/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Bluetooth_Platformservice.h
   Author             : Arjun
   Version            : V0.0.0.1
   Origination Date   : 25/02/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the BLE platform service declarations

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             25/02/2022			Arjun

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _BLE_PLATFORM_SERVICE_H_
#define	_BLE_PLATFORM_SERVICE_H_

/*!
 * BLE TxQ and RxQ size.
 */
#define BLE_RX_TX_MAX_Q_SIZE       	10

/*!
 * BLE Timeout value
 */
#define PS_BLE_TIMEOUT				1000

/* Thread State */
#define BLE_THREAD_STATE_RUN   		0
#define BLE_THREAD_STATE_STOP  		1

/*!
 * Maximum packet size
 */
#define MAX_BLE_RX_LEN           	255
#define MAX_BLE_TX_LEN              64

/*!
 * Status of the RX buffer
 */
#define BLE_RX_MSG_PENDING          1
#define BLE_RX_MSF_EMPTY            2

/* !
 * BLE SDK Field Index
 */
#define BLE_FUNC_INDEX				0
#define BLE_RESULT_INDEX 			0
#define BLE_DATA_INDEX              1
#define BLE_LEN_INDEX	            2

/*!
 *  BLE Buffer status
 */
#define BLE_TX_BUFF_FULL            1
#define BLE_TX_BUFF_NOTFULL         2

/*!
 * BLE Events
 */
typedef enum __BLE_Event
{
	BLE_WKUP_EVENT,
	BLE_RX_EVENT,
	BLE_MSG_EVENT,
	BLE_CAM_STOP_EVENT,
	BLE_CAM_START_EVENT
}BLE_Event;

/*!
 * BLE SDK Message
 */
typedef enum __BLE_MSG
{
	BLE_GET,
	BLE_SET,
}BLE_MSG;

/*!
 * BLE buffer status
 */
typedef enum __BLE_BUF_STATUS
{
	BLE_BUFF_FULL,
	BLE_BUFF_EMPTY,
}BLE_BUF_STATUS;

/*!
 * BLE Communication status
 */
typedef enum __BLE_COMM_STATUS
{
	BLE_COMM_OK,
	BLE_COMM_ERROR,
}BLE_COMM_STATUS;

/*!
 *	Function Declaration
 **/
int8_t BLE_DB_Init(void);
void HAL_GPIO_EXTI_BLE_Callback();

#endif	//_BLE_PLATFORM_SERVICE_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
