/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Lcd_platformservice.h
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 11/02/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the LCD platform service decelerations

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             11/02/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _LCD_PLATFORM_SERVICE_H_
#define	_LCD_PLATFORM_SERVICE_H_


/*!
 * Lcd SDK Message
 */
typedef enum __Lcd_Event
{
	LCD_MSG_EVENT,
}Lcd_Event;

/*!
 * LCD SDK Message
 */
typedef enum __LCD_MSG
{
	SET_LCD,
	GET_LCD,
}LCD_MSG;

/*!
 * LCD Input Function
 */
typedef enum __LCD_Func
{
	SET_LCD_STATE,
	SET_LCD_BRIGHTNESS,
}LCD_Func;

/*!
 * LCD Platform Service configuration
 */
#define LCD_RX_TX_MAX_Q_SIZE		10

/*!
 * LCD index
 */
#define LCD_FUNC_INDEX	    		0
#define LCD_RESULT_INDEX    		0
#define LCD_SUB_FUNC_INDEX			1
#define LCD_STATE_INDEX	    		2
#define LCD_BRIGHTNESS_INDEX   		2

/*!
 * LCD state
 */
#define LCD_CONF_ON					1
#define LCD_CONF_OFF				0

/*!
 * LCD Brightness values
 */
#define MIN_LCD_BRIGHTNESS			0
#define MAX_LCD_BRIGHTNESS			100

/*!
 * LCD Enable GPIO pin
 */
#define LCD_ENABLE_PIN			    GPIO_PIN_3
#define LCD_ENABLE_PORT				GPIOE

/*!
 * LCD Resolution
 */
#define LCD_RESOlUTION_X0           480
#define LCD_RESOlUTION_Y0           272

#define CAMERA_RESOlUTION_X0        600
#define CAMERA_RESOlUTION_Y0        236

/*!
 * Function declaration
 */
int8_t Lcd_DB_Init(void);

#endif	//_LCD_PLATFORM_SERVICE_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
