/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DL_u8_Validation.c
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Data Layer unsigned 8 bits field validation function

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../Maximatecc/Inc/Data_Layer.h"
#include "../Inc/Common.h"
#include "../Inc/Dl_U8_Validation.h"
#include "../../Maximatecc/inc/camera.h"
/* USER CODE END Includes */

/* USER CODE BEGIN Global Variables */
/* USER CODE END Includes */
extern int8_t   dl_buf     [((END_BUF512BIT -1)  - START_BUF512BIT) * DB_512BIT_NO_BUF * BUF512BITSIZE];

int8_t (*dl_u8_func   [(END_U8BIT    -1)    - START_U8BIT   ])(uint16_t, uint8_t);

extern pvt_variable pv;
/* USER CODE END Global Variables */

/** @brief DB Validation function
 *
 *  This function initialize the DB Validation function for the each
 *  unsinged 8 bits field.
 *
 *  @param  None
 *
 *  @return None
 *
 */
void DB_u8_Field_Validation_Reg(void)
{
	/* Clear the Callback memory */
	memset (&dl_u8_func[0], 0x00, ((END_U8BIT    -1) - START_U8BIT));

#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

#if (CONF_WARNING_LIGHT_01_ENABLE == PS_ENABLE)
    /* WARNING_LIGHT_01_STATE Validation */
	dl_u8_func[WARNING_LIGHT_01_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_01_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_01_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_01_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_01_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_01_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_01_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_02_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_02_STATE Validation */
	dl_u8_func[WARNING_LIGHT_02_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_02_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_02_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_02_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_02_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_02_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_02_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_03_ENABLE == PS_ENABLE)
	/* WARNING_LIGHT_03_STATE Validation */
	dl_u8_func[WARNING_LIGHT_03_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_03_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_03_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_03_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_03_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_03_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_03_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_04_ENABLE == PS_ENABLE)
	/* WARNING_LIGHT_04_STATE Validation */
	dl_u8_func[WARNING_LIGHT_04_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_04_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_04_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_04_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_04_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_04_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_04_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_05_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_05_STATE Validation */
	dl_u8_func[WARNING_LIGHT_05_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_05_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_05_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_05_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_05_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_05_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_05_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_06_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_06_STATE Validation */
	dl_u8_func[WARNING_LIGHT_06_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_06_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_06_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_06_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_06_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_06_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_06_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_07_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_07_STATE Validation */
	dl_u8_func[WARNING_LIGHT_07_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_07_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_07_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_07_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_07_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_07_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_07_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_08_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_08_STATE Validation */
	dl_u8_func[WARNING_LIGHT_08_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_08_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_08_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_08_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_08_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_08_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_08_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_09_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_09_STATE Validation */
	dl_u8_func[WARNING_LIGHT_09_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_09_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_09_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_09_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_09_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_09_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_09_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_10_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_10_STATE Validation */
	dl_u8_func[WARNING_LIGHT_10_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_10_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_10_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_10_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_10_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_10_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_10_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_11_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_11_STATE Validation */
	dl_u8_func[WARNING_LIGHT_11_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_11_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_11_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_11_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_11_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_11_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_11_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_12_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_12_STATE Validation */
	dl_u8_func[WARNING_LIGHT_12_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_12_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_12_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_12_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_12_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_12_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_12_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_13_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_13_STATE Validation */
	dl_u8_func[WARNING_LIGHT_13_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_13_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_13_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_13_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_13_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_13_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_13_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_14_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_14_STATE Validation */
	dl_u8_func[WARNING_LIGHT_14_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_14_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_14_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_14_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_14_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_14_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_14_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_15_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_15_STATE Validation */
	dl_u8_func[WARNING_LIGHT_15_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_15_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_15_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_15_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_15_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_15_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_15_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_WARNING_LIGHT_16_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_16_STATE Validation */
	dl_u8_func[WARNING_LIGHT_16_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_16_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_16_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else

	/* WARNING_LIGHT_16_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_16_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_16_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_16_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_17_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_17_STATE Validation */
	dl_u8_func[WARNING_LIGHT_17_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_17_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_17_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_17_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_17_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_17_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_17_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_18_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_18_STATE Validation */
	dl_u8_func[WARNING_LIGHT_18_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_18_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_18_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_18_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_18_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_18_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_18_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_19_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_19_STATE Validation */
	dl_u8_func[WARNING_LIGHT_19_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_19_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_19_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_19_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_19_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_19_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_19_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif

#if (CONF_WARNING_LIGHT_20_ENABLE == PS_ENABLE)

	/* WARNING_LIGHT_20_STATE Validation */
	dl_u8_func[WARNING_LIGHT_20_STATE - (START_U8BIT + 1)] = validate_wl_state;

	/* WARNING_LIGHT_20_PWM_DC Validation */
	dl_u8_func[WARNING_LIGHT_20_PWM_DC - (START_U8BIT + 1)] = validate_wl_pwm;
#else
    /* WARNING_LIGHT_20_STATE_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_20_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNING_LIGHT_20_PWM_DC_DUMMY Validation */
	dl_u8_func[WARNING_LIGHT_20_PWM_DC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#endif

#if (SDK_SERVICE_KEYPAD == PS_ENABLE)

	/* KEYPAD_BACKLIGHT Validation */
	dl_u8_func[KEYPAD_BACKLIGHT - (START_U8BIT + 1)] = validate_keypad_backlight;

#if (CONF_KEYPAD_01_STATE == PS_ENABLE)
	/* KEYPAD_STATUS_01 Validation */
	dl_u8_func[KEY_STATUS_01 - (START_U8BIT + 1)] = validate_keypad_status;

	/* KEY_PRESS_01 Validation */
	dl_u8_func[KEY_PRESS_01 - (START_U8BIT + 1)] = validate_keypad_press;
#else
	/* KEY_STATUS_01_DUMMY Validation */
	dl_u8_func[KEY_STATUS_01_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* KEY_PRESS_01_DUMMY Validation */
	dl_u8_func[KEY_PRESS_01_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif


#if (CONF_KEYPAD_02_STATE == PS_ENABLE)
	/* KEYPAD_STATUS_02 Validation */
	dl_u8_func[KEY_STATUS_02 - (START_U8BIT + 1)] = validate_keypad_status;

	/* KEY_PRESS_02 Validation */
	dl_u8_func[KEY_PRESS_02 - (START_U8BIT + 1)] = validate_keypad_press;
#else
	/* KEY_STATUS_02_DUMMY Validation */
	dl_u8_func[KEY_STATUS_02_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* KEY_PRESS_02_DUMMY Validation */
	dl_u8_func[KEY_PRESS_02_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif


#if (CONF_KEYPAD_03_STATE == PS_ENABLE)
	/* KEYPAD_STATUS_03 Validation */
	dl_u8_func[KEY_STATUS_03 - (START_U8BIT + 1)] = validate_keypad_status;

	/* KEY_PRESS_03 Validation */
	dl_u8_func[KEY_PRESS_03 - (START_U8BIT + 1)] = validate_keypad_press;
#else
	/* KEY_STATUS_03_DUMMY Validation */
	dl_u8_func[KEY_STATUS_03_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* KEY_PRESS_03_DUMMY Validation */
	dl_u8_func[KEY_PRESS_03_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif


#if (CONF_KEYPAD_04_STATE == PS_ENABLE)
	/* KEYPAD_STATUS_04 Validation */
	dl_u8_func[KEY_STATUS_04 - (START_U8BIT + 1)] = validate_keypad_status;

	/* KEY_PRESS_04 Validation */
	dl_u8_func[KEY_PRESS_04 - (START_U8BIT + 1)] = validate_keypad_press;
#else
	/* KEY_STATUS_04_DUMMY Validation */
	dl_u8_func[KEY_STATUS_04_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* KEY_PRESS_04_DUMMY Validation */
	dl_u8_func[KEY_PRESS_04_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#endif	//SDK_SERVICE_KEYPAD

#if (SDK_SERVICE_RTC == PS_ENABLE)

	/* RTC_SECOND Validation */
	dl_u8_func[RTC_SECOND - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_MINUTE Validation */
	dl_u8_func[RTC_MINUTE - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_HOUR Validation */
	dl_u8_func[RTC_HOUR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_DAY Validation */
	dl_u8_func[RTC_DATE - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_WEEK_DAY Validation */
	dl_u8_func[RTC_WEEK_DAY - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_MONTH Validation */
	dl_u8_func[RTC_MONTH - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_YEAR Validation */
	dl_u8_func[RTC_YEAR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_TIME_FORMAT Validation */
	dl_u8_func[RTC_TIME_FORMAT - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_SECOND Validation */
	dl_u8_func[RTC_ALARM_A_SECOND - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_MINUTE Validation */
	dl_u8_func[RTC_ALARM_A_MINUTE - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_HOUR Validation */
	dl_u8_func[RTC_ALARM_A_HOUR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_DAY Validation */
	dl_u8_func[RTC_ALARM_A_DAY - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_WEEK_DAY Validation */
	dl_u8_func[RTC_ALARM_A_WEEK_DAY - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_MONTH Validation */
	dl_u8_func[RTC_ALARM_A_MONTH - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_YEAR Validation */
	dl_u8_func[RTC_ALARM_A_YEAR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_A_TIME_FORMAT Validation */
	dl_u8_func[RTC_ALARM_A_TIME_FORMAT - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_SECOND Validation */
	dl_u8_func[RTC_ALARM_B_SECOND - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_MINUTE Validation */
	dl_u8_func[RTC_ALARM_B_MINUTE - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_HOUR Validation */
	dl_u8_func[RTC_ALARM_B_HOUR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_DAY Validation */
	dl_u8_func[RTC_ALARM_B_DAY - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_WEEK_DAY Validation */
	dl_u8_func[RTC_ALARM_B_WEEK_DAY - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_MONTH Validation */
	dl_u8_func[RTC_ALARM_B_MONTH - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_YEAR Validation */
	dl_u8_func[RTC_ALARM_B_YEAR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* RTC_ALARM_B_TIME_FORMAT Validation */
	dl_u8_func[RTC_ALARM_B_TIME_FORMAT - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* SET_RTC Validation */
	dl_u8_func[SET_RTC - (START_U8BIT + 1)] = validate_and_SET_RTC_parameter;

	/* SET_ALARM_A Validation */
	dl_u8_func[SET_ALARM_A - (START_U8BIT + 1)] = validate_and_SET_RTC_parameter;

	/* ALARM_A_STATUS Validation */
	dl_u8_func[ALARM_A_STATUS - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* SET_ALARM_B Validation */
	dl_u8_func[SET_ALARM_B - (START_U8BIT + 1)] = validate_and_SET_RTC_parameter;

	/* ALARM_B_STATUS Validation */
	dl_u8_func[ALARM_B_STATUS - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_SECOND Validation */
	dl_u8_func[GET_RTC_SECOND - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_MINUTE Validation */
	dl_u8_func[GET_RTC_MINUTE - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_HOUR Validation */
	dl_u8_func[GET_RTC_HOUR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_DAY Validation */
	dl_u8_func[GET_RTC_DATE - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_WEEK_DAY Validation */
	dl_u8_func[GET_RTC_WEEK_DAY - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_MONTH Validation */
	dl_u8_func[GET_RTC_MONTH - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_YEAR Validation */
	dl_u8_func[GET_RTC_YEAR - (START_U8BIT + 1)] = validate_RTC_parameter;

	/* GET_RTC_TIME_FORMAT Validation */
	dl_u8_func[GET_RTC_TIME_FORMAT - (START_U8BIT + 1)] = validate_RTC_parameter;

#else

	/* RTC_SECOND_DUMMY Validation */
	dl_u8_func[RTC_SECOND_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_MINUTE_DUMMY Validation */
	dl_u8_func[RTC_MINUTE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_HOUR_DUMMY Validation */
	dl_u8_func[RTC_HOUR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_DAY_DUMMY Validation */
	dl_u8_func[RTC_DATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_WEEK_DAY_DUMMY Validation */
	dl_u8_func[RTC_WEEK_DAY_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_MONTH_DUMMY Validation */
	dl_u8_func[RTC_MONTH_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_YEAR_DUMMY Validation */
	dl_u8_func[RTC_YEAR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_TIME_FORMAT_DUMMY Validation */
	dl_u8_func[RTC_TIME_FORMAT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_SECOND_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_SECOND_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_MINUTE_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_MINUTE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_HOUR_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_HOUR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_DAY_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_DAY_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_WEEK_DAY_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_WEEK_DAY_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_MONTH_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_MONTH_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_YEAR_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_YEAR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_A_TIME_FORMAT_DUMMY Validation */
	dl_u8_func[RTC_ALARM_A_TIME_FORMAT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_SECOND_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_SECOND_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_MINUTE_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_MINUTE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_HOUR_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_HOUR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_DAY_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_DAY_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_WEEK_DAY_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_WEEK_DAY_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_MONTH_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_MONTH_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_YEAR_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_YEAR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_ALARM_B_TIME_FORMAT_DUMMY Validation */
	dl_u8_func[RTC_ALARM_B_TIME_FORMAT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* SET_RTC_DUMMY Validation */
	dl_u8_func[SET_RTC_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* SET_ALARM_A_DUMMY Validation */
	dl_u8_func[SET_ALARM_A_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* ALARM_A_STATUS_DUMMY Validation */
	dl_u8_func[ALARM_A_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* SET_ALARM_B_DUMMY Validation */
	dl_u8_func[SET_ALARM_B_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* ALARM_B_STATUS_DUMMY Validation */
	dl_u8_func[ALARM_B_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_SECOND_DUMMY Validation */
	dl_u8_func[GET_RTC_SECOND_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_MINUTE_DUMMY Validation */
	dl_u8_func[GET_RTC_MINUTE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_HOUR_DUMMY Validation */
	dl_u8_func[GET_RTC_HOUR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_DAY_DUMMY Validation */
	dl_u8_func[GET_RTC_DATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_WEEK_DAY_DUMMY Validation */
	dl_u8_func[GET_RTC_WEEK_DAY_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_MONTH_DUMMY Validation */
	dl_u8_func[GET_RTC_MONTH_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_YEAR_DUMMY Validation */
	dl_u8_func[GET_RTC_YEAR_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* GET_RTC_TIME_FORMAT_DUMMY Validation */
	dl_u8_func[GET_RTC_TIME_FORMAT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_RTC

#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)

	/* DIGITAL_OUTPUT_01_STATE Validation */
	dl_u8_func[DIGITAL_OUTPUT_01_STATE - (START_U8BIT + 1)] = validate_DIO_state;

	/* DIGITAL_OUTPUT_01_CFG Validation */
	dl_u8_func[DIGITAL_OUTPUT_01_CFG - (START_U8BIT + 1)] = validate_DIO_CFG_parameter;

#else

	/* DIGITAL_OUTPUT_01_STATE_DUMMY Validation */
	dl_u8_func[DIGITAL_OUTPUT_01_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* DIGITAL_OUTPUT_01_CFG_DUMMY Validation */
	dl_u8_func[DIGITAL_OUTPUT_01_CFG_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_DIGITAL_OUTPUT

#if (SDK_SERVICE_LIGHT_SENSOR == PS_ENABLE)

	/* LIGHT_SENSOR_CONVERSION_TIME Validation */
	dl_u8_func[LIGHT_SENSOR_CONVERSION_TIME - (START_U8BIT + 1)] = validate_LTS_conversion_time;

	/* LIGHT_SENSOR_CONVERSION_MODE Validation */
	dl_u8_func[LIGHT_SENSOR_CONVERSION_MODE - (START_U8BIT + 1)] = validate_LTS_conversion_mode;

	/* LIGHT_SENSOR_TRIGGER Validation */
	dl_u8_func[LIGHT_SENSOR_TRIGGER - (START_U8BIT + 1)] = validate_LTS_trigger;

#else

	/* LIGHT_SENSOR_CONVERSION_TIME_DUMMY Validation */
	dl_u8_func[LIGHT_SENSOR_CONVERSION_TIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* LIGHT_SENSOR_CONVERSION_MODE_DUMMY Validation */
	dl_u8_func[LIGHT_SENSOR_CONVERSION_MODE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* LIGHT_SENSOR_TRIGGER_DUMMY Validation */
	dl_u8_func[LIGHT_SENSOR_TRIGGER_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_LIGHT_SENSOR

#if (SDK_SERVICE_WATCHDOG == PS_ENABLE)

#if (USER_TASK_WD0 == PS_ENABLE)
	/* WD0_PING Validation */
	dl_u8_func[WD0_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD0_PING_DUMMY Validation */
	dl_u8_func[WD0_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD0

#if (USER_TASK_WD1 == PS_ENABLE)
	/* WD1_PING Validation */
	dl_u8_func[WD1_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD1_PING_DUMMY Validation */
	dl_u8_func[WD1_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD1

#if (USER_TASK_WD2 == PS_ENABLE)
	/* WD2_PING Validation */
	dl_u8_func[WD2_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD2_PING_DUMMY Validation */
	dl_u8_func[WD2_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD2

#if (USER_TASK_WD3 == PS_ENABLE)
	/* WD3_PING Validation */
	dl_u8_func[WD3_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD3_PING_DUMMY Validation */
	dl_u8_func[WD3_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD3

#if (USER_TASK_WD4 == PS_ENABLE)
	/* WD4_PING Validation */
	dl_u8_func[WD4_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD4_PING_DUMMY Validation */
	dl_u8_func[WD4_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD4

#if (USER_TASK_WD5 == PS_ENABLE)
	/* WD5_PING Validation */
	dl_u8_func[WD5_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD5_PING_DUMMY Validation */
	dl_u8_func[WD5_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD5

#if (USER_TASK_WD6 == PS_ENABLE)
	/* WD6_PING Validation */
	dl_u8_func[WD6_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD6_PING_DUMMY Validation */
	dl_u8_func[WD6_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD6

#if (USER_TASK_WD7 == PS_ENABLE)
	/* WD7_PING Validation */
	dl_u8_func[WD7_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD7_PING_DUMMY Validation */
	dl_u8_func[WD7_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD7

#if (USER_TASK_WD8 == PS_ENABLE)
	/* WD8_PING Validation */
	dl_u8_func[WD8_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD8_PING_DUMMY Validation */
	dl_u8_func[WD8_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD8

#if (USER_TASK_WD9 == PS_ENABLE)
	/* WD9_PING Validation */
	dl_u8_func[WD9_PING - (START_U8BIT + 1)] = validate_WD_feed_id;

#else
	/* WD9_PING_DUMMY Validation */
	dl_u8_func[WD9_PING_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//USER_TASK_WD9

#endif	//SDK_SERVICE_WATCHDOG

#if (SDK_SERVICE_LED == PS_ENABLE)

#if (CONF_RED_LED_PS_STATE == PS_ENABLE)
	/* LED_RED_STATE Validation */
	dl_u8_func[LED_RED_STATE - (START_U8BIT + 1)] = validate_led_state;
#else
	/* LED_RED_STATE_DUMMY Validation */
	dl_u8_func[LED_RED_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (CONF_AMB_LED_PS_STATE == PS_ENABLE)
	/* LED_AMB_STATE Validation */
	dl_u8_func[LED_AMB_STATE - (START_U8BIT + 1)] = validate_led_state;
#else
	/* LED_AMB_STATE_DUMMY Validation */
	dl_u8_func[LED_AMB_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#endif	//SDK_SERVICE_LED

#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)

	/* CFG_INPUT_01_DIGITAL_STG Validation */
	dl_u8_func[CFG_INPUT_01_DIGITAL_STG - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_01_DIGITAL_STB Validation */
	dl_u8_func[CFG_INPUT_01_DIGITAL_STB - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_01_TYPE Validation */
	dl_u8_func[CFG_INPUT_01_TYPE - (START_U8BIT + 1)] = validate_cfg_type;

	/* CFG_INPUT_01_NUMB_SAMPLES Validation */
	dl_u8_func[CFG_INPUT_01_NUMB_SAMPLES - (START_U8BIT + 1)] = validate_num_of_samples;

	/* CFG_INPUT_02_DIGITAL_STG Validation */
	dl_u8_func[CFG_INPUT_02_DIGITAL_STG - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_02_DIGITAL_STB Validation */
	dl_u8_func[CFG_INPUT_02_DIGITAL_STB - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_02_TYPE Validation */
	dl_u8_func[CFG_INPUT_02_TYPE - (START_U8BIT + 1)] = validate_cfg_type;

	/* CFG_INPUT_02_NUMB_SAMPLES Validation */
	dl_u8_func[CFG_INPUT_02_NUMB_SAMPLES - (START_U8BIT + 1)] = validate_num_of_samples;

	/* CFG_INPUT_03_DIGITAL_STG Validation */
	dl_u8_func[CFG_INPUT_03_DIGITAL_STG - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_03_DIGITAL_STB Validation */
	dl_u8_func[CFG_INPUT_03_DIGITAL_STB - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_03_TYPE Validation */
	dl_u8_func[CFG_INPUT_03_TYPE - (START_U8BIT + 1)] = validate_cfg_type;

	/* CFG_INPUT_03_NUMB_SAMPLES Validation */
	dl_u8_func[CFG_INPUT_03_NUMB_SAMPLES - (START_U8BIT + 1)] = validate_num_of_samples;

	/* CFG_INPUT_04_DIGITAL_STG Validation */
	dl_u8_func[CFG_INPUT_04_DIGITAL_STG - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_04_DIGITAL_STB Validation */
	dl_u8_func[CFG_INPUT_04_DIGITAL_STB - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_04_TYPE Validation */
	dl_u8_func[CFG_INPUT_04_TYPE - (START_U8BIT + 1)] = validate_cfg_type;

	/* CFG_INPUT_04_NUMB_SAMPLES Validation */
	dl_u8_func[CFG_INPUT_04_NUMB_SAMPLES - (START_U8BIT + 1)] = validate_num_of_samples;

	/* CFG_INPUT_05_DIGITAL_STG Validation */
	dl_u8_func[CFG_INPUT_05_DIGITAL_STG - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_05_DIGITAL_STB Validation */
	dl_u8_func[CFG_INPUT_05_DIGITAL_STB - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_05_TYPE Validation */
	dl_u8_func[CFG_INPUT_05_TYPE - (START_U8BIT + 1)] = validate_cfg_type;

	/* CFG_INPUT_05_NUMB_SAMPLES Validation */
	dl_u8_func[CFG_INPUT_05_NUMB_SAMPLES - (START_U8BIT + 1)] = validate_num_of_samples;

	/* CFG_INPUT_06_DIGITAL_STG Validation */
	dl_u8_func[CFG_INPUT_06_DIGITAL_STG - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_06_DIGITAL_STB Validation */
	dl_u8_func[CFG_INPUT_06_DIGITAL_STB - (START_U8BIT + 1)] = validate_digital_input;

	/* CFG_INPUT_06_TYPE Validation */
	dl_u8_func[CFG_INPUT_06_TYPE - (START_U8BIT + 1)] = validate_cfg_type;

	/* CFG_INPUT_06_NUMB_SAMPLES Validation */
	dl_u8_func[CFG_INPUT_06_NUMB_SAMPLES - (START_U8BIT + 1)] = validate_num_of_samples;

#else

	/* CFG_INPUT_01_DIGITAL_STG_DUMMY Validation */
	dl_u8_func[CFG_INPUT_01_DIGITAL_STG_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_01_DIGITAL_STB_DUMMY Validation */
	dl_u8_func[CFG_INPUT_01_DIGITAL_STB_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_01_TYPE_DUMMY Validation */
	dl_u8_func[CFG_INPUT_01_TYPE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_01_NUMB_SAMPLES_DUMMY Validation */
	dl_u8_func[CFG_INPUT_01_NUMB_SAMPLES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_02_DIGITAL_STG_DUMMY Validation */
	dl_u8_func[CFG_INPUT_02_DIGITAL_STG_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_02_DIGITAL_STB_DUMMY Validation */
	dl_u8_func[CFG_INPUT_02_DIGITAL_STB_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_02_TYPE_DUMMY Validation */
	dl_u8_func[CFG_INPUT_02_TYPE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_02_NUMB_SAMPLES_DUMMY Validation */
	dl_u8_func[CFG_INPUT_02_NUMB_SAMPLES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_03_DIGITAL_STG_DUMMY Validation */
	dl_u8_func[CFG_INPUT_03_DIGITAL_STG_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_03_DIGITAL_STB_DUMMY Validation */
	dl_u8_func[CFG_INPUT_03_DIGITAL_STB_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_03_TYPE Validation_DUMMY */
	dl_u8_func[CFG_INPUT_03_TYPE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_03_NUMB_SAMPLES_DUMMY Validation */
	dl_u8_func[CFG_INPUT_03_NUMB_SAMPLES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_04_DIGITAL_STG_DUMMY Validation */
	dl_u8_func[CFG_INPUT_04_DIGITAL_STG_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_04_DIGITAL_STB_DUMMY Validation */
	dl_u8_func[CFG_INPUT_04_DIGITAL_STB_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_04_TYPE_DUMMY Validation */
	dl_u8_func[CFG_INPUT_04_TYPE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_04_NUMB_SAMPLES_DUMMY Validation */
	dl_u8_func[CFG_INPUT_04_NUMB_SAMPLES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_05_DIGITAL_STG_DUMMY Validation */
	dl_u8_func[CFG_INPUT_05_DIGITAL_STG_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_05_DIGITAL_STB_DUMMY Validation */
	dl_u8_func[CFG_INPUT_05_DIGITAL_STB_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_05_TYPE_DUMMY Validation */
	dl_u8_func[CFG_INPUT_05_TYPE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_05_NUMB_SAMPLES_DUMMY Validation */
	dl_u8_func[CFG_INPUT_05_NUMB_SAMPLES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_06_DIGITAL_STG_DUMMY Validation */
	dl_u8_func[CFG_INPUT_06_DIGITAL_STG_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_06_DIGITAL_STB_DUMMY Validation */
	dl_u8_func[CFG_INPUT_06_DIGITAL_STB_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_06_TYPE_DUMMY Validation */
	dl_u8_func[CFG_INPUT_06_TYPE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CFG_INPUT_06_NUMB_SAMPLES_DUMMY Validation */
	dl_u8_func[CFG_INPUT_06_NUMB_SAMPLES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif	//SDK_SERVICE_CFG_INPUT

#if (SDK_SERVICE_LCD == PS_ENABLE)

	/* LCD_STATE Validation */
	dl_u8_func[LCD_STATE - (START_U8BIT + 1)] = validate_lcd_state;

	/* LCD_BRIGHTNESS Validation */
	dl_u8_func[LCD_BRIGHTNESS - (START_U8BIT + 1)] = validate_lcd_brightness;

#else

	/* LCD_STATE_DUMMY Validation */
	dl_u8_func[LCD_STATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* LCD_BRIGHTNESS_DUMMY Validation */
	dl_u8_func[LCD_BRIGHTNESS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_LCD

#if (SDK_SERVICE_PM == PS_ENABLE)

#if (KEYPAD01_WAKEUP_SOURCE == PS_ENABLE)
	/* KEYPAD_01_WAKEUP Validation */
	dl_u8_func[KEYPAD_01_WAKEUP - (START_U8BIT + 1)] = validate_keypad_wakeup_state;
#else
	/* KEYPAD_01_DUMMY_WAKEUP Validation */
	dl_u8_func[KEYPAD01_DUMMY_WAKEUP - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (KEYPAD02_WAKEUP_SOURCE == PS_ENABLE)
	/* KEYPAD_02_WAKEUP Validation */
	dl_u8_func[KEYPAD_02_WAKEUP - (START_U8BIT + 1)] = validate_keypad_wakeup_state;
#else
	/* KEYPAD_02_DUMMY_WAKEUP Validation */
	dl_u8_func[KEYPAD02_DUMMY_WAKEUP - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (KEYPAD03_WAKEUP_SOURCE == PS_ENABLE)
	/* KEYPAD_03_WAKEUP Validation */
	dl_u8_func[KEYPAD_03_WAKEUP - (START_U8BIT + 1)] = validate_keypad_wakeup_state;
#else
	/* KEYPAD_03_DUMMY_WAKEUP Validation */
	dl_u8_func[KEYPAD03_DUMMY_WAKEUP - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (KEYPAD04_WAKEUP_SOURCE == PS_ENABLE)
	/* KEYPAD_04_WAKEUP Validation */
	dl_u8_func[KEYPAD_04_WAKEUP - (START_U8BIT + 1)] = validate_keypad_wakeup_state;
#else
	/* KEYPAD_04_DUMMY_WAKEUP Validation */
	dl_u8_func[KEYPAD04_DUMMY_WAKEUP - (START_U8BIT + 1)] = validate_dummy_field;
#endif

#if (RTC_WAKEUP_SOURCE_STATE == PS_ENABLE)
	/* RTC_WAKEUP Validation */
	dl_u8_func[RTC_WAKEUP - (START_U8BIT + 1)] = validate_rtc_wakeup_state;

#else
	/* DUMMY_WAKEUP Validation */
	dl_u8_func[RTC_DUMMY_WAKEUP - (START_U8BIT + 1)] = validate_dummy_field;

#endif

	/* POWER_MODE Validation */
	dl_u8_func[POWER_MODE - (START_U8BIT + 1)] = validate_power_mode;

#endif	//SDK_SERVICE_PM

#if (SDK_SERVICE_POWER_MONITOR == PS_ENABLE)

	/* IGNITION_STATUS Validation */
	dl_u8_func[IGNITION_STATUS - (START_U8BIT + 1)] = validate_IGN_state;

#else

	/* IGNITION_STATUS_DUMMY Validation */
	dl_u8_func[IGNITION_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_POWER_MONITOR

#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	/* TIMER_STATUS_01 Validation */
	dl_u8_func[TIMER_STATUS_01 - (START_U8BIT + 1)] = validate_timer_status;

	/* TIMER_MODE_01 Validation */
	dl_u8_func[TIMER_MODE_01 - (START_U8BIT + 1)] = validate_timer_mode;

	/* TIMER_STATUS_02 Validation */
	dl_u8_func[TIMER_STATUS_02 - (START_U8BIT + 1)] = validate_timer_status;

	/* TIMER_MODE_02 Validation */
	dl_u8_func[TIMER_MODE_02 - (START_U8BIT + 1)] = validate_timer_mode;

	/* TIMER_STATUS_03 Validation */
	dl_u8_func[TIMER_STATUS_03 - (START_U8BIT + 1)] = validate_timer_status;

	/* TIMER_MODE_03 Validation */
	dl_u8_func[TIMER_MODE_03 - (START_U8BIT + 1)] = validate_timer_mode;

	/* TIMER_STATUS_04 Validation */
	dl_u8_func[TIMER_STATUS_04 - (START_U8BIT + 1)] = validate_timer_status;

	/* TIMER_MODE_04 Validation */
	dl_u8_func[TIMER_MODE_04 - (START_U8BIT + 1)] = validate_timer_mode;

	/* TIMER_STATUS_05 Validation */
	dl_u8_func[TIMER_STATUS_05 - (START_U8BIT + 1)] = validate_timer_status;

	/* TIMER_MODE_05 Validation */
	dl_u8_func[TIMER_MODE_05 - (START_U8BIT + 1)] = validate_timer_mode;

	/* TIMER_STATUS_06 Validation */
	dl_u8_func[TIMER_STATUS_06 - (START_U8BIT + 1)] = validate_timer_status;

	/* TIMER_MODE_06 Validation */
	dl_u8_func[TIMER_MODE_06 - (START_U8BIT + 1)] = validate_timer_mode;

	/* TIMER_CALLBACK_01 Validation */
	dl_u8_func[TIMER_CALLBACK_01 - (START_U8BIT + 1)] = validate_timer_callback;

	/* TIMER_CALLBACK_02 Validation */
	dl_u8_func[TIMER_CALLBACK_02 - (START_U8BIT + 1)] = validate_timer_callback;

	/* TIMER_CALLBACK_03 Validation */
	dl_u8_func[TIMER_CALLBACK_03 - (START_U8BIT + 1)] = validate_timer_callback;

	/* TIMER_CALLBACK_04 Validation */
	dl_u8_func[TIMER_CALLBACK_04 - (START_U8BIT + 1)] = validate_timer_callback;

	/* TIMER_CALLBACK_05 Validation */
	dl_u8_func[TIMER_CALLBACK_05 - (START_U8BIT + 1)] = validate_timer_callback;

	/* TIMER_CALLBACK_06 Validation */
	dl_u8_func[TIMER_CALLBACK_06 - (START_U8BIT + 1)] = validate_timer_callback;

#else

	/* TIMER_STATUS_01_DUMMY Validation */
	dl_u8_func[TIMER_STATUS_01_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_MODE_01_DUMMY Validation */
	dl_u8_func[TIMER_MODE_01_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_STATUS_02_DUMMY Validation */
	dl_u8_func[TIMER_STATUS_02_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_MODE_02_DUMMY Validation */
	dl_u8_func[TIMER_MODE_02_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_STATUS_03_DUMMY Validation */
	dl_u8_func[TIMER_STATUS_03_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_MODE_03_DUMMY Validation */
	dl_u8_func[TIMER_MODE_03_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_STATUS_04_DUMMY Validation */
	dl_u8_func[TIMER_STATUS_04_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_MODE_04_DUMMY Validation */
	dl_u8_func[TIMER_MODE_04_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_STATUS_05_DUMMY Validation */
	dl_u8_func[TIMER_STATUS_05_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_MODE_05_DUMMY Validation */
	dl_u8_func[TIMER_MODE_05_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_STATUS_06_DUMMY Validation */
	dl_u8_func[TIMER_STATUS_06_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_MODE_06_DUMMY Validation */
	dl_u8_func[TIMER_MODE_06_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_CALLBACK_01_DUMMY Validation */
	dl_u8_func[TIMER_CALLBACK_01_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_CALLBACK_02_DUMMY Validation */
	dl_u8_func[TIMER_CALLBACK_02_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_CALLBACK_03_DUMMY Validation */
	dl_u8_func[TIMER_CALLBACK_03_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_CALLBACK_04_DUMMY Validation */
	dl_u8_func[TIMER_CALLBACK_04_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_CALLBACK_05_DUMMY Validation */
	dl_u8_func[TIMER_CALLBACK_05_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TIMER_CALLBACK_06_DUMMY Validation */
	dl_u8_func[TIMER_CALLBACK_06_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_SWTIMER

#if (SDK_SERVICE_BLE == PS_ENABLE)

	/* BLE_TX_STATUS Validation */
	dl_u8_func[BLE_TX_STATUS - (START_U8BIT + 1)] = validate_ble_tx_status;

	/* BLE_TX_BUFFER_STATUS Validation */
	dl_u8_func[BLE_TX_BUFFER_STATUS - (START_U8BIT + 1)] = validate_ble_buffer_status;

	/* BLE_RX_STATUS Validation */
	dl_u8_func[BLE_RX_STATUS - (START_U8BIT + 1)] = validate_ble_rx_status;

	/* BLE_RX_BUFFER_STATUS Validation */
	dl_u8_func[BLE_RX_BUFFER_STATUS - (START_U8BIT + 1)] = validate_ble_buffer_status;

	/* BLE_COMMUNICATION_STATUS Validation */
	dl_u8_func[BLE_COMMUNICATION_STATUS - (START_U8BIT + 1)] = validate_ble_communication_status;

#else

	/* BLE_TX_STATUS_DUMMY Validation */
	dl_u8_func[BLE_TX_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* BLE_TX_BUFFER_STATUS_DUMMY Validation */
	dl_u8_func[BLE_TX_BUFFER_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* BLE_RX_STATUS_DUMMY Validation */
	dl_u8_func[BLE_RX_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* BLE_RX_BUFFER_STATUS_DUMMY Validation */
	dl_u8_func[BLE_RX_BUFFER_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* BLE_COMMUNICATION_STATUS_DUMMY Validation */
	dl_u8_func[BLE_COMMUNICATION_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_BLE

#if (SDK_SERVICE_USB == PS_ENABLE)

	/* USB_COMMUNICATION_STATUS Validation */
	dl_u8_func[USB_TX_STATUS - (START_U8BIT + 1)] = validate_usb_tx_status;

	/* USB_COMMUNICATION_STATUS Validation */
	dl_u8_func[USB_RX_STATUS - (START_U8BIT + 1)] = validate_usb_rx_status;

	/* USB_RX_BUFFER_STATUS Validation */
	dl_u8_func[USB_RX_BUFFER_STATUS - (START_U8BIT + 1)] = validate_usb_rxbuf_status;

	/* USB_COMMUNICATION_STATUS Validation */
	dl_u8_func[USB_COMMUNICATION_STATUS - (START_U8BIT + 1)] = validate_usb_communication_status;

#else

	/* USB_COMMUNICATION_STATUS_DUMMY Validation */
	dl_u8_func[USB_TX_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* USB_COMMUNICATION_STATUS_DUMMY Validation */
	dl_u8_func[USB_RX_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* USB_RX_BUFFER_STATUS_DUMMY Validation */
	dl_u8_func[USB_RX_BUFFER_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* USB_COMMUNICATION_STATUS_DUMMY Validation */
	dl_u8_func[USB_COMMUNICATION_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_USB

#if (SDK_SERVICE_EEPROM == PS_ENABLE)

	/* EEPROM_READ_STATUS Validation */
	dl_u8_func[EEPROM_READ_STATUS - (START_U8BIT + 1)] = validate_eeprom_read_status;

	/* EEPROM_WRITE_STATUS Validation */
	dl_u8_func[EEPROM_WRITE_STATUS - (START_U8BIT + 1)] = validate_eeprom_write_status;

#else

	/* EEPROM_READ_STATUS_DUMMY Validation */
	dl_u8_func[EEPROM_READ_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* EEPROM_WRITE_STATUS_DUMMY Validation */
	dl_u8_func[EEPROM_WRITE_STATUS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_EEPROM

#if (SDK_SERVICE_CAMERA == PS_ENABLE)

	/* CAMERA_STREAM ON/OFF */
	dl_u8_func[CAMERA_VIDEO_STREAM - (START_U8BIT + 1)] = validate_camera_stream_state;

	/* CAMERA Mode <Full Screen / Resize / Display as it is */
	dl_u8_func[CAMERA_VIDEO_MODE - (START_U8BIT + 1)] = validate_camera_stream_mode;

	/* VERTICAL_FLIP Validation */
	dl_u8_func[CAMERA_VIDEO_FLIP_VERTICAL - (START_U8BIT + 1)] = validate_flip_state;

	/* HORIZONTAL_FLIP Validation */
	dl_u8_func[CAMERA_VIDEO_FLIP_HORIZONTAL - (START_U8BIT + 1)] = validate_flip_state;

#else

	/* CAMERA_STREAM_DUMMY Validation */
	dl_u8_func[CAMERA_VIDEO_STREAM_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* VERTICAL_FLIP_DUMMY Validation */
	dl_u8_func[CAMERA_VIDEO_FLIP_VERTICAL_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* HORIZONTAL_FLIP_DUMMY Validation */
	dl_u8_func[CAMERA_VIDEO_FLIP_HORIZONTAL_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//SDK_SERVICE_CAMERA

#if (SDK_SERVICE_FDCAN == PS_ENABLE)
	/* CAN_CH0_MODE Validation */
	dl_u8_func[CAN_CH0_MODE - (START_U8BIT + 1)] = validate_fdcan_mode;

	/* CAN_CH1_MODE Validation */
	dl_u8_func[CAN_CH1_MODE - (START_U8BIT + 1)] = validate_fdcan_mode;

	/* CAN_CH0_FILTER_INDEX_ENABLE Validation */
	dl_u8_func[CAN_CH0_FILTER_INDEX_ENABLE - (START_U8BIT + 1)] = validate_filter_index;

	/* CAN_CH1_FILTER_INDEX_ENABLE Validation */
	dl_u8_func[CAN_CH1_FILTER_INDEX_ENABLE - (START_U8BIT + 1)] = validate_filter_index;

	/* CAN_CH0_STATES Validation */
	dl_u8_func[CAN_CH0_STATES - (START_U8BIT + 1)] = validate_can_state;

	/* CAN_CH1_STATES Validation */
	dl_u8_func[CAN_CH1_STATES - (START_U8BIT + 1)] = validate_can_state;

	/* CAN_CH0_COMM_STATE_EVENTS Validation */
	dl_u8_func[CAN_CH0_COMM_STATE_EVENTS - (START_U8BIT + 1)] = validate_can_comm_state;

	/* CAN_CH1_COMM_STATE_EVENTS Validation */
	dl_u8_func[CAN_CH1_COMM_STATE_EVENTS - (START_U8BIT + 1)] = validate_can_comm_state;

	/* CAN_CH0_RESET Validation */
	dl_u8_func[CAN_CH0_RESET - (START_U8BIT + 1)] = validate_can_reset;

	/* CAN_CH1_RESET Validation */
	dl_u8_func[CAN_CH1_RESET - (START_U8BIT + 1)] = validate_can_reset;

	/* CAN_CH0_DRIVER_RESET Validation */
	dl_u8_func[CAN_CH0_DRIVER_RESET - (START_U8BIT + 1)] = validate_can_reset;

	/* CAN_CH1_DRIVER_RESET Validation */
	dl_u8_func[CAN_CH1_DRIVER_RESET - (START_U8BIT + 1)] = validate_can_reset;

	/* CAN0_RX_BYTE_COUNT Validation */
	dl_u8_func[CAN0_RX_BYTE_COUNT - (START_U8BIT + 1)] = validate_can_byte_count;

	/* CAN0_TX_BYTE_COUNT Validation */
	dl_u8_func[CAN0_TX_BYTE_COUNT - (START_U8BIT + 1)] = validate_can_byte_count;

	/* CAN0_RX_DATA_IS_AVAILABLE Validation */
	dl_u8_func[CAN0_RX_DATA_IS_AVAILABLE - (START_U8BIT + 1)] = validate_can_data_available;

	/* CAN0_RX_DATA_SIZE Validation */
	dl_u8_func[CAN0_RX_DATA_SIZE - (START_U8BIT + 1)] = validate_can_data_size;

	/* CAN1_RX_BYTE_COUNT Validation */
	dl_u8_func[CAN1_RX_BYTE_COUNT - (START_U8BIT + 1)] = validate_can_byte_count;

	/* CAN1_TX_BYTE_COUNT Validation */
	dl_u8_func[CAN1_TX_BYTE_COUNT - (START_U8BIT + 1)] = validate_can_byte_count;

	/* CAN1_RX_DATA_IS_AVAILABLE Validation */
	dl_u8_func[CAN1_RX_DATA_IS_AVAILABLE - (START_U8BIT + 1)] = validate_can_data_available;

	/* CAN1_RX_DATA_SIZE Validation */
	dl_u8_func[CAN1_RX_DATA_SIZE - (START_U8BIT + 1)] = validate_can_data_size;

	/* CAN_CH0_BAUDRATE Validation */
	dl_u8_func[CAN_CH0_BAUDRATE - (START_U8BIT + 1)] = validate_can_baudrate;

	/* CAN_CH1_BAUDRATE Validation */
	dl_u8_func[CAN_CH1_BAUDRATE - (START_U8BIT + 1)] = validate_can_baudrate;

#else

	/* CAN_CH0_MODE_DUMMY Validation */
	dl_u8_func[CAN_CH0_MODE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH1_MODE_DUMMY Validation */
	dl_u8_func[CAN_CH1_MODE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH0_FILTER_INDEX_ENABLE_DUMMY Validation */
	dl_u8_func[CAN_CH0_FILTER_INDEX_ENABLE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH1_FILTER_INDEX_ENABLE_DUMMY Validation */
	dl_u8_func[CAN_CH1_FILTER_INDEX_ENABLE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH0_STATES_DUMMY Validation */
	dl_u8_func[CAN_CH0_STATES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH1_STATES_DUMMY Validation */
	dl_u8_func[CAN_CH1_STATES_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH0_COMM_STATE_EVENTS_DUMMY Validation */
	dl_u8_func[CAN_CH0_COMM_STATE_EVENTS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH1_COMM_STATE_EVENTS_DUMMY Validation */
	dl_u8_func[CAN_CH1_COMM_STATE_EVENTS_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH0_RESET_DUMMY Validation */
	dl_u8_func[CAN_CH0_RESET_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH1_RESET_DUMMY Validation */
	dl_u8_func[CAN_CH1_RESET_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH0_DRIVER_RESET_DUMMY Validation */
	dl_u8_func[CAN_CH0_DRIVER_RESET_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH1_DRIVER_RESET_DUMMY Validation */
	dl_u8_func[CAN_CH1_DRIVER_RESET_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN0_RX_BYTE_COUNT_DUMMY Validation */
	dl_u8_func[CAN0_RX_BYTE_COUNT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN0_TX_BYTE_COUNT_DUMMY Validation */
	dl_u8_func[CAN0_TX_BYTE_COUNT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN0_RX_DATA_IS_AVAILABLE_DUMMY Validation */
	dl_u8_func[CAN0_RX_DATA_IS_AVAILABLE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN0_RX_DATA_SIZE_DUMMY Validation */
	dl_u8_func[CAN0_RX_DATA_SIZE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN1_RX_BYTE_COUNT_DUMMY Validation */
	dl_u8_func[CAN1_RX_BYTE_COUNT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN1_TX_BYTE_COUNT_DUMMY Validation */
	dl_u8_func[CAN1_TX_BYTE_COUNT_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN1_RX_DATA_IS_AVAILABLE_DUMMY Validation */
	dl_u8_func[CAN1_RX_DATA_IS_AVAILABLE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN1_RX_DATA_SIZE_DUMMY Validation */
	dl_u8_func[CAN1_RX_DATA_SIZE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH0_BAUDRATE_DUMMY Validation */
	dl_u8_func[CAN_CH0_BAUDRATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_CH1_BAUDRATE_DUMMY Validation */
	dl_u8_func[CAN_CH1_BAUDRATE_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;
#endif	//SDK_SERVICE_CAMERA

#if (THROUGH_PUT_SERVICE == PS_ENABLE)

	/* KEYPAD_PTIME Validation */
	dl_u8_func[KEYPAD_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* DIO_PTIME Validation */
	dl_u8_func[DIO_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* CI_PTIME Validation */
	dl_u8_func[CI_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* POWERMODE_PTIME Validation */
	dl_u8_func[POWERMODE_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* LIGHT_SENSOR_PTIME Validation */
	dl_u8_func[LIGHT_SENSOR_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* WARNINGLIGHT_PTIME Validation */
	dl_u8_func[WARNINGLIGHT_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* LED_PTIME Validation */
	dl_u8_func[LED_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* POWER_MONITOR_PTIME Validation */
	dl_u8_func[POWER_MONITOR_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* USB_PTIME Validation */
	dl_u8_func[USB_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* DEFAULT_PERTIME Validation */
	dl_u8_func[DEFAULT_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* BLUETOOTH_PTIME Validation */
	dl_u8_func[BLUETOOTH_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* RTC_PTIME Validation */
	dl_u8_func[RTC_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* SW_TIMER_PTIME Validation */
	dl_u8_func[SW_TIMER_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* CAMERA_PTIME Validation */
	dl_u8_func[CAMERA_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* EEPROM_PTIME Validation */
	dl_u8_func[EEPROM_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* WATCHDOG_PTIME Validation */
	dl_u8_func[WATCHDOG_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* LCD_PTIME Validation */
	dl_u8_func[LCD_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* CAN_PTIME Validation */
	dl_u8_func[CAN_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* J1939_PTIME Validation */
	dl_u8_func[J1939_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	/* TOUCHGFX_PERTIME Validation */
	dl_u8_func[TOUCHGFX_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	dl_u8_func[J1939CTRL_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	dl_u8_func[IDLE_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	dl_u8_func[USERTASK1_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	dl_u8_func[USERTASK2_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

	dl_u8_func[USERTASK3_PERTIME - (START_U8BIT + 1)] = validate_percentage_time;

#else

	/* KEYPAD_PTIME_DUMMY Validation */
	dl_u8_func[KEYPAD_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* DIO_PTIME_DUMMY Validation */
	dl_u8_func[DIO_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CI_PTIME_DUMMY Validation */
	dl_u8_func[CI_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* POWERMODE_PTIME_DUMMY Validation */
	dl_u8_func[POWERMODE_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* LIGHT_SENSOR_PTIME_DUMMY Validation */
	dl_u8_func[LIGHT_SENSOR_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WARNINGLIGHT_PTIME_DUMMY Validation */
	dl_u8_func[WARNINGLIGHT_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* LED_PTIME_DUMMY Validation */
	dl_u8_func[LED_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* POWER_MONITOR_PTIME_DUMMY Validation */
	dl_u8_func[POWER_MONITOR_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* USB_PTIME_DUMMY Validation */
	dl_u8_func[USB_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* DEFAULT_PERTIME_DUMMY Validation */
	dl_u8_func[DEFAULT_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* BLUETOOTH_PTIME_DUMMY Validation */
	dl_u8_func[BLUETOOTH_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* RTC_PTIME_DUMMY Validation */
	dl_u8_func[RTC_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* SW_TIMER_PTIME_DUMMY Validation */
	dl_u8_func[SW_TIMER_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAMERA_PTIME_DUMMY Validation */
	dl_u8_func[CAMERA_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* EEPROM_PTIME_DUMMY Validation */
	dl_u8_func[EEPROM_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* WATCHDOG_PTIME_DUMMY Validation */
	dl_u8_func[WATCHDOG_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* LCD_PTIME_DUMMY Validation */
	dl_u8_func[LCD_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* CAN_PTIME_DUMMY Validation */
	dl_u8_func[CAN_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* J1939_PTIME_DUMMY Validation */
	dl_u8_func[J1939_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

	/* TOUCHGFX_PERTIME_DUMMY Validation */
	dl_u8_func[TOUCHGFX_PERTIME_DUMMY - (START_U8BIT + 1)] = validate_dummy_field;

#endif	//THROUGH_PUT_SERVICE

	/* IS_PS_INIT_DONE Validation */
	dl_u8_func[IS_PS_INIT_DONE - (START_U8BIT + 1)] = validate_ps_init_state;

}

#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

/** @brief Warning light state field validation
 *
 *  This function validates the Warning light state DB field.
 *
 *  @param  wl_num [IN] : Warning light number
 *          state  [IN] : warning light state
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_wl_state(uint16_t wl_num ,uint8_t state)
{
	uint8_t cbuff[CBUF_BUF_SIZE];

	/* Fetch the proper Warning light index */
	wl_num = wl_num / 2;

	/* Check ON / OFF value */
	if ((WL_ON != state) && (WL_OFF != state))
		return FAILURE;

	/* Clear the local buffer */
	memset(&cbuff[0], 0x00, sizeof(cbuff));

	/* WL Number */
	cbuff[WL_NUM_INDEX] = wl_num;

	/* Fill the WL state data */
	cbuff[WL_STATE_INDEX] = state;

    /* Get the Duty cycle value for the appropriate WL */
    Get_DL(((wl_num +1) * 2), &cbuff[WL_DC_INDEX]);

    /* Get the Blinking period value for the appropriate WL */
    Get_DL((START_U16BIT + wl_num + 1), &cbuff[WL_BL_INDEX]);

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper warning light SDK API */
    	SetWLT(wl_num, &cbuff[WL_NUM_INDEX]);
    }

	return SUCCESS;
}

/** @brief Warning light pwm validation
 *
 *  This function validates the Warning light PWM DB field.
 *
 *  @param  wl_num [IN] : Warning light number
 *          period [IN] : PWM Period
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_wl_pwm(uint16_t wl_num ,uint8_t period)
{

	if(!((MIN_WL_PWM_DC <= period) && (MAX_WL_PWM_DC >= period)))
		return FAILURE;

	return SUCCESS;
}

#endif	//SDK_SERVICE_WARNING_LIGHT

#if (SDK_SERVICE_KEYPAD == PS_ENABLE)

/** @brief Keypad backlight validation
 *
 *  This function validates the Keypad backlight DB field.
 *
 *  @param  keypad [IN]    : keypad DB Field
 *          key_state [IN] : key state
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_keypad_backlight(uint16_t keypad, uint8_t key_state)
{
	if(!((KEY_BACKLIGHT_ON == key_state) || (KEY_BACKLIGHT_OFF == key_state)))
		return FAILURE;

	/* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper Keypad SDK API */
    	SetKPD(KEYPAD_SET,key_state);
    }
	return SUCCESS;
}

/** @brief Keypad status validation
 *
 *  This function validates the Keypad status DB field.
 *
 *  @param  keypad [IN]     : keypad DB Field
 *          key_status [IN] : key status
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_keypad_status(uint16_t keypad, uint8_t key_status)
{
	if(!((KEY_INACTIVE == key_status) || (SHORT_PRESSED == key_status)
			|| (LONG_PRESSED == key_status) || (CONTINUOUS_PRESSED == key_status)))
		return FAILURE;

	return SUCCESS;
}


/** @brief Keypad press validation
 *
 *  This function validates the Keypad press DB field.
 *
 *  @param  keypad [IN]     : keypad DB Field
 *          key_status [IN] : key status
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_keypad_press(uint16_t keypad, uint8_t key_press)
{
	uint8_t key_status = 0;

	if(!((TRUE == key_press) || (FALSE == key_press)))
		return FAILURE;

	/* Get the current key state */
	Get_DL(keypad, &key_status);

	if(!((SHORT_PRESSED == key_status) || (LONG_PRESSED == key_status)))
		return FAILURE;

	/* Update the current key status to inactive */
	key_status = KEY_INACTIVE;
	Set_DL(keypad, &key_status);

	return SUCCESS;
}

#endif	//SDK_SERVICE_KEYPAD

#if (SDK_SERVICE_RTC == PS_ENABLE)
/** @brief validation RTC parameter
 *
 *  This function validates the RTC parameter DB field.
 *
 *  @param  rtc_index [IN]  : RTC DB Field
 *          value [IN]      : RTC parameter
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_RTC_parameter(uint16_t rtc_index, uint8_t value)
{
	uint8_t result = SUCCESS;

	switch(rtc_index+1)
	{
		case RTC_SECOND:
		case RTC_ALARM_A_SECOND:
		case RTC_ALARM_B_SECOND:
		case GET_RTC_SECOND:

			if(!((RTC_MIN_VAL <= value) && (RTC_MAX_VAL > value)))
			{
				result = FAILURE;
			}
			break;

		case RTC_MINUTE:
		case RTC_ALARM_A_MINUTE:
		case RTC_ALARM_B_MINUTE:
		case GET_RTC_MINUTE:

			if(!((RTC_MIN_VAL <= value) && (RTC_MAX_VAL > value)))
			{
				result = FAILURE;
			}
			break;

		case RTC_HOUR:
		case RTC_ALARM_A_HOUR:
		case RTC_ALARM_B_HOUR:
		case GET_RTC_HOUR:

			if (!((RTC_MIN_VAL <= value && RTC_12H_MAX_VAL > value) ||
					(RTC_MIN_VAL <= value && RTC_24H_MAX_VAL > value)))
			{
				result = FAILURE;
			}
			break;

		case RTC_DATE:
		case RTC_ALARM_A_DAY:
		case RTC_ALARM_B_DAY:
		case GET_RTC_DATE:

			if(!((RTC_DAY_MIN_VAL <= value) && (RTC_DAY_MAX_VAL >= value)))
			{
				result = FAILURE;
			}
			break;

		case RTC_WEEK_DAY:
		case RTC_ALARM_A_WEEK_DAY:
		case RTC_ALARM_B_WEEK_DAY:
		case GET_RTC_WEEK_DAY:

			if(!((RTC_WEEKDAY_MIN_VAL <= value) && (RTC_WEEKDAY_MAX_VAL >= value)))
			{
				result = FAILURE;
			}
			break;

		case RTC_MONTH:
		case RTC_ALARM_A_MONTH:
		case RTC_ALARM_B_MONTH:
		case GET_RTC_MONTH:

			if(!((RTC_MONTH_MIN_VAL <= value) && (RTC_MONTH_MAX_VAL >= value)))
			{
				result = FAILURE;
			}
			break;

		case RTC_YEAR:
		case RTC_ALARM_A_YEAR:
		case RTC_ALARM_B_YEAR:
		case GET_RTC_YEAR:
			if(!((RTC_YEAR_MIN_VAL <= value) && (RTC_YEAR_MAX_VAL >= value)))
			{
				result = FAILURE;
			}
			break;

		case RTC_TIME_FORMAT:
		case RTC_ALARM_A_TIME_FORMAT:
		case RTC_ALARM_B_TIME_FORMAT:
		case GET_RTC_TIME_FORMAT:

			if(!((FORMAT_12_HOUR == value) || (FORMAT_24_HOUR == value)))
			{
				result = FAILURE;
			}
			break;

		case ALARM_A_STATUS:
		case ALARM_B_STATUS:

			if(!((ALARM_OCCURED == value) || (ALARM_NOT_OCCURED == value)))
			{
				result = FAILURE;
			}
			break;

		default:
			result = FAILURE;
	}

	return result;
}

/** @brief validation and SET RTC parameter
 *
 *  This function validates the RTC parameter DB field and
 *  sends the RTC parameter to platform service.
 *
 *  @param  rtc_index [IN]  : RTC DB Field
 *          value [IN]      : RTC parameter
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_and_SET_RTC_parameter(uint16_t rtc_index, uint8_t value)
{
	uint8_t index;
	uint8_t rtcbuff[RTCBUF_BUF_SIZE];
	uint8_t result = SUCCESS;
	uint16_t rtc_db_start_idx;

	/* Clear the local buffer */
	memset(&rtcbuff[0], 0x00, sizeof(rtcbuff));

	switch(rtc_index+1)
	{
		case SET_RTC:
			rtc_db_start_idx = RTC_SECOND;
			rtcbuff[0] = TIME;

			if(!(SET_RTC_PARAMETER == value))
			{
				result = FAILURE;
			}
			break;

		case SET_ALARM_A:
			rtc_db_start_idx = RTC_ALARM_A_SECOND;
			rtcbuff[0] = ALARM_A;

			if(!(SET_RTC_PARAMETER == value))
			{
				result = FAILURE;
			}
			break;

		case SET_ALARM_B:
			rtc_db_start_idx = RTC_ALARM_B_SECOND;
			rtcbuff[0] = ALARM_B;

			if(!(SET_RTC_PARAMETER == value))
			{
				result = FAILURE;
			}
			break;

		default:
			result = FAILURE;
	}

	if(result == SUCCESS)
	{
		for(index = 1; index <= RTCBUF_BUF_SIZE; index++)
		{
			/* Get the RTC parameter with respect to RTC DB index */
			Get_DL((rtc_db_start_idx++), &rtcbuff[index]);
		}

		index = 1;
		/* Update the RTC parameter */
		pv.rtc_ps_data.Seconds 	   = rtcbuff[index++];
		pv.rtc_ps_data.Minutes 	   = rtcbuff[index++];
		pv.rtc_ps_data.Hours   	   = rtcbuff[index++];
		pv.rtc_ps_data.Date    	   = rtcbuff[index++];
		pv.rtc_ps_data.WeekDay 	   = rtcbuff[index++];
		pv.rtc_ps_data.Month   	   = rtcbuff[index++];
		pv.rtc_ps_data.Year    	   = rtcbuff[index++];
		pv.rtc_ps_data.time_format = rtcbuff[index++];


		/* Check if the PS is UP */
	    if (TRUE == pv.isPSUP)
	    {
			/* Call the proper RTC SDK API */
			SetRTC(rtcbuff[0], &pv.rtc_ps_data, pv.rtc_ps_data.time_format);
	    }

	}

	return result;
}

#endif	//SDK_SERVICE_RTC


#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
/** @brief validation DIO CFG parameter
 *
 *  This function validates the DIO CFG parameter
 *  sends the DIO CFG parameter to platform service.
 *
 *  @param  DIO_db_idx [IN]  : DIO DB Field
 *          DIO_state [IN]   : DIO State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_DIO_CFG_parameter(uint16_t DIO_db_idx, uint8_t DIO_state)
{
    /* Validate the Digital output state */
    if (!((CONF_LOW_SIDE_DRIVER == DIO_state) || (CONF_HIGH_SIDE_DRIVER == DIO_state)
    		|| (CONF_OPEN_DRIVE_DRIVER == DIO_state)))
    	return FAILURE;


    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper DIO SDK API */
    	SetDIO(SET_DIO_CFG, DIO_state);
    }
    return SUCCESS;
}

/** @brief validation DIO state
 *
 *  This function validates the DIO state
 *  sends the DIO state to platform service.
 *
 *  @param  DIO_db_idx [IN]  : DIO DB Field
 *          DIO_state [IN]   : DIO State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_DIO_state(uint16_t DIO_db_idx, uint8_t DIO_state)
{
    /* Validate the Digital output state */
    if (!((CONF_DIGITAL_OUTPUT_ON == DIO_state) || (CONF_DIGITAL_OUTPUT_OFF == DIO_state)))
    	return FAILURE;

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
		/* Call the proper DIO SDK API */
		SetDIO(SET_DIO_STATE, DIO_state);
    }
    return SUCCESS;
}
#endif	//SDK_SERVICE_DIGITAL_OUTPUT


#if (SDK_SERVICE_LIGHT_SENSOR == PS_ENABLE)
/** @brief validation LTS conversion time
 *
 *  This function validates the Light sensor conversion time and
 *  sends the LTS parameter to platform service.
 *
 *  @param  LTS_db_idx [IN]    : LTS DB Field
 *          LTS_conv_time [IN] : LTS Conv time
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_LTS_conversion_time(uint16_t LTS_db_idx, uint8_t LTS_conv_time)
{
	if(!((LS_CONVERSION_TIME_100 == LTS_conv_time) ||
	    		 (LS_CONVERSION_TIME_800 == LTS_conv_time)))
		return FAILURE;

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper LTS SDK API */
    	SetLTS(LS_SET_CONVERSION_TIME, LTS_conv_time);
    }
	return SUCCESS;
}

/** @brief validation LTS conversion mode
 *
 *  This function validates the Light sensor conversion mode and
 *  sends the LTS parameter to platform service.
 *
 *  @param  LTS_db_idx [IN]    : LTS DB Field
 *          LTS_conv_mode [IN] : LTS Conv mode
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_LTS_conversion_mode(uint16_t LTS_db_idx, uint8_t LTS_conv_mode)
{
	if(!((LS_SINGLE_MODE_CONV == LTS_conv_mode) || (LS_CONTINUOUS_MODE_CONV == LTS_conv_mode)
			|| (LS_SHUTDOWN == LTS_conv_mode)))
		return FAILURE;

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper LTS SDK API */
    	SetLTS(LS_SET_MODE, LTS_conv_mode);
    }
	return SUCCESS;
}

/** @brief validation LTS Trigger
 *
 *  This function validates the Light sensor Trigger and
 *  sends the LTS parameter to platform service.
 *
 *  @param  LTS_db_idx [IN]  : LTS DB Field
 *          LTS_tigger [IN]  : LTS Trigger
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_LTS_trigger(uint16_t LTS_db_idx, uint8_t LTS_tigger)
{
	if(!((TRUE == LTS_tigger) || (FALSE == LTS_tigger)))
		return FAILURE;

	if((LTS_tigger == TRUE) && (LS_SINGLE_MODE_CONV == pv.ls_mode))
	{
		SetLTS(LS_SET_MODE, LS_SINGLE_MODE_CONV);
	}
	return SUCCESS;
}

#endif	//SDK_SERVICE_LIGHT_SENSOR


#if (SDK_SERVICE_WATCHDOG == PS_ENABLE)
/** @brief validation WD Feed
 *
 *  This function validates the watchdog feed id and
 *  sends the watchdog feed id to platform service.
 *
 *  @param  wd_db_idx [IN]  : Watchdog DB Field
 *          feed_id [IN]    : Watchdog feed id
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_WD_feed_id(uint16_t wd_db_idx, uint8_t feed_id)
{
	uint8_t wd_index = 0;

	feed_id = 1;

#if (USER_TASK_WD0 == PS_ENABLE)
	if (WD0_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_0;
	}
#endif

#if (USER_TASK_WD1 == PS_ENABLE)
	if (WD1_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_1;
	}
#endif

#if (USER_TASK_WD2 == PS_ENABLE)
	if (WD2_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_2;
	}
#endif

#if (USER_TASK_WD3 == PS_ENABLE)
	if (WD3_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_3;
	}
#endif

#if (USER_TASK_WD4 == PS_ENABLE)
	if (WD4_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_4;
	}
#endif

#if (USER_TASK_WD5 == PS_ENABLE)
	if (WD5_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_5;
	}
#endif

#if (USER_TASK_WD6 == PS_ENABLE)
	if (WD6_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_6;
	}
#endif

#if (USER_TASK_WD7 == PS_ENABLE)
	if (WD7_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_7;
	}
#endif

#if (USER_TASK_WD8 == PS_ENABLE)
	if (WD8_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_8;
	}
#endif

#if (USER_TASK_WD9 == PS_ENABLE)
	if (WD9_PING == (wd_db_idx + 1))
	{
		wd_index = WD_PING_USER_9;
	}
#endif

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper Watchdog SDK API */
    	SetWD(wd_index);
    }
	return SUCCESS;
}

#endif	//SDK_SERVICE_WATCHDOG

#if (SDK_SERVICE_LED == PS_ENABLE)

#if ((CONF_RED_LED_PS_STATE == PS_ENABLE) || \
		(CONF_AMB_LED_PS_STATE == PS_ENABLE))
/** @brief validation led state
 *
 *  This function validates the led state and
 *  sends the led state to platform service.
 *
 *  @param  led_idx [IN]   : LED DB Field
 *          led_state [IN] : led state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_led_state(uint16_t led_idx, uint8_t led_state)
{
	uint8_t lbuff[CBUF_BUF_SIZE];
	uint8_t led_num = 0;

	/* Check ON / OFF value */
	if ((LED_ON != led_state) && (LED_OFF != led_state))
		return FAILURE;

	/* Clear the local buffer */
	memset(&lbuff[0], 0x00, sizeof(lbuff));
#if(CONF_RED_LED_PS_STATE == PS_ENABLE)
	/* get LED number */
	led_num = (led_idx - (LED_RED_STATE - 1));
#endif
	/* LED Number */
	lbuff[LED_NUM_INDEX] = led_num;

	/* Fill the LED state data */
	lbuff[LED_STATE_INDEX] = led_state;

	if(led_num == 0)
	{
#if(CONF_RED_LED_PS_STATE == PS_ENABLE)
	    /* Get the Blinking period value for the RED LED */
	    Get_DL(LED_RED_BLINKING, &lbuff[LED_BLK_INDEX]);
#endif
	}
	else
	{
#if(CONF_AMB_LED_PS_STATE == PS_ENABLE)
	    /* Get the Blinking period value for the AMB LED */
		Get_DL(LED_AMB_BLINKING, &lbuff[LED_BLK_INDEX]);
#endif
	}

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper warning light SDK API */
    	SetLED(led_num, &lbuff[LED_NUM_INDEX]);
    }

	return SUCCESS;
}

#endif

#endif	//SDK_SERVICE_LED

#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)

/** @brief validate digital input
 *
 *  This function validates the digital input value and
 *  return the status
 *
 *  @param  cfg_idx [IN]       : configurable input DB Field.
 *          digital_input [IN] : digital input value.
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_digital_input(uint16_t cfg_idx, uint8_t digital_input)
{
	if(!((TRUE == digital_input) || (FALSE == digital_input)))
		return FAILURE;

	return SUCCESS;
}

/** @brief validate number of samples
 *
 *  This function validates the number of samples and
 *  return the status
 *
 *  @param  cfg_idx [IN]    : configurable input DB Field.
 *          value [IN] 		: number of sample value.
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_num_of_samples(uint16_t cfg_idx, uint8_t value)
{
	uint16_t ci_index = 0;

	if(!((MIN_NUM_SAMPLE <= value) && (value <= MAX_NUM_SAMPLE)))
		return FAILURE;

	/* get the configurable input index (i.e 1 to 6) */
	ci_index = ((cfg_idx - (CFG_INPUT_01_NUMB_SAMPLES - 2))/4) + 1;

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper configurable SDK API */
    	SetCGI(CI_SET_NUM_SAMPLE, ci_index ,value);
    }
	return SUCCESS;
}

/** @brief validate config type
 *
 *  This function validates the config type and
 *  return the status
 *
 *  @param  cfg_idx [IN]    : configurable input DB Field.
 *          cfg_type [IN] 	: config type value.
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_cfg_type(uint16_t cfg_idx, uint8_t cfg_type)
{
	uint16_t ci_index = 0;

	if ((CI_INPUT_FREQUENCY != cfg_type) && (CI_INPUT_CURRENT != cfg_type) &&
			(CI_INPUT_VOLTAGE_LOW != cfg_type) && (CI_INPUT_RESISTANCE != cfg_type) &&
			(CI_DIGITAL_STG != cfg_type) && (CI_DIGITAL_STB != cfg_type) &&
			(CI_INPUT_VOLTAGE_HIGH != cfg_type) && (CI_INPUT_VOLTAGE_LOW_6V != cfg_type) &&
			(CI_INPUT_OFF != cfg_type))
		return FAILURE;

	/* get the configurable input index (i.e 1 to 6) */
	ci_index = ((cfg_idx - (CFG_INPUT_01_TYPE - 2))/4) + 1;

	/* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
		/* Call the proper configurable SDK API */
		SetCGI(CI_SET_INPUT_TYPE, ci_index ,cfg_type);
    }
	return SUCCESS;
}

#endif	//SDK_SERVICE_CFG_INPUT

#if (SDK_SERVICE_LCD == PS_ENABLE)

/** @brief validation LCD state
 *
 *  This function validates the LCD state and
 *  sends the lcd state to platform service.
 *
 *  @param  lcd_idx [IN]   : LCD DB Field
 *          lcd_state [IN] : LCD state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_lcd_state(uint16_t lcd_idx, uint8_t lcd_state)
{
	/* Check LCD ON / OFF value */
	if ((LCD_CONF_ON != lcd_state) && (LCD_CONF_OFF != lcd_state))
		return FAILURE;

	/* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
		/* Call the proper LCD SDK API */
		SetLCD(SET_LCD_STATE, lcd_state);
    }
	return SUCCESS;
}

/** @brief validation LCD Brightness
 *
 *  This function validates the LCD brightness and
 *  sends the LCD brightness to platform service.
 *
 *  @param  lcd_idx [IN]        : LCD DB Field
 *          brightness_val [IN] : LCD brightness value
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_lcd_brightness(uint16_t lcd_idx, uint8_t brightness_val)
{
	if(!((MIN_LCD_BRIGHTNESS <= brightness_val) &&
			(MAX_LCD_BRIGHTNESS >= brightness_val)))
		return FAILURE;


    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper LCD SDK API */
    	SetLCD(SET_LCD_BRIGHTNESS, brightness_val);
    }
	return SUCCESS;
}

#endif	//SDK_SERVICE_LCD

#if (SDK_SERVICE_PM == PS_ENABLE)

/** @brief validation of power mode
 *
 *  This function validates the power mode state and
 *  sends the power mode state to platform service.
 *
 *  @param  pm_idx [IN]   : PM DB Field
 *          pm_state [IN] : PM State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_power_mode(uint16_t pm_idx, uint8_t pm_state)
{
	if(!((PM_SLEEP_MODE == pm_state) || (PM_STOP_MODE == pm_state)
			|| (PM_STANDBY_MODE == pm_state)))
		return FAILURE;

    /* Check if the PS is UP */
    if (TRUE == pv.isPSUP)
    {
    	/* Call the proper PM SDK API */
    	SetPWR(pm_state);
    }
	return SUCCESS;
}

#endif	//SDK_SERVICE_PM


#if (SDK_SERVICE_PM == PS_ENABLE)

/** @brief validate Keypad state value
 *
 *  This function validates the Keypad wakeup state value and
 *  sends the wakeup state value to platform service.
 *
 *  @param  wakeup_idx [IN] : Keypad DB Field
 *          state [IN]      : Keypad State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_keypad_wakeup_state(uint16_t wakeup_idx, uint8_t state)
{
	if(!((TRUE == state) || (FALSE == state)))
		return FAILURE;

	return SUCCESS;
}

/** @brief validate RTC state value
 *
 *  This function validates the RTC state value and
 *  sends the RTC state value to platform service.
 *
 *  @param  wakeup_idx [IN] : RTC DB Field
 *          state [IN]      : RTC State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_rtc_wakeup_state(uint16_t wakeup_idx, uint8_t state)
{
	if(!((TRUE == state) || (FALSE == state)))
		return FAILURE;

	return SUCCESS;
}

#endif	// SDK_SERVICE_PM

#if (SDK_SERVICE_POWER_MONITOR == PS_ENABLE)

/** @brief validation of IGN Status
 *
 *  This function validates the IGN status and
 *  sends the IGN Status to platform service.
 *
 *  @param  ign_idx [IN]    : IGN DB Field
 *          ign_status [IN] : IGN Status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_IGN_state(uint16_t ign_idx, uint8_t ign_status)
{
	/* IGN ON / OFF value */
	if ((IGN_ON != ign_status) && (IGN_OFF != ign_status))
		return FAILURE;

	return SUCCESS;
}
#endif	//SDK_SERVICE_POWER_MONITOR

#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

/** @brief Timer Status validation
 *
 *  This function validates the timer status.
 *
 *  @param  db_idx [IN] : Timer DB index
 *          status [IN] : Timer Status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_timer_status(uint16_t db_idx, uint8_t status)
{
	uint8_t tbuf[3] = {0};
	uint16_t timeout_val = 0;
	uint8_t timer_count = 0;

	/* Check Timer Status */
	if ((SWT_ACTIVE != status) && (SWT_INACTIVE != status))
		return FAILURE;

	/* Get the timer mode */
	Get_DL((db_idx + 2), &tbuf[0]);

	timer_count = (((db_idx + 1) - TIMER_STATUS_01)/2);
	/* Get the timeout value */
	Get_DL((TIMER_TIMEOUT_01 + timer_count), &tbuf[1]);

	/* Timer count start with 1 */
	timer_count++;

	/* Timeout value */
	timeout_val = (tbuf[2] << 8) | (tbuf[1]);

	SetSWT(timer_count, status, tbuf[0], timeout_val);
	return SUCCESS;
}

/** @brief Timer Mode validation
 *
 *  This function validates the timer Mode.
 *
 *  @param  db_idx [IN] : Timer DB index
 *          mode   [IN] : Timer mode
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_timer_mode(uint16_t db_idx, uint8_t mode)
{
	/* Check Timer Mode */
	if ((SWT_ONESHOT != mode) && (SWT_CONTINUOUS != mode))
		return FAILURE;

	return SUCCESS;
}

/** @brief Timer callback validation
 *
 *  This function validates the timer callback state.
 *
 *  @param  db_idx [IN] : Timer DB index
 *          state  [IN] : Timer callback state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_timer_callback(uint16_t db_idx, uint8_t state)
{
	/* Check Timer Mode */
	if ((CALLBACK_CLEAR != state) && (CALLBACK_OCCURED != state))
		return FAILURE;

	return SUCCESS;
}

#endif	//SDK_SERVICE_SWTIMER

#if (SDK_SERVICE_BLE == PS_ENABLE)

/** @brief BLE Status validation
 *
 *  This function validates the BLE status.
 *
 *  @param  db_idx [IN] : BLE DB index
 *          status [IN] : BLE Status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_ble_tx_status(uint16_t db_idx, uint8_t status)
{
	uint8_t res = FAILURE;
	uint8_t buf_index;
	uint8_t *buf;

	if(TRUE == status)
	{
		/* Get the USB buffer Index */
		buf_index = (BLE_TX_DATA - START_BUF512BIT) * BUF512BITSIZE;
		buf = (uint8_t *)&dl_buf[buf_index * BUF512BITSIZE];

		/* Call the SDK API for sending the USB packet to terminal*/
		res = SetBLE((int8_t *)buf, BUF512BITSIZE);

		res = SUCCESS;
	}
	return res;
}

/** @brief BLE Status validation
 *
 *  This function validates the BLE status.
 *
 *  @param  db_idx [IN] : BLE DB index
 *          status [IN] : BLE Status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_ble_rx_status(uint16_t db_idx, uint8_t status)
{
	uint8_t res = FAILURE;
	uint8_t buf_index;
	uint8_t *buf;

	if(TRUE == status)
	{
		buf_index = (BLE_RX_DATA - START_BUF512BIT) * BUF512BITSIZE;

		buf = (uint8_t *)&dl_buf[buf_index * BUF512BITSIZE];

		/* Clear the Rx buffer */
		memset(buf, 0x00, BUF512BITSIZE);

		/* Clear the RX buffer status */
		res = BLE_RX_MSF_EMPTY;
		Set_DL(BLE_RX_BUFFER_STATUS, &res);

		/* Clear the RX status */
		res =FALSE;
		Set_DL(BLE_RX_STATUS, &res);

		 res = SUCCESS;
	}
	return res;
}

/** @brief BLE buffer status validation
 *
 *  This function validates the BLE buffer status.
 *
 *  @param  db_idx [IN]     : BLE DB index
 *          buf_status [IN] : BLE buffer status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_ble_buffer_status(uint16_t db_idx, uint8_t buf_status)
{
	if(!((BLE_BUFF_FULL == buf_status) || (BLE_BUFF_EMPTY == buf_status)))
		return FAILURE;

	return SUCCESS;
}

/** @brief BLE communication status validation
 *
 *  This function validates the BLE Communication status.
 *
 *  @param  db_idx [IN]      : BLE DB index
 *          comm_status [IN] : BLE comm status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_ble_communication_status(uint16_t db_idx, uint8_t comm_status)
{
	if(!((BLE_COMM_OK == comm_status) || (BLE_COMM_ERROR == comm_status)))
		return FAILURE;

	return SUCCESS;
}
#endif	//SDK_SERVICE_BLE


#if (SDK_SERVICE_USB == PS_ENABLE)

/** @brief USB communication rx status validation
 *
 *  This function validates the USB Rx status validation.
 *
 *  @param  db_idx [IN]      : USB DB index
 *          status [IN]      : USB tx status for sending packet
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_usb_rx_status(uint16_t db_idx, uint8_t status)
{
	uint8_t res = FAILURE;
	uint16_t buf_index;
	uint8_t *buf;

	if(TRUE == status)
	{
		buf_index = (uint16_t) (((uint16_t)USB_RX_DATA - (uint16_t)START_BUF512BIT));

		buf = (uint8_t *)&dl_buf[buf_index * BUF512BITSIZE];

		/* Clear the Rx buffer */
		memset(buf, 0x00, BUF512BITSIZE);

		/* Clear the RX buffer status */
		res =RX_MSF_EMPTY;
		Set_DL(USB_RX_BUFFER_STATUS, &res);

		/* Clear the RX status */
		res =FALSE;
		Set_DL(USB_RX_STATUS, &res);

		 res = SUCCESS;
	}
	return res;
}

/** @brief USB communication status validation
 *
 *  This function validates the USB Transmission status.
 *
 *  @param  db_idx [IN]      : USB DB index
 *          status [IN]      : USB tx status for sending packet
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_usb_tx_status(uint16_t db_idx, uint8_t status)
{
	uint8_t res = FAILURE;
	uint8_t buf_index;
	uint8_t *buf;

	if(TRUE == status)
	{
		/* Get the USB buffer Index */
		buf_index = (USB_TX_DATA - START_BUF512BIT) * BUF512BITSIZE;
		buf = (uint8_t *)&dl_buf[buf_index * BUF512BITSIZE];

		/* Call the SDK API for sending the USB packet to terminal*/
		res = SetUSB((int8_t *)buf, BUF512BITSIZE);

		res = SUCCESS;
	}
	return res;
}


/** @brief USB communication status validation
 *
 *  This function validates the USB Communication status.
 *
 *  @param  db_idx [IN]      : USB DB index
 *          comm_status [IN] : USB comm status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_usb_communication_status(uint16_t db_idx, uint8_t comm_status)
{
	if(!((USB_COMM_OK == comm_status) || (USB_COMM_ERROR == comm_status)))
		return FAILURE;

	return SUCCESS;
}

/** @brief USB communication rx buffer status validation
 *
 *  This function validates the USB Rx buffer status validation.
 *
 *  @param  db_idx [IN]      : USB DB index
 *          status [IN]      : USB rx status for sending packet
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_usb_rxbuf_status(uint16_t db_idx, uint8_t status)
{
#if 0
	uint8_t res = FAILURE;
	uint16_t buf_index;
	uint8_t *buf;
#endif

	if((RX_MSG_PENDING == status) && (RX_MSF_EMPTY == status))
		return FAILURE;

	return SUCCESS;
}
#endif	//SDK_SERVICE_USB

#if (SDK_SERVICE_EEPROM == PS_ENABLE)
/** @brief Validate EEPROM read status
 *
 *  This function validates the EEPROM read status.
 *
 *  @param  db_idx 		 [IN] : DB Index
 *          stream_state [IN] : EEPROM Read Status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_eeprom_read_status(uint16_t db_idx, uint8_t status)
{
	if(!((INVALID_EE_DATA == status) || (VALID_EE_DATA == status) ||
			(VALID_EE_DEFAULT == status) || (EEPROM_FAILURE_RETRY == status)))
		return FAILURE;

	return SUCCESS;
}

/** @brief Validate EEPROM write status
 *
 *  This function validates the EEPROM write status.
 *
 *  @param  db_idx 		 [IN] : DB Index
 *          stream_state [IN] : EEPROM write Status
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_eeprom_write_status(uint16_t db_idx, uint8_t status)
{
	if(!((INVALID_EE_DATA == status) || (VALID_EE_DATA == status) ||
			(VALID_EE_DEFAULT == status) || (EEPROM_FAILURE_RETRY == status)))
		return FAILURE;

	return SUCCESS;
}

#endif	//SDK_SERVICE_EEPROM

#if (SDK_SERVICE_CAMERA == PS_ENABLE)

/** @brief Camera Stream mode validation
 *
 *  This function validates the camera streaming mode.
 *
 *  @param  db_idx 		 [IN] : DB Index
 *          stream_state [IN] : Camera Stream State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_camera_stream_mode(uint16_t db_idx, uint8_t stream_state)
{

	if ((FULL_SCREEN_ON != stream_state) && (RESIZE_TO_FULL_SCREEN_ON != stream_state) &&
			(DISPLAY_AS_IT_IS_ON != stream_state))
		return FAILURE;

	return SUCCESS;
}

/** @brief Camera Stream state validation
 *
 *  This function validates the camera streaming.
 *
 *  @param  db_idx 		 [IN] : DB Index
 *          stream_state [IN] : Camera Stream State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_camera_stream_state(uint16_t db_idx, uint8_t stream_state)
{
	uint8_t  cbuf[STREAM_MODE+1];
	uint8_t  fbuf[2];
	uint8_t  stream_mode;

	if ((CAMERA_STREAM_ON != stream_state) &&
			(CAMERA_STREAM_OFF != stream_state))
		return FAILURE;

	/* Clear the buffer memory */
	memset(&cbuf[0], 0x00, sizeof(cbuf));
	VideoStandardID();
if (bVidDet_PAL)
{
	/* Get the X0 Camera Origin for grapping the image */
	Get_DL(PAL_CAMERA_X0_ORIGIN, (uint8_t *)&cbuf[CAMERA_X_ORG_INDEX]);

	/* Get the Y0 Camera Origin for grapping the image*/
	Get_DL(PAL_CAMERA_Y0_ORIGIN, (uint8_t *)&cbuf[CAMERA_Y_ORG_INDEX]);

	/* Get the Width */
	Get_DL(PAL_CAMERA_X0_WIDTH, (uint8_t *)&cbuf[CAMERA_WIDTH_INDEX]);

	/* Get the Height */
	Get_DL(PAL_CAMERA_Y0_HEIGHT, (uint8_t *)&cbuf[CAMERA_HEIGHT_INDEX]);
} else
{
	/* Get the X0 Camera Origin for grapping the image */
	Get_DL(NTSC_CAMERA_X0_ORIGIN, (uint8_t *)&cbuf[CAMERA_X_ORG_INDEX]);

	/* Get the Y0 Camera Origin for grapping the image*/
	Get_DL(NTSC_CAMERA_Y0_ORIGIN, (uint8_t *)&cbuf[CAMERA_Y_ORG_INDEX]);

	/* Get the Width */
	Get_DL(NTSC_CAMERA_X0_WIDTH, (uint8_t *)&cbuf[CAMERA_WIDTH_INDEX]);

	/* Get the Height */
	Get_DL(NTSC_CAMERA_Y0_HEIGHT, (uint8_t *)&cbuf[CAMERA_HEIGHT_INDEX]);
};
	/* Get the Mode */
	Get_DL(CAMERA_VIDEO_MODE, (uint8_t *)&stream_mode);

	/* Validate the RESIZE full screen configuration */
	if (RESIZE_TO_FULL_SCREEN_ON == stream_mode)
	{
		/* Validate the Height */
		if ((RESIZE_WIDTH_TO_480  != (*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX])) &&
			(RESIZE_WIDTH_TO_240  != (*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX])) &&
			(RESIZE_WIDTH_TO_120  != (*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX])) &&
			(RESIZE_WIDTH_TO_60   != (*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX])))
		{
			return FAILURE;
		}

		/* Validate the Width */
		if ((RESIZE_HEIGTH_TO_136 != (*(uint16_t *)&cbuf[CAMERA_HEIGHT_INDEX])) &&
			(RESIZE_HEIGTH_TO_68  != (*(uint16_t *)&cbuf[CAMERA_HEIGHT_INDEX])) &&
			(RESIZE_HEIGTH_TO_34  != (*(uint16_t *)&cbuf[CAMERA_HEIGHT_INDEX])))
		{
			return FAILURE;
		}

		/* Validate the X0 Origin */
		if ((CAMERA_RESOlUTION_X0 - (*(uint16_t *)&cbuf[CAMERA_X_ORG_INDEX])) <
				(*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX]))
		{
			return FAILURE;
		}

		/* Validate the Y0 Origin */
		if ((CAMERA_RESOlUTION_Y0 - (*(uint16_t *)&cbuf[CAMERA_Y_ORG_INDEX])) <
				(*(uint16_t *)&cbuf[CAMERA_HEIGHT_INDEX]))
		{
			return FAILURE;
		}
	}
	else
	/* Validate the DISPLAY_AS_IT_IS_ON configuration */
	if (DISPLAY_AS_IT_IS_ON == stream_mode)
	{

		/* Get the X0 Display Origin */
		Get_DL(DISPLAY_X0_ORIGIN, (uint8_t *)&cbuf[DISPLAY_X_ORG_INDEX]);

		/* Get the Y0 Display Origin */
		Get_DL(DISPLAY_Y0_ORIGIN, (uint8_t *)&cbuf[DISPLAY_Y_ORG_INDEX]);

		/* Validate the X0 Camera Boundary */
		if (((*(uint16_t *)&cbuf[CAMERA_X_ORG_INDEX]) +
				(*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX])) > CAMERA_RESOlUTION_X0)
		{
//			return FAILURE;
		}

		/* Validate the Y0 Boundary */
		if (((*(uint16_t *)&cbuf[CAMERA_Y_ORG_INDEX]) +
				(*(uint16_t *)&cbuf[CAMERA_HEIGHT_INDEX])) > CAMERA_RESOlUTION_Y0)
		{
//			return FAILURE;
		}

		/* Validate the X0 LCD Boundary */
//		if (((*(uint16_t *)&cbuf[DISPLAY_X_ORG_INDEX]) +
//				(*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX])) > LCD_RESOlUTION_X0)
//		{
//			return FAILURE;
//		}
//
//		/* Validate the Y0 LCD Boundary */
//		if (((*(uint16_t *)&cbuf[DISPLAY_Y_ORG_INDEX]) +
//				(*(uint16_t *)&cbuf[CAMERA_HEIGHT_INDEX])) > CAMERA_RESOlUTION_Y0)
//		{
//			return FAILURE;
//		}
		
		
		/* Validate the X0 LCD Boundary */
//		if (((*(uint16_t *)&cbuf[DISPLAY_X_ORG_INDEX]) +
//				(*(uint16_t *)&cbuf[CAMERA_WIDTH_INDEX])) <= LCD_RESOlUTION_X0)
//		{
//			return FAILURE;
//		}
//
//		if (((*(uint16_t *)&cbuf[DISPLAY_Y_ORG_INDEX]) +
//				(*(uint16_t *)&cbuf[CAMERA_HEIGHT_INDEX])) <= LCD_RESOlUTION_Y0)
//		{
//			return FAILURE;
//		}
		
	}

	/* Get the CAMERA_VIDEO_FLIP_VERTICAL */
	Get_DL(CAMERA_VIDEO_FLIP_VERTICAL, (uint8_t *)&fbuf[0]);

	/* Get the CAMERA_VIDEO_FLIP_HORIZONTAL */
	Get_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, (uint8_t *)&fbuf[1]);

	if(fbuf[0] == FLIP_ENABLE)
	{
		cbuf[DISPLAY_FLIP] = FLIP_VERTICAL;
	}
	else if(fbuf[1] == FLIP_ENABLE)
	{
		cbuf[DISPLAY_FLIP] = FLIP_HORIZONTAL;
	}

	if((fbuf[0] == FLIP_ENABLE) && (fbuf[1] == FLIP_ENABLE))
	{
		cbuf[DISPLAY_FLIP] = FLIP_VERTICAL;
	}
	else if((fbuf[0] == FLIP_DISABLE) && (fbuf[1] == FLIP_DISABLE))
	{
		cbuf[DISPLAY_FLIP] = FLIP_OFF;
	}

	cbuf[STREAM_MODE] = stream_state;

	/* Call the SDK API for sending the information to PS */
	SetCam(stream_mode, &cbuf[0]);

	return SUCCESS;
}

/** @brief Camera Flip state validation
 *
 *  This function validates the camera flip state.
 *
 *  @param  db_idx 		 [IN] : DB Index
 *          flip_state   [IN] : Camera Flip State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_flip_state(uint16_t db_idx, uint8_t flip_state)
{
	/* Check Stream State value */
	if ((FLIP_ENABLE != flip_state) && (FLIP_DISABLE != flip_state))
		return FAILURE;

	return SUCCESS;
}

#endif	//SDK_SERVICE_CAMERA

#if (THROUGH_PUT_SERVICE == PS_ENABLE)

/** @brief Percentage Time validation
 *
 *  This function validates the Percentage Time.
 *
 *  @param  db_idx 	[IN] : DB Index
 *          p_time  [IN] : Percentage Time
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_percentage_time(uint16_t db_idx ,uint8_t p_time)
{
	return SUCCESS;
}
#endif	//THROUGH_PUT_SERVICE

#if (SDK_SERVICE_FDCAN == PS_ENABLE)

/** @brief FDCAN mode validation
 *
 *  This function validates the fdcan mode.
 *
 *  @param  index_number 	[IN] : DB Index
 *          mode   			[IN] : FDCAN Mode
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_fdcan_mode(uint16_t index_number ,uint8_t mode)
{
	uint8_t can_buf[4] = {0};

	if ((CAN_MODE_STANDARD_ID != mode) && (CAN_MODE_EXTENDED_ID != mode))
		return FAILURE;

	switch(index_number+1)
	{
		case CAN_CH0_MODE:

			Get_DL(CAN_CH0_FILTER_INDEX_ENABLE, &can_buf[0]);
			if(ENABLE == can_buf[0])
			{
				Get_DL(CAN_CH0_FILTER_INDEX_ID, &can_buf[1]);
				can_buf[2] = mode;

				ActCAN(FDCAN_1, SET_FILTER_INDEX_ENABLE, &can_buf[0]);
			}
			break;

		case CAN_CH1_MODE:

			Get_DL(CAN_CH1_FILTER_INDEX_ENABLE, &can_buf[0]);
			if(ENABLE == can_buf[0])
			{
				Get_DL(CAN_CH1_FILTER_INDEX_ID, &can_buf[1]);
				can_buf[2] = mode;

				ActCAN(FDCAN_2, SET_FILTER_INDEX_ENABLE, &can_buf[0]);
			}
			break;
	}

	return SUCCESS;
}

/** @brief FDCAN filter index validation
 *
 *  This function validates the fdcan filter index.
 *
 *  @param  index_number 	[IN] : DB Index
 *          range   		[IN] : FDCAN range
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_filter_index(uint16_t index_number ,uint8_t range)
{
	if(!((ENABLE == range) || (DISABLE == range)))
		return FAILURE;

	return SUCCESS;
}

/** @brief can state
 *
 *  This function validates the can state.
 *
 *  @param  idx_num 	[IN] : DB Index
 *          state  		[IN] : FDCAN state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_can_state(uint16_t idx_num ,uint8_t state)
{
	if(!((CAN_BUS_OFF == state) || (CAN_BUS_ON == state) ||
			(CAN_STATE_PASSIVE == state) || (CAN_STATE_UNCHANGED == state)))
		return FAILURE;

	return SUCCESS;
}

/** @brief can communication state
 *
 *  This function validates the can communication state.
 *
 *  @param  idx_num 	[IN] : DB Index
 *          state  		[IN] : FDCAN state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_can_comm_state(uint16_t idx_num ,uint8_t state)
{
	if(!((STATE_EVENT_NONE == state) ||
			(STATE_EVENT_BUS_OFF == state) ||
			(STATE_EVENT_BUS_OFF_RECOVERY == state) ||
			(STATE_EVENT_BUS_ON == state) ||
			(STATE_EVENT_PASSIVE == state) ||
			(STATE_EVENT_ACTIVE == state) ||
			(STATE_EVENT_OVERRUN == state) ||
			(STATE_EVENT_QUEUE_FULL == state) ||
			(STATE_EVENT_QUEUE_OVERFLOW == state) ||
			(STATE_EVENT_QUEUE_EMPTY == state) ||
			(STATE_EVENT_DRIVER_ERROR == state)))
		return FAILURE;

	return SUCCESS;
}

/** @brief FDCAN Reset
 *
 *  This function validates the fdcan reset state.
 *
 *  @param  idx_num 	[IN] : DB Index
 *          state  		[IN] : FDCAN state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_can_reset(uint16_t idx_num ,uint8_t state)
{
	uint8_t can_buf[2] = {0};

	switch(idx_num+1)
	{
		case CAN_CH0_RESET:

			if(!((TRUE == state) || (FALSE == state)))
				return FAILURE;

			can_buf[0] = state;
			ActCAN(FDCAN_1, SET_FDCAN_RESET, can_buf);
			break;

		case CAN_CH1_RESET:

			if(!((TRUE == state) || (FALSE == state)))
				return FAILURE;

			can_buf[0] = state;
			ActCAN(FDCAN_2, SET_FDCAN_RESET, can_buf);
			break;

		case CAN_CH0_DRIVER_RESET:

			if(!((TRUE == state) || (FALSE == state)))
				return FAILURE;

			can_buf[0] = state;
			ActCAN(FDCAN_1, SET_FDCAN_DRIVER_RESET, can_buf);
			break;

		case CAN_CH1_DRIVER_RESET:

			if(!((TRUE == state) || (FALSE == state)))
				return FAILURE;

			can_buf[0] = state;
			ActCAN(FDCAN_2, SET_FDCAN_DRIVER_RESET, can_buf);
			break;
	}

	return SUCCESS;
}

/** @brief FDCAN Byte Count
 *
 *  This function validates the fdcan byte count.
 *
 *  @param  idx_num 	[IN] : DB Index
 *          state  		[IN] : FDCAN state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_can_byte_count(uint16_t idx_num ,uint8_t count_val)
{
	if(!((MIN_BYTE_VAL <= count_val) || (MAX_BYTE_VAL >= count_val)))
		return FAILURE;

	return SUCCESS;
}

/** @brief CAN data available
 *
 *  This function validates the can data available state.
 *
 *  @param  idx_num 	[IN] : DB Index
 *          state  		[IN] : can data available state
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_can_data_available(uint16_t idx_num ,uint8_t state)
{
	if(!((TRUE == state) || (FALSE == state)))
		return FAILURE;

	return SUCCESS;
}

/** @brief CAN data size
 *
 *  This function validates the can data size.
 *
 *  @param  idx_num 	[IN] : DB Index
 *          size  		[IN] : can data size
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_can_data_size(uint16_t idx_num ,uint8_t size)
{
	if(!((MIN_DATA_VAL <= size) || (MAX_DATA_VAL >= size)))
		return FAILURE;

	return SUCCESS;
}

/** @brief CAN BaudRate
 *
 *  This function validates the can BaudRate.
 *
 *  @param  idx_num 	[IN] : DB Index
 *          size  		[IN] : can baudrate
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_can_baudrate(uint16_t idx_num ,uint8_t baudrate)
{
	uint8_t can_buf[2] = {0};

	switch(idx_num+1)
	{
		case CAN_CH0_BAUDRATE:

			if(!((BAUDRATE_50K == baudrate) || (BAUDRATE_100K == baudrate) ||
					(BAUDRATE_125K == baudrate) || (BAUDRATE_250K == baudrate) ||
					(BAUDRATE_500K == baudrate) || (BAUDRATE_1000K == baudrate)))
				return FAILURE;

			can_buf[0] = baudrate;
			ActCAN(FDCAN_1, SET_FDCAN_BAUDRATE, can_buf);
			break;

		case CAN_CH1_BAUDRATE:

			if(!((BAUDRATE_100K == baudrate) || (BAUDRATE_100K == baudrate) ||
					(BAUDRATE_125K == baudrate) || (BAUDRATE_250K == baudrate) ||
					(BAUDRATE_500K == baudrate) || (BAUDRATE_1000K == baudrate)))
				return FAILURE;

			can_buf[0] = baudrate;
			ActCAN(FDCAN_2, SET_FDCAN_BAUDRATE, can_buf);
			break;
	}

	return SUCCESS;
}

#endif	//SDK_SERVICE_FDCAN

/** @brief Dummy Field validation
 *
 *  This function validates the dummy field in the DB.
 *
 *  @param  dummy1 [IN] : Not used
 *          dummy2 [IN] : Not used
 *
 *  @return 0 : FAILURE
 *
 */
int8_t validate_dummy_field(uint16_t dummy1, uint8_t dummy2)
{
	return FAILURE;
}

/** @brief PS Init validation
 *
 *  This function validates the PS Init state in the DB field.
 *
 *  @param  wl_state [IN]     : wl_state
 *          wl_state_val [IN] : TRUE/FALSE
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_ps_init_state(uint16_t wl_state, uint8_t wl_state_val)
{
	if(!((TRUE == wl_state_val) || (FALSE == wl_state_val)))
		return FAILURE;

	pv.isPSUP = wl_state_val;

	return SUCCESS;
}

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
