/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DL_jU8_Validation.c
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 24/05/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Data Layer j1939 unsigned 8 bits field validation function

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             24/05/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../Maximatecc/Inc/Data_Layer.h"
#include "../Inc/Common.h"
#include "../Inc/Dl_jU8_Validation.h"
/* USER CODE END Includes */

/* USER CODE BEGIN Global Variables */
/* USER CODE END Includes */

int8_t (*dl_ju8_func [(END_J1939U8BIT - 1) - START_J1939U8BIT])(uint16_t, uint8_t);

extern pvt_variable pv;
/* USER CODE END Global Variables */

/** @brief DB Validation function
 *
 *  This function initialize the DB Validation function for the each
 *  j1939 unsinged 8 bits field.
 *
 *  @param  None
 *
 *  @return None
 *
 */
void DB_ju8_Field_Validation_Reg(void)
{
	/* Clear the Callback memory */
	memset (&dl_ju8_func[0], 0x00, ((END_J1939U8BIT - 1) - START_J1939U8BIT));

#if (SDK_SERVICE_J1939 == PS_ENABLE)
    /* ECU_INSTANCE_60920 Validation */
	dl_ju8_func[ECU_INSTANCE_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* FUNCTION_INSTANCE_60920 Validation */
	dl_ju8_func[FUNCTION_INSTANCE_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* FUNCATION_60920 Validation */
	dl_ju8_func[FUNCATION_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* RESERVED_60920 Validation */
	dl_ju8_func[RESERVED_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* VEHICLE_SYSTEM_60920 Validation */
	dl_ju8_func[VEHICLE_SYSTEM_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* VEHICAL_SYSTEAM_INSTANCE_60920 Validation */
	dl_ju8_func[VEHICAL_SYSTEAM_INSTANCE_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* INDUSTRY_GROUP_60920 Validation */
	dl_ju8_func[INDUSTRY_GROUP_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ADD_CLAIMING_SUPPORT_60920 Validation */
	dl_ju8_func[ADD_CLAIMING_SUPPORT_60920 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ENGINE_COOLENT_TEMP Validation */
	dl_ju8_func[ENGINE_COOLANT_TEMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ENGINE_FULE_1_TEMP_1 Validation */
	dl_ju8_func[ENGINE_FUEL_1_TEMP_1 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ENGINE_INTERCOOLER_TEMP Validation */
	dl_ju8_func[ENGINE_INTERCOOLER_TEMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ENGINE_AIR_COOLER_THERMOSTAT Validation */
	dl_ju8_func[ENGINE_AIR_COOLER_THERMOSTAT - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ECU_INSTANCE_60928 Validation */
	dl_ju8_func[ECU_INSTANCE_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* FUNCTION_INSTANCE_60928 Validation */
	dl_ju8_func[FUNCTION_INSTANCE_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* FUNCATION_60928 Validation */
	dl_ju8_func[FUNCATION_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* RESERVED_60928 Validation */
	dl_ju8_func[RESERVED_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* VEHICLE_SYSTEM_60928 Validation */
	dl_ju8_func[VEHICLE_SYSTEM_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* VEHICAL_SYSTEAM_INSTANCE_60928 Validation */
	dl_ju8_func[VEHICAL_SYSTEAM_INSTANCE_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* INDUSTRY_GROUP_60928 Validation */
	dl_ju8_func[INDUSTRY_GROUP_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ADD_CLAIMING_SUPPORT_60928 Validation */
	dl_ju8_func[ADD_CLAIMING_SUPPORT_60928 - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_PROTECT_LAMP Validation */
	dl_ju8_func[DM1_PROTECT_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_AMBER_WARN_LAMP Validation */
	dl_ju8_func[DM1_AMBER_WARN_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_RED_STOP_LAMP Validation */
	dl_ju8_func[DM1_RED_STOP_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_MAL_FUNC_IND_LAMP Validation */
	dl_ju8_func[DM1_MAL_FUNC_IND_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FLASH_PROT_LAMP Validation */
	dl_ju8_func[DM1_FLASH_PROT_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FLASH_AMBER_WARN_LAMP Validation */
	dl_ju8_func[DM1_FLASH_AMBER_WARN_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FLASH_MAL_FUNC_IND_LAMP Validation */
	dl_ju8_func[DM1_FLASH_MAL_FUNC_IND_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FMI Validation */
	dl_ju8_func[DM1_FMI - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_SPN_CONV_METHOD Validation */
	dl_ju8_func[DM1_SPN_CONV_METHOD - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_OC Validation */
	dl_ju8_func[DM1_OC - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_PROTECT_LAMP Validation */
	dl_ju8_func[DM2_PROTECT_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_AMBER_WARN_LAMP Validation */
	dl_ju8_func[DM2_AMBER_WARN_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_RED_STOP_LAMP Validation */
	dl_ju8_func[DM2_RED_STOP_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_MAL_FUNC_IND_LAMP Validation */
	dl_ju8_func[DM2_MAL_FUNC_IND_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FLASH_PROT_LAMP Validation */
	dl_ju8_func[DM2_FLASH_PROT_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FLASH_AMBER_WARN_LAMP Validation */
	dl_ju8_func[DM2_FLASH_AMBER_WARN_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FLASH_MAL_FUNC_IND_LAMP Validation */
	dl_ju8_func[DM2_FLASH_MAL_FUNC_IND_LAMP - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_FMI Validation */
	dl_ju8_func[DM2_FMI - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_SPN_CONV_METHOD Validation */
	dl_ju8_func[DM2_SPN_CONV_METHOD - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* DM_OC Validation */
	dl_ju8_func[DM2_OC - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ENGFUELDELIVERYPRESS Validation */
	dl_ju8_func[ENGFUELDELIVERYPRESS - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ENGINEOILLEVEL Validation */
	dl_ju8_func[ENGINEOILLEVEL - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* ENGINEOILPRESSURE Validation */
	dl_ju8_func[ENGINEOILPRESSURE - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* COOLANTPRESSURE Validation */
	dl_ju8_func[COOLANTPRESSURE - (START_J1939U8BIT + 1)] = validate_j1939_u8_variable;

    /* SEND_CAN0_DM1 Validation */
	dl_ju8_func[SEND_CAN0_DM1 - (START_J1939U8BIT + 1)] = validate_diagnostic_messages;

    /* SEND_CAN1_DM1 Validation */
	dl_ju8_func[SEND_CAN1_DM1 - (START_J1939U8BIT + 1)] = validate_diagnostic_messages;

    /* SEND_CAN0_DM2 Validation */
	dl_ju8_func[SEND_CAN0_DM2 - (START_J1939U8BIT + 1)] = validate_diagnostic_messages;

    /* SEND_CAN1_DM2 Validation */
	dl_ju8_func[SEND_CAN1_DM2 - (START_J1939U8BIT + 1)] = validate_diagnostic_messages;

    /* SEND_CAN0_DM3 Validation */
	dl_ju8_func[SEND_CAN0_DM3 - (START_J1939U8BIT + 1)] = validate_diagnostic_messages;

    /* SEND_CAN1_DM3 Validation */
	dl_ju8_func[SEND_CAN1_DM3 - (START_J1939U8BIT + 1)] = validate_diagnostic_messages;

#endif	//SDK_SERVICE_J1939

}


#if (SDK_SERVICE_J1939 == PS_ENABLE)
/** @brief validation j1939 variable
 *
 *  This function validates the j1939 variable.
 *
 *  @param  db_idx [IN]  : DB Field
 *          val    [IN]  : variable val
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_j1939_u8_variable(uint16_t db_idx, uint8_t val)
{
	return SUCCESS;
}

/** @brief validation j1939 diagnostic messages
 *
 *  This function validates the j1939 diagnostic messages.
 *
 *  @param  db_idx [IN]  : DB Field
 *          val    [IN]  : variable val
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_diagnostic_messages(uint16_t db_idx, uint8_t val)
{
	uint8_t can_add[2] = {0};

	if(db_idx == (SEND_CAN0_DM1 - (START_J1939U8BIT + 1)))
	{
		Get_DL(CAN0_DEST_ADD, (uint8_t *)&can_add);

		Setj1939(CAN0_DM1, (uint8_t *)&can_add);
	}
	else if(db_idx == (SEND_CAN1_DM1 - (START_J1939U8BIT + 1)))
	{
		Get_DL(CAN1_DEST_ADD, (uint8_t *)&can_add);

		Setj1939(CAN1_DM1, (uint8_t *)&can_add);
	}
	else if(db_idx == (SEND_CAN0_DM2 - (START_J1939U8BIT + 1)))
	{
		Get_DL(CAN0_DEST_ADD, (uint8_t *)&can_add);

		Setj1939(CAN0_DM2, (uint8_t *)&can_add);
	}
	else if(db_idx == (SEND_CAN1_DM2 - (START_J1939U8BIT + 1)))
	{
		Get_DL(CAN1_DEST_ADD, (uint8_t *)&can_add);

		Setj1939(CAN1_DM2, (uint8_t *)&can_add);
	}
	else if(db_idx == (SEND_CAN0_DM3 - (START_J1939U8BIT + 1)))
	{
		Get_DL(CAN0_DEST_ADD, (uint8_t *)&can_add);

		Setj1939(CAN0_DM3, (uint8_t *)&can_add);
	}
	else if(db_idx == (SEND_CAN1_DM3 - (START_J1939U8BIT + 1)))
	{
		Get_DL(CAN1_DEST_ADD, (uint8_t *)&can_add);

		Setj1939(CAN1_DM3, (uint8_t *)&can_add);
	}

	return SUCCESS;
}

#endif	//SDK_SERVICE_J1939
