/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Data_Layer.h
   Author             : Jonathan Serrano
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : Header File.
   Environment        : Independant
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

		General File Description
-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.0              06/25/2020          Jonathan Serrano
   0.0.0.1              21/01/2022          Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

START_J1939U8BIT = END_BUF512BIT+1,
ECU_INSTANCE_60920,
FUNCTION_INSTANCE_60920,
FUNCATION_60920,
RESERVED_60920,
VEHICLE_SYSTEM_60920,
VEHICAL_SYSTEAM_INSTANCE_60920,
INDUSTRY_GROUP_60920,
ADD_CLAIMING_SUPPORT_60920,
ENGINE_COOLANT_TEMP,
ENGINE_FUEL_1_TEMP_1,
ENGINE_INTERCOOLER_TEMP,
ENGINE_AIR_COOLER_THERMOSTAT,
ECU_INSTANCE_60928,
FUNCTION_INSTANCE_60928,
FUNCATION_60928,
RESERVED_60928,
VEHICLE_SYSTEM_60928,
VEHICAL_SYSTEAM_INSTANCE_60928,
INDUSTRY_GROUP_60928,
ADD_CLAIMING_SUPPORT_60928,
DM1_PROTECT_LAMP,
DM1_AMBER_WARN_LAMP,
DM1_RED_STOP_LAMP,
DM1_MAL_FUNC_IND_LAMP,
DM1_FLASH_PROT_LAMP,
DM1_FLASH_AMBER_WARN_LAMP,
DM1_FLASH_RED_STOP_LAMP,
DM1_FLASH_MAL_FUNC_IND_LAMP,
DM1_FMI,
DM1_SPN_CONV_METHOD,
DM1_OC,
DM2_PROTECT_LAMP,
DM2_AMBER_WARN_LAMP,
DM2_RED_STOP_LAMP,
DM2_MAL_FUNC_IND_LAMP,
DM2_FLASH_PROT_LAMP,
DM2_FLASH_AMBER_WARN_LAMP,
DM2_FLASH_RED_STOP_LAMP,
DM2_FLASH_MAL_FUNC_IND_LAMP,
DM2_FMI,
DM2_SPN_CONV_METHOD,
DM2_OC,
ENGFUELDELIVERYPRESS,
ENGINEOILLEVEL,
ENGINEOILPRESSURE,
COOLANTPRESSURE,

SEND_CAN0_DM1,
SEND_CAN1_DM1,
SEND_CAN0_DM2,
SEND_CAN1_DM2,
SEND_CAN0_DM3,
SEND_CAN1_DM3,

/*	ENGINE_FLUID_PRESSURE_LEVEL	*/
ENGINE_FUEL_DELIVERY_PRESSURE,		//94
ENGINE_EXTENDED_CRANKCASE_BLOW_BY_PRESSURE,	//22
ENGINE_OIL_LEVEL,		//98
ENGINE_OIL_PRESSURE_1,	//100
ENGINE_COOLANT_PRESSURE_1,		//109
ENGINE_COOLANT_LEVEL_1,			//111

/*	ELECTRONIC_ENGINE_CONTROLLER_1	*/
ENGINE_TORQUE_MODE,			//899
ACTUAL_ENGINE_PERCENT_TORQUE_FRACTIONAL,	//4154
DRIVERS_DEMAND_ENGINE_PERCENT_TORQUE,	//512
ACTUAL_ENGINE_PERCENT_TORQUE,	//513
SOURCE_ADDRESS_OF_DEVICE_ENGINE_CONTROL,	//1483
ENGINE_STARTER_MODE,		//1675
ENGINE_DEMAND_PERCENT_TORQUE,	//2432




/* After treatment 1 Diesel Exhaust Fluid Tank 1 Information(AT1T1I1) */
AFTERTREATMENT_1_DIESEL_EXHAUST_FLUID_TANK_VOLUME,		//1761
AFTERTREATMENT_1_DIESEL_EXHAUST_FLUID_TANK_TEMPERATURE_1,	//3031
AFTERTREATMENT_1_DIESEL_EXHAUST_FLUID_TANK_LEVEL_VOLUME_PRELIMINARY_FMI,	//3532
AFTERTREATMENT_DIESEL_EXHAUST_FLUID_TANK_LOW_LEVEL_INDICATOR,	//5245
AFTERTREATMENT_1_DIESEL_EXHAUST_FLUID_TANK_1_TEMPERATURE_PRELIMINARY_FMI,	//4365
AFTERTREATMENT_SCR_OPERATOR_INDUCEMENT_SEVERITY,	//5246
AFTERTREATMENT_1_DIESEL_EXHAUST_FLUID_TANK_HEATER,	//3363
AFTERTREATMENT_1_DIESEL_EXHAUST_FLUID_TANK_1_HEATER_PRELIMINARY_FMI,	//4366


/*  DASH_DISPLAY */
WASHER_FLUID_LEVEL,		//80
FUEL_LEVEL_1,			//96
ENGINE_FUEL_FILTER_DIFFERENTIAL_PRESSURE,		//95
ENGINE_OIL_FILTER_DIFFERENTIAL_PRESSURE,		//99
FUEL_LEVEL_2,					//38
ENGINE_OIL_FILTER_DIFFERENTIAL_PRESSURE_EXTENDED_RANGE,	//7471



/*  TRANSMISSION_FLUIDS */
TRANSMISSION_CLUTCH_1_PRESSURE,		//123
TRANSMISSION_OIL_LEVEL_1,			//124
TRANSMISSION_FILTER_DIFFERENTIAL_PRESSURE,	//126
TRANSMISSION_1_OIL_PRESSURE,		//127
TRANSMISSION_OIL_LEVEL_1_HIGH_LOW,	//3027
TRANSMISSION_OIL_LEVEL_1_COUNTDOWN_TIMER,	//3028
TRANSMISSION_OIL_LEVEL_1_MEASUREMENT_STATUS,	//3026



/* DIRECT_LAMP_CONTROL_COMMAND_2 */
VEHICLE_BATTERY_VOLTAGE_LOW_LAMP_COMMAND,	//5087
VEHICLE_FUEL_LEVEL_LOW_LAMP_COMMAND,		//5088
VEHICLE_AIR_PRESSURE_LOW_LAMP_COMMAND,		//5089
VEHICLE_HVAC_RECIRCULATION_LAMP_COMMAND,	//5090
VEHICLE_BATTERY_CHARGING_LAMP_COMMAND,		//5091
HILL_HOLDER_LAMP_COMMAND,					//1847
VEHICLE_LIMITED_PERFORMANCE_MODE_LAMP_COMMAND,	//10295





/* FAN_DRIVE */
ENGINE_FAN_1_ESTIMATED_PERCENT_SPEED,	//975
FAN_DRIVE_STATE,						//977
FAN_DRIVE_BYPASS_COMMAND_STATUS,		//4212


/* DIRECT_LAMP_CONTROL_COMMAND_1 */
ENGINE_PROTECT_LAMP_COMMAND,			//5077
ENGINE_AMBER_WARNING_LAMP_COMMAND,		//5078
ENGINE_RED_STOP_LAMP_COMMAND,			//5079
OBD_MALFUNCTION_INDICATOR_LAMP_COMMAND,	//5080
ENGINE_BRAKE_ACTIVE_LAMP_COMMAND,		//5081
COMPRESSION_BRAKE_ENABLE_SWITCH_INDICATOR_LAMP_COMMAND,	//3987
ENGINE_OIL_PRESSURE_LOW_LAMP_COMMAND,	//5082
ENGINE_COOLANT_TEMPERATURE_HIGH_LAMP_COMMAND,	//5083
ENGINE_COOLANT_LEVEL_LOW_LAMP_COMMAND,	//5084
ENGINE_IDLE_MANAGEMENT_ACTIVE_LAMP_COMMAND,	//5085
ENGINE_AIR_FILTER_RESTRICTION_LAMP_COMMAND,	//5086
ENGINE_FUEL_FILTER_RESTRICTED_LAMP_COMMAND,	//5469
ENGINE_CONTROL_MODULE_1_LAMP_COMMAND,		//6205
ENGINE_CONTROL_MODULE_2_LAMP_COMMAND,		//6206
ENGINE_CONTROL_MODULE_3_LAMP_COMMAND,		//6207
ENGINE_SPEED_HIGH_LAMP_COMMAND,				//6709
ENGINE_SPEED_VERY_HIGH_LAMP_COMMAND,		//6710
VEHICLE_ACCELERATION_RATE_LIMIT_LAMP_COMMAND,	//6899
ENGINE_IDLE_MANAGEMENT_PENDING_EVENT_LAMP_COMMAND,	//9372
ENGINE_STOP_START_AUTOMATIC_STOP_ACTIVE_LAMP_COMMAND,	//9683
ENGINE_STOP_START_AUTOMATIC_START_FAILED_LAMP_COMMAND,	//9684
ENGINE_STOP_START_ENABLED_LAMP_COMMAND,				//9685
ENGINE_OIL_TEMPERATURE_HIGH_LAMP_COMMAND,			//13105
ENGINE_FUEL_TEMPERATURE_HIGH_LAMP_COMMAND,			//13106
ENGINE_INTERCOOLER_TEMPERATURE_HIGH_LAMP_COMMAND,	//13107
ENGINE_AIR_SHUTOFF_LAMP_COMMAND,					//13379
ENGINE_SERVICE_LAMP_COMMAND,						//21788


/* VEHICLE_FLUIDS */
HYDRAULIC_TEMPERATURE,		//1638
HYDRAULIC_OIL_FILTER_RESTRICTION_SWITCH,	//1713
WINCH_OIL_PRESSURE_SWITCH,		//1857
HYDRAULIC_OIL_LEVEL,			//2602


/* ALTERNATOR_INFORMATION */
ALTERNATOR_1_STATUS,	//3353
ALTERNATOR_2_STATUS,	//3354
ALTERNATOR_3_STATUS,	//3355
ALTERNATOR_4_STATUS,	//3356


/* SHUTDOWN */
ENGINE_IDLE_SHUTDOWN_HAS_SHUTDOWN_ENGINE,	//593
ENGINE_IDLE_SHUTDOWN_DRIVER_ALERT_MODE,		//594
ENGINE_IDLE_SHUTDOWN_TIMER_OVERRIDE,		//592
ENGINE_IDLE_SHUTDOWN_TIMER_STATE,			//590
ENGINE_IDLE_SHUTDOWN_TIMER_FUNCTION,		//591
AC_HIGH_PRESSURE_FAN_SWITCH,				//985
REFRIGERANT_LOW_PRESSURE_SWITCH,			//875
REFRIGERANT_HIGH_PRESSURE_SWITCH,			//605
ENGINE_WAIT_TO_START_LAMP,					//1081
ENGINE_PROTECTION_SYSTEM_HAS_SHUTDOWN_ENGINE,	//1110
ENGINE_PROTECTION_SYSTEM_APPROACHING_SHUTDOWN,	//1109
ENGINE_PROTECTION_SYSTEM_TIMER_OVERRIDE,		//1108
ENGINE_PROTECTION_SYSTEM_TIMER_STATE,			//1107
ENGINE_PROTECTION_SYSTEM_CONFIGURATION,			//1111
ENGINE_ALARM_ACKNOWLEDGE,						//2815
ENGINE_ALARM_OUTPUT_COMMAND_STATUS,				//2814
ENGINE_AIR_SHUTOFF_COMMAND_STATUS,				//2813
ENGINE_OVERSPEED_TEST,							//2812
ENGINE_AIR_SHUTOFF_STATUS,						//3667
PTO_SHUTDOWN_HAS_SHUTDOWN_ENGINE,				//5404
COOLANT_LEVEL_ENGINE_PROTECTION_SHUTDOWN_STATUS,	//5566
ENGINE_OIL_PRESSURE_SWITCH,						//8159



/* HYDRAULIC_BRAKING_SYSTEM */
HYDRAULIC_BRAKE_PRESSURE_CIRCUIT_1,		//2580
HYDRAULIC_BRAKE_PRESSURE_CIRCUIT_2,		//2581
HYDRAULIC_BRAKE_PRESSURE_WARNING_STATE_CIRCUIT_1,	//2584
HYDRAULIC_BRAKE_PRESSURE_WARNING_STATE_CIRCUIT_2,	//2585
HYDRAULIC_BRAKE_PRESSURE_SUPPLY_STATE_CIRCUIT_1,	//2582
HYDRAULIC_BRAKE_PRESSURE_SUPPLY_STATE_CIRCUIT_2,	//2583
HYDRAULIC_BRAKE_SYSTEM_AUDIBLE_WARNING_COMMAND,		//2930
HYDRAULIC_BRAKE_FLUID_LEVEL_SWITCH,					//2931



/* LIGHTING_COMMAND */
DAYTIME_RUNNING_LIGHTS_COMMAND,
ALTERNATE_HEADLIGHTS_COMMAND,
LOW_BEAM_HEADLIGHTS_COMMAND,
HIGH_BEAM_HEADLIGHTS_COMMAND,
TRACTOR_FRONT_FOG_LIGHTS_COMMAND,
ROTATING_BEACON_LIGHT_COMMAND,
RIGHT_TURN_SIGNAL_LIGHTS_COMMAND,
LEFT_TURN_SIGNAL_LIGHTS_COMMAND,
BACK_UP_LIGHTS_AND_ALARM_HORN_COMMAND,
CENTER_STOP_LIGHTS_COMMAND,
RIGHT_STOP_LIGHTS_COMMAND,
LEFT_STOP_LIGHTS_COMMAND,
IMPLEMENT_CLEARANCE_LIGHTS_COMMAND,
TRACTOR_CLEARANCE_LIGHTS_COMMAND,
IMPLEMENT_MARKER_LIGHTS_COMMAND,
TRACTOR_MARKER_LIGHTS_COMMAND,
REAR_FOG_LIGHTS_COMMAND,
TRACTOR_UNDERSIDE_MOUNTED_WORK_LIGHTS_COMMAND,
TRACTOR_REAR_LOW_MOUNTED_WORK_LIGHTS_COMMAND,
TRACTOR_REAR_HIGH_MOUNTED_WORK_LIGHTS_COMMAND,
TRACTOR_SIDE_LOW_MOUNTED_WORK_LIGHTS_COMMAND,
TRACTOR_SIDE_HIGH_MOUNTED_WORK_LIGHTS_COMMAND,
TRACTOR_FRONT_LOW_MOUNTED_WORK_LIGHTS_COMMAND,
TRACTOR_FRONT_HIGH_MOUNTED_WORK_LIGHTS_COMMAND,
IMPLEMENT_OEM_OPTION_2_LIGHTS_COMMAND,
IMPLEMENT_OEM_OPTION_1_LIGHTS_COMMAND,
IMPLEMENT_RIGHT_FACING_WORK_LIGHTS_COMMAND,
IMPLEMENT_LEFT_FACING_WORK_LIGHTS_COMMAND,
LIGHTING_DATA_MESSAGE_REQUEST_COMMAND,
IMPLEMENT_RIGHT_FORWARD_WORK_LIGHTS_COMMAND,
IMPLEMENT_LEFT_FORWARD_WORK_LIGHTS_COMMAND,
IMPLEMENT_REAR_WORK_LIGHTS_COMMAND,


/* BRAKES_1 */
BRAKE_APPLICATION_PRESSURE,		//116
BRAKE_PRIMARY_PRESSURE,			//117
BRAKE_SECONDARY_PRESSURE,		//118
PARKING_BRAKE_ACTUATOR,			//619
PARKING_BRAKE_RED_WARNING_SIGNAL,	//3557
PARK_BRAKE_RELEASE_INHIBIT_STATUS,	//3808
TOTAL_BRAKE_AXLE_TORQUE,			//21140


/* DIESEL_PARTICULATE_FILTER_CONTROL_1 (DPFC) */
DPF_LAMP_COMMAND,		//3697
DPF_ACTIVE_REGENERATION_AVAILABILITY_STATUS, 	//8857
AFTERTREATMENT_DPF_PASSIVE_REGENERATION_STATUS,  //3699
AFTERTREATMENT_DPF_ACTIVE_REGENERATION_STATUS, 	//3700
AFTERTREATMENT_DPF_STATUS,	//3701
DPF_ACTIVE_REGENERATION_INHIBITED_STATUS,		//3702
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_INHIBIT_SWITCH,	//3703
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_CLUTCH_DISENGAGED,	//3704
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_SERVICE_BRAKE_ACTIVE, //3705
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_PTO_ACTIVE,		//3706
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_ACCELERATOR_PEDAL_OFF_IDLE,	//3707
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_OUT_OF_NEUTRAL,	//3708
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_VEHICLE_SPEED_ABOVE_ALLOWED_SPEED,	//3709
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_PARKING_BRAKE_NOT_SET,	//3710
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_LOW_EXHAUST_TEMPERATURE,	//3711
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_SYSTEM_FAULT_ACTIVE,		//3712
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_SYSTEM_TIMEOUT,		//3713
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_TEMPORARY_SYSTEM_LOCKOUT,	//3714
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_PERMANENT_SYSTEM_LOCKOUT,	//3715
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_ENGINE_NOT_WARMED_UP,	//3716
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_VEHICLE_SPEED_BELOW_ALLOWED_SPEED,	//3717
DPF_AUTOMATIC_ACTIVE_REGENERATION_INITIATION_CONFIGURATION,		//3718
EXHAUST_SYSTEM_HIGH_TEMPERATURE_LAMP_COMMAND,		//3698
DPF_ACTIVE_REGENERATION_FORCED_STATUS,	//4175
HYDROCARBON_DOSER_PURGING_ENABLE,		//5504
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_LOW_EXHAUST_PRESSURE,	//5629
AFTERTREATMENT_1_DPF_CONDITIONS_NOT_MET_FOR_ACTIVE_REGENERATION,	//3750
DPF_ACTIVE_REGENERATION_INHIBITED_DUE_TO_THRESHER,	//10153


/* PGN 61441/0xf001 EBC1 Electronic Brake Controller 1 */
ASR_ENGINE_CONTROL_ACTIVE,	/* ASR Engine Control Active */
ASR_BRAKE_CONTROL_ACTIVE,	/* ASR Brake Control Active */
ANTI_LOCK_BRAKING_ABS_ACTIVE,	/* Anti-Lock Braking (ABS) Active */
EBS_BRAKE_SWITCH,	/* EBS Brake Switch */
BRAKE_PEDAL_POSITION,	/* Brake Pedal Position */
ABS_OFF_ROAD_SWITCH,	/* ABS Off-road Switch */
ASR_OFF_ROAD_SWITCH,	/* ASR Off-road Switch */
ASR_HILL_HOLDER_SWITCH,	/* "ASR ""Hill Holder"" Switch" */
TRACTION_CONTROL_OVERRIDE_SWITCH,	/* Traction Control Override Switch */
ACCELERATOR_INTERLOCK_SWITCH,	/* Accelerator Interlock Switch */
ENGINE_DERATE_SWITCH,	/* Engine Derate Switch */
ENGINE_AUXILIARY_SHUTDOWN_SWITCH, /* Engine Auxiliary Shutdown Switch */
REMOTE_ACCELERATOR_ENABLE_SWITCH, /* Remote Accelerator Enable Switch */
ENGINE_RETARDER_SELECTION,	/* Engine Retarder Selection */
ABS_FULLY_OPERATIONAL,	/* ABS Fully Operational */
EBS_RED_WARNING_SIGNAL,	/* EBS Red Warning Signal */
ABS_EBS_AMBER_WARNING_SIGNAL,	/* ABS/EBS Amber Warning Signal (Powered Vehicle) */
ATC_ASR_INFORMATION_SIGNAL,	/* ATC/ASR Information Signal */
SOURCE_ADDRESS_OF_CONTROLLING_DEVICE_BRAKE_CONTROL,	/* Source Address of Controlling Device for Brake Control */
RAILROAD_MODE_SWITCH,	/* Railroad Mode Switch */
HALT_BRAKE_SWITCH,	/* Halt brake switch */
TRAILER_ABS_STATUS, /* Trailer ABS Status */
TRACTOR_MOUNTED_TRAILER_ABS_WARNING_SIGNAL,	/* Tractor-Mounted Trailer ABS Warning Signal */

/* PGN 64586/0xfc4a SCRSC SCR System Cleaning */
SCR_SYSTEM_CLEANING_LAMP_COMMAND,
SCR_SYSTEM_CLEANING_STATUS,
SCR_SYSTEM_INHIBITED_STATUS,
SCR_SYSTEM_INHIBITED_DUE_TO_INHIBIT_SWITCH,
SCR_SYSTEM_INHIBITED_DUE_TO_CLUTCH_DISENGAGED,
SCR_SYSTEM_INHIBITED_DUE_TO_SERVICE_BRAKE_ACTIVE,
SCR_SYSTEM_INHIBITED_DUE_TO_PTO_ACTIVE,
SCR_SYSTEM_INHIBITED_DUE_TO_ACCELERATOR,
SCR_SYSTEM_INHIBITED_DUE_TO_OUT_OF_NEUTRAL,
SCR_SYSTEM_INHIBITED_DUE_TO_VEHICLE_SPEED,
SCR_SYSTEM_INHIBITED_DUE_TO_PARKING_BRAKE,
SCR_SYSTEM_INHIBITED_DUE_TO_LOW_EXHAUST_TEMPERATURE,
SCR_SYSTEM_INHIBITED_DUE_TO_SYSTEM_FAULT_ACTIVE,
SCR_SYSTEM_INHIBITED_DUE_TO_SYSTEM_TIMEOUT,
SCR_SYSTEM_INHIBITED_DUE_TO_TEMPORARY_SYSTEM_LOCKOUT,
SCR_SYSTEM_INHIBITED_DUE_TO_PERMAMENT_SYSTEM_LOCK,
SCR_SYSTEM_INHIBITED_DUE_TO_ENGINE_NOT_WARMED_UP,
SCR_SYSTEM_INHIBITED_DUE_TO_VEHICLE_SPEED_BELOW_ALLOWED_SPEED,
SCR_SYSTEM_AUTOMATIC_INITATION_CONFIGURATION,
SCR_SYSTEM_CLEANING_FORCED_STATUS,
AFTERTREATMENT_1_CONDITIONS,
ACTUAL_MAXIMUM_AVAILABLE_PERCENT_LEVEL,

TRANSMISSION_SELECTED_GEAR,
TRANSMISSION_CURRENT_GEAR,

END_J1939U8BIT,


START_J1939U16BIT,
CAN0_DEST_ADD,
CAN1_DEST_ADD,
MANUFACTURER_CODE_60920,
ENGINE_OIL_TEMP_1,
ENGINE_TURBOCHARGER_OIL_TEMP,
MANUFACTURER_CODE_60928,
ENGINE_SPEED,		//190
AFTERTREATMENT_1_DIESEL_EXHAUST_FLUID_TANK_LEVEL,	//3517
CARGO_AMBIENT_TEMPERATURE,		//169
TRANSMISSION_OIL_TEMPERATURE_1,		//177
FAN_SPEED,								//1639
HYDRAULIC_FAN_MOTOR_PRESSURE,			//4211
ALTERNATOR_SPEED,		//589
ESTIMATED_ENGINE_PARASITIC_LOSSES,
NOMINAL_FRICTION_PERCENT,
FIRE_PUMP_ENGAGEMENT_CYCLES,
TRANSMISSION_ACTUAL_GEAR_RATIO,
TRANSMISSION_REQUESTED_RANGE,
TRANSMISSION_CURRENT_RANGE,


END_J1939U16BIT,


START_J1939U32BIT,

IDENTIFY_NUMBER_60920,
IDENTIFY_NUMBER_60928,
DM1_SPN,
DM2_SPN,
ENGINE_CRANKCASE_PRESSURE_1,	//101
FIRE_PUMP_OPERATION_TIME,
ENGINE_TOTAL_GASEOUS_FUEL_VOLUME,
ENGINE_TOTAL_GASEOUS__IDLE_FUEL_VOLUME,

END_J1939U32BIT,

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
