/****************************************************************************
Copyright (c) 2012 Maxima Technologies and Systems
All Rights Reserved
File Name : adv7180.h
Author : upender chennoju
Version : V0.0.0.1
Origination Date : 10/15/2019
Description : C Header File.
Environment : Independant
Processor: : Independant
-----------------------------------------------------------------------------
Description:
This file Contains constants, public defines and function declarations of the functions
defined in adv7180.c source file.
-----------------------------------------------------------------------------
File Revision History:
-----------------------------------------------------------------------------
Version Date Programmer
0.0.0.0 04/04/2011 Name Last_Name
Notes: - Initial Version
-----------------------------------------------------------------------------
Version Date Programmer
0.0.0.1 31/03/2011 Name Last_Name
Notes: - Second Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef __adv7180_H
#define __adv7180_H

#ifdef __cplusplus
 extern "C" {
#endif 
   
/* Includes ---------------------------------------------------------------*/
//#include "camera.h"
//#include "stm32746g_discovery_lcd.h"
#include "main.h"

   
/* Public typedef ---------------------------------------------------------*/
//extern CAMERA_DrvTypeDef   adv7180_drv;

/* Public define ----------------------------------------------------------*/
/*
=======================================================
To enable different combination of the configuraiton available,
Enable only one config at a time to 1 and all others to 0.
CONFIG_ONE is the working configuration for the adv7180 for this project.
=======================================================
*/
#define CONFIG_ONE          1
#define CONFIG_TWO          0
#define CONFIG_THREE        0
#define CONFIG_FOUR         0
#define CONFIG_FIVE         0

#define AD_CVBS_IN_YPRPB_OUT     CONFIG_ONE
#define NTSC_M_IN_FAST_SWITCHING CONFIG_TWO
#define PAL_M_IN_FAST_SWITCHING  CONFIG_THREE
#define YC_IN_YPRPB_OUT          CONFIG_FOUR
#define YPRPB_IN_YPRPB_OUT       CONFIG_FIVE
   
/*** Registers addresses ***/
#define INPUT_CONTROL 	        0x00
#define VIDEO_SELECTION         0x01
#define OUTPUT_CONTROL          0x03
#define EXT_OUTPUT_CONTROL      0x04
#define AUTO_DETECT_ENABLE      0x07
#define CONTRAST                0x08
#define BRIGHTNESS              0x0a
#define HUE                     0x0b
#define DEFAULT_VALUE_Y         0x0c
#define DEFAULT_VALUE_C         0x0d
#define ADI_CONTROL             0x0e
#define POWER_MANAGEMENT        0x0f
#define STATUS1                 0x10
#define STATUS2                 0x12
#define STATUS3                 0x13
#define ANALOG_CLAMP_CONTROL    0x14
#define DIGITAL_CLAMP_CTL_1     0x15
#define SHAPING_FILTER_CTL_1    0x17
#define SHAPING_FILTER_CTL_2    0x18
#define COMB_FILTER_CTL         0x19
#define ADI_CTL_2               0x1d
#define PIXEL_DELAY_CTL         0x27
#define MISC_GAIN_CTL           0x2B
#define AGC_MODE_CTL            0x2c
#define CHROMA_GAIN_CTL_1_WO    0x2d
#define CHROMA_GAIN_CTL_2_WO    0x2e
#define LUMA_GAIN_CTL_1_WO      0x2f
#define LUMA_GAIN_CTL_2_WO      0x30
#define VS_FIELD_CTL_1          0x31
#define VS_FIELD_CTL_2          0x32
#define VS_FIELD_CTL_3          0x33
#define HS_POSITION_CTL_1       0x34
#define HS_POSITION_CTL_2       0x35
#define HS_POSITION_CTL_3       0x36
#define POLARITY                0x37
#define NTSC_COMB_CTL           0x38
#define PAL_COMB_CTL            0x39
#define ADC_CTL                 0x3a
#define MANUAL_WINDOW_CTL       0x3d
#define RESAMPLE_CTL            0x41
#define GEMSTAR_CTL_1           0x48
#define GEMSTAR_CTL_2           0x49
#define GEMSTAR_CTL_3           0x4a
#define GEMSTAR_CTL_4           0x4b
#define GEMSTAR_CTL_5           0x4c
#define CTIDNR_CTL_1            0x4d
#define CTIDNR_CTL_2            0x4e
#define CTIDNR_CTL_3            0x50
#define LOCK_COUNT              0x51
#define CVBS_TRIM               0x52
#define VS_FIELD_PIN_CTL        0x58
#define GPO                     0x59
#define FREE_RUN_LINE_LEN       0x8f
#define CRC_ENABLE              0xb2
#define ADC_SWITCH_1            0xc3
#define ADC_SWITCH_2            0xc4
#define LETTER_BOX_CTL_1        0xdc
#define LETTER_BOX_CTL_2        0xdd
#define SD_OFF_SET_CB           0xe1
#define SD_OFF_SET_CR           0xe2
#define SD_SATURATION_CB        0xe3
#define SD_SATURATION_CR        0xe4
#define NTSC_VBIT_BEGIN         0xe5
#define NTSC_VBIT_END           0xe6
#define NTSC_VBIT_TOGGLE        0xe7
#define PAL_VBIT_BEGIN          0xe8
#define PAL_VBIT_END            0xe9
#define PAL_FBIT_TOGGLE         0xea
#define V_BLANK_CTL_1           0xeb
#define V_BLANK_CTL_2           0xec
#define AFE_CTL_1               0xf3
#define DRIVE_STRENGHT          0xf4
#define IFCOMP_CTL              0xf8
#define VSMODE_CTL              0xf9
#define PEAKING_CTL             0xfb
#define CORING_TRESHHOLD        0xfc 
#define MANDATE_ONE             0x0E
#define MANDATE_TWO             0x55
#define MANDATE_THREE           0x52

#define INTERNAL_REG_ONE        0x3e
#define INTERNAL_REG_TWO        0x3f       
   
#define FLAG1                   0x04
#define FLAG2                   0x12
#define FLAG3                   0xC1
#define FLAG4                   0xC0
#define FLAG5                   0x20
#define FLAG6                   0x00
#define FLAG7                   0x02
#define FLAG8                   0x01
#define FLAG9                   0x05
#define FLAG10                  0xF6  
#define FLAG11                  0x80  
#define FLAG12                  0x81
#define FLAG13                  0x0D

/*
=======================================================
Example :     BYTE(0xC,5)  will be result to 0xC5
              BYTE(5,0xC)  will be result to 0x5C
              BYTE(0xF,0xF) will be result to 0xFF 
=======================================================
*/
#define BYTE(X,Y)		(X<<4 & 0xF0) | (Y & 0x0F)




   
#define adv7180_ID                      ((uint16_t)0x05CA)
#define adv7180_INFO_CHIPID1             ((uint16_t)0x0040)
#define adv7180_INFO_CHIPID2             ((uint16_t)0x0042)
#define adv7180_INFO_SVNVERSION          ((uint16_t)0x0048)
#define adv7180_INFO_DATE                ((uint16_t)0x004E)

/* adv7180 Features Parameters */
#define adv7180_BRIGHTNESS_LEVEL0        ((uint16_t)0xFF00)  /* Brightness level -2         */
#define adv7180_BRIGHTNESS_LEVEL1        ((uint16_t)0xFFC0)  /* Brightness level -1         */
#define adv7180_BRIGHTNESS_LEVEL2        ((uint16_t)0x0000)  /* Brightness level 0          */
#define adv7180_BRIGHTNESS_LEVEL3        ((uint16_t)0x0050)  /* Brightness level +1         */
#define adv7180_BRIGHTNESS_LEVEL4        ((uint16_t)0x0080)  /* Brightness level +2         */

#define adv7180_BLACK_WHITE_BW           ((uint16_t)0x0001)  /* Black and white effect      */
#define adv7180_BLACK_WHITE_NEGATIVE     ((uint16_t)0x0003)  /* Negative effect             */
#define adv7180_BLACK_WHITE_BW_NEGATIVE  ((uint16_t)0x0002)  /* BW and Negative effect      */
#define adv7180_BLACK_WHITE_NORMAL       ((uint16_t)0x0000)  /* Normal effect               */

#define adv7180_CONTRAST_LEVEL0          ((uint16_t)0xFF80)  /* Contrast level -2           */
#define adv7180_CONTRAST_LEVEL1          ((uint16_t)0xFFC0)  /* Contrast level -1           */
#define adv7180_CONTRAST_LEVEL2          ((uint16_t)0x0000)  /* Contrast level 0            */
#define adv7180_CONTRAST_LEVEL3          ((uint16_t)0x0050)  /* Contrast level -1           */
#define adv7180_CONTRAST_LEVEL4          ((uint16_t)0x0080)  /* Contrast level -2           */

#define adv7180_COLOR_EFFECT_NONE        ((uint16_t)0x0000)  /* No color effect             */
#define adv7180_COLOR_EFFECT_ANTIQUE     ((uint16_t)0x0004)  /* Antique effect              */
#define adv7180_COLOR_EFFECT_BLUE        ((uint16_t)0x0001)  /* Blue effect                 */
#define adv7180_COLOR_EFFECT_GREEN       ((uint16_t)0x0002)  /* Green effect                */
#define adv7180_COLOR_EFFECT_RED         ((uint16_t)0x0003)  /* Red effect                  */

/* Public macro -----------------------------------------------------------*/
/* Public variables -------------------------------------------------------*/
/* Public functions declaration -------------------------------------------*/
void     adv7180_Init(uint16_t DeviceAddr);
void     adv7180_Config(uint16_t DeviceAddr, uint32_t feature, uint32_t value, uint32_t BR_value);
uint16_t adv7180_ReadID(uint16_t DeviceAddr);

void     CAMERA_IO_Init(void);
void     CAMERA_IO_Write(uint8_t addr, uint16_t reg, uint16_t value);
uint16_t CAMERA_IO_Read(uint8_t addr, uint16_t reg);
void     CAMERA_Delay(uint32_t delay);
void     config_read_one(uint16_t DeviceAddr);
HAL_StatusTypeDef I2Cx_WriteMultiple_c(uint8_t Addr, uint16_t Reg,
                                            uint16_t MemAddress, uint8_t *Buffer,
                                            uint16_t Length); //borrame

#ifdef __cplusplus
}
#endif

#endif /* __adv7180_H */

/**************** (C) COPYRIGHT 2012 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
