/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Sdram.c
   Author             : Adrush
   Version            : V0.0.0.1
   Origination Date   : 11/02/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the SDRAM HAL driver functions

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             11/02/2022           Adrush

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../../Core/Maximatecc/Inc/Common.h"
/* USER CODE END Includes */

#if (SDK_SERVICE_SDRAM == PS_ENABLE)
extern pvt_variable pv;
extern SDRAM_HandleTypeDef hsdram1;

void HAL_FMC_SDRAM_Configure(void)
{
    IS42S16100H_Context_t pRegMode;

    /* External memory mode register configuration */
    pRegMode.TargetBank      = FMC_SDRAM_CMD_TARGET_BANK1;
    pRegMode.RefreshMode     = IS42S16100H_AUTOREFRESH_MODE_CMD;
    pRegMode.RefreshRate     = REFRESH_COUNT;
    pRegMode.BurstLength     = IS42S16100H_BURST_LENGTH_1;
//    pRegMode.BurstLength     = IS42S16100H_BURST_LENGTH_4;//IS42S16100H_BURST_LENGTH_1;
    pRegMode.BurstType       = IS42S16100H_BURST_TYPE_SEQUENTIAL;
    pRegMode.CASLatency      = IS42S16100H_CAS_LATENCY_2;
    pRegMode.OperationMode   = IS42S16100H_OPERATING_MODE_STANDARD;
    pRegMode.WriteBurstMode  = IS42S16100H_WRITEBURST_MODE_SINGLE;
    /* SDRAM initialization sequence */
    if(IS42S16100H_Init(&hsdram1, &pRegMode) != IS42S16100H_OK)
    {
    	//DEBUGOUT("SDRAM Hardware Failure...\n");
    }
#if 0
    /* SDRAM initialization sequence */
    if(IS42S16100H_Init(pv.hsdram1, &pRegMode) != IS42S16100H_OK)
    {
    	//DEBUGOUT("SDRAM Hardware Failure...\n");
    }
#endif
}

#endif	//SDK_SERVICE_SDRAM
/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
