/*
* ij1939_address.h - contains internal defines
*
* Copyright (c) 2014-2021 emotas embedded communication GmbH
*
*-------------------------------------------------------------------
* $Id: ij1939_bam.h 38573 2021-10-15 08:39:19Z boe $
*
*-------------------------------------------------------------------
*
*
*
*/

/**
* \file
* \brief dataty type header
*/

#ifndef IJ1939_BAM_H
#define IJ1939_BAM_H 1

/* datatypes */

/** \brief function pointer to BAM mapping function
 *
 * This function is called to map next data into buffer for special mapping
 *
 * \param actual
 *		seqNumber	actual sequence number
 *		buf			pointer to CAN buf (max. 7 bytes)
 *
 * \return
 * 		void
 */
typedef void (* J1939_BAM_MAPPING_FCT_T)(CO_LINE_DECL, UNSIGNED32 seqNr, UNSIGNED8 *pbuf);


/* function prototypes */

RET_T	ij1939_bamInit(CO_LINE_DECL);
RET_T	ij1939_bamUpdateCob(CO_LINE_DECL, UNSIGNED8	nodeAddress);
RET_T	ij1939_bamStart(CO_LINE_DECL, const J1939_PGN_CONFIG_T *pCfg,
			UNSIGNED16 mapCnt);
void	ij1939_bamConnectReceived(CO_LINE_DECL, const CO_CAN_REC_MSG_T *pMsg);
void	ij1939_bamDataReceived(CO_LINE_DECL, const CO_CAN_REC_MSG_T *pMsg);
RET_T	ij1939_bamStartFct(CO_LINE_DECL, const J1939_PGN_CONFIG_T *pCfg,
			UNSIGNED16 trSize, J1939_BAM_MAPPING_FCT_T fct);
RET_T	ij1939_bamIsFree(CO_LINE_DECL);

#endif /* IJ1939_BAM_H */

