﻿/*
* ij1939_receive.h - contains internal defines
*
* Copyright (c) 2014-2021 emotas embedded communication GmbH
*
*-------------------------------------------------------------------
* $Id: ij1939_receive.h 38573 2021-10-15 08:39:19Z boe $
*
*-------------------------------------------------------------------
*
*
*
*/

/**
* \file
* \brief dataty type header
*/

#ifndef IJ1939_RECEIVE_H
#define IJ1939_RECEIVE_H 1


/* datatypes */

/* function prototypes */

RET_T	ij1939_receivePgnInit(CO_LINE_DECL, UNSIGNED16 recCnt,
			const J1939_PGN_CONFIG_T *rCfg);
const J1939_PGN_CONFIG_T *ij1939_receiveFindPgnConfig(CO_LINE_DECL, 
			UNSIGNED32 pgn);
PGN_CFG_T *ij1939_receiveFindPgn(CO_LINE_DECL, UNSIGNED32 pgn);
RET_T	ij1939_unmapReceive(CO_LINE_DECL, const J1939_PGN_CONFIG_T *pCfg,
			void *pDest,
			const UNSIGNED8	buf[], UNSIGNED32 bufStart, UNSIGNED32 bufEnd);
void	ij1939_receiveIndication(CO_LINE_DECL, const J1939_PGN_CONFIG_T *pCfg,
			void *pMemory, UNSIGNED8 node,
			UNSIGNED32 receivedLen, J1939_RECEIVE_STATE_T state);
RET_T	ij1939_receiveCheckIndication(CO_LINE_DECL, UNSIGNED32 pgn,
			UNSIGNED8 node, const UNSIGNED8 *pData);
RET_T	ij1939_receivePgnEnDisable(CO_LINE_DECL, UNSIGNED32	pgn, BOOL_T enable);
RET_T	ij1939_receiveUpdateCobs(CO_LINE_DECL, UNSIGNED8	nodeAddress);
RET_T	ij1939_receivePgnVarInit(const UNSIGNED16	*pRecCnt);
BOOL_T	ij1939_receivePgnEnabled(CO_LINE_DECL, UNSIGNED32 pgn);
void	ij1939_receiveStartTimer(CO_LINE_DECL, UNSIGNED32 pgn);
RET_T	ij1939_receiveDecrDynPgnCnt(CO_LINE_DECL);
RET_T	ij1939_receiveIncrDynPgnCnt(CO_LINE_DECL);

#endif /* IJ1939_RECEIVE_H */
