#ifndef ALARMASCRPRESENTER_HPP
#define ALARMASCRPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class ALARMASCRView;

class ALARMASCRPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    ALARMASCRPresenter(ALARMASCRView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~ALARMASCRPresenter() {};

    virtual void keyUpdate(uint8_t val);

    virtual void trigger();

    virtual void alarmupdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);


private:
    ALARMASCRPresenter();

    ALARMASCRView& view;
};

#endif // ALARMASCRPRESENTER_HPP
