#ifndef ALARMBSCRPRESENTER_HPP
#define ALARMBSCRPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class ALARMBSCRView;

class ALARMBSCRPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    ALARMBSCRPresenter(ALARMBSCRView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~ALARMBSCRPresenter() {};

    virtual void keyUpdate(uint8_t val);

    virtual void trigger();

    virtual void alarmupdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);


private:
    ALARMBSCRPresenter();

    ALARMBSCRView& view;
};

#endif // ALARMBSCRPRESENTER_HPP
