#ifndef AMBBLINKPRESENTER_HPP
#define AMBBLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class AMBBLINKView;

class AMBBLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    AMBBLINKPresenter(AMBBLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~AMBBLINKPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);


private:
    AMBBLINKPresenter();

    AMBBLINKView& view;
};

#endif // AMBBLINKPRESENTER_HPP
