#ifndef AMBSTAPRESENTER_HPP
#define AMBSTAPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class AMBSTAView;

class AMBSTAPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    AMBSTAPresenter(AMBSTAView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~AMBSTAPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    AMBSTAPresenter();

    AMBSTAView& view;
};

#endif // AMBSTAPRESENTER_HPP
