#ifndef BLEPRESENTER_HPP
#define BLEPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class BLEView;

class BLEPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    BLEPresenter(BLEView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~BLEPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    BLEPresenter();

    BLEView& view;
};

#endif // BLEPRESENTER_HPP
