#ifndef CAMERAVIEW_HPP
#define CAMERAVIEW_HPP

#include <gui_generated/camera_screen/CameraViewBase.hpp>
#include <gui/camera_screen/CameraPresenter.hpp>

class CameraView : public CameraViewBase
{
public:
    CameraView();
    virtual ~CameraView() {}
    virtual void setupScreen();
    virtual void tearDownScreen();
    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);
    virtual void trigger();
    void moveBackScreen();

protected:
    uint8_t mode;
    uint8_t x0_index;
    uint16_t x0;
    uint16_t y0;
    uint8_t y0_index;
    uint16_t w0;
    uint8_t w0_index;
    uint16_t h0;
    uint8_t h0_index;
    uint16_t dx0;
    uint8_t dxy0_index;
    uint16_t dy0;
    uint8_t streaming_mode;
    uint8_t vfindex;
    uint8_t vf;
    uint8_t hf;

private:
	void updateResByStandard();
};

#endif // CAMERAVIEW_HPP
