#ifndef CAN2PRESENTER_HPP
#define CAN2PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class CAN2View;

class CAN2Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    CAN2Presenter(CAN2View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~CAN2Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    CAN2Presenter();

    CAN2View& view;
};

#endif // CAN2PRESENTER_HPP
