#ifndef CANPRESENTER_HPP
#define CANPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class CANView;

class CANPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    CANPresenter(CANView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~CANPresenter() {};


    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    CANPresenter();

    CANView& view;
};

#endif // CANPRESENTER_HPP
