#ifndef CIPRESENTER_HPP
#define CIPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class CIView;

class CIPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    CIPresenter(CIView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~CIPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    CIPresenter();

    CIView& view;
};

#endif // CIPRESENTER_HPP
