#ifndef EEPROM1PRESENTER_HPP
#define EEPROM1PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class EEPROM1View;

class EEPROM1Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    EEPROM1Presenter(EEPROM1View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~EEPROM1Presenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);
    virtual void trigger();
private:
    EEPROM1Presenter();

    EEPROM1View& view;
};

#endif // EEPROM1PRESENTER_HPP
