#ifndef FLASHVIEW_HPP
#define FLASHVIEW_HPP

#include <gui_generated/flash_screen/FLASHViewBase.hpp>
#include <gui/flash_screen/FLASHPresenter.hpp>

class FLASHView : public FLASHViewBase
{
public:
    FLASHView();
    virtual ~FLASHView() {}
    virtual void setupScreen();
    virtual void tearDownScreen();
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);


    void moveNext();
    void movePrevious();
    void moveNextScreen();
    void moveBackScreen();
protected:
    uint32_t key_position;
    uint8_t value;
    uint32_t rdflash;
    uint32_t address;
    uint8_t rdata[20] = {0};

};

#endif // FLASHVIEW_HPP
