#ifndef INGTESTPRESENTER_HPP
#define INGTESTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class IngtestView;

class IngtestPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    IngtestPresenter(IngtestView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~IngtestPresenter() {};

    /*
     * Update the Keypad event to the UI
     */
     virtual void keyUpdate(uint8_t val);
     virtual void trigger();
     virtual void watchdogstatus(uint8_t *val);


private:
    IngtestPresenter();

    IngtestView& view;
};

#endif // INGTESTPRESENTER_HPP
