#ifndef J1939PRESENTER_HPP
#define J1939PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class J1939View;

class J1939Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    J1939Presenter(J1939View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~J1939Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);


    virtual void trigger();

private:
    J1939Presenter();

    J1939View& view;
};

#endif // J1939PRESENTER_HPP
