#ifndef LTSPRESENTER_HPP
#define LTSPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class LTSView;

class LTSPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    LTSPresenter(LTSView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~LTSPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);


    virtual void trigger();

private:
    LTSPresenter();

    LTSView& view;
};

#endif // LTSPRESENTER_HPP
