#ifndef POWERMODEPRESENTER_HPP
#define POWERMODEPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class POWERMODEView;

class POWERMODEPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    POWERMODEPresenter(POWERMODEView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~POWERMODEPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);


    virtual void trigger();

private:
    POWERMODEPresenter();

    POWERMODEView& view;
};

#endif // POWERMODEPRESENTER_HPP
