#ifndef REDBLINKPRESENTER_HPP
#define REDBLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class REDBLINKView;

class REDBLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    REDBLINKPresenter(REDBLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~REDBLINKPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    REDBLINKPresenter();

    REDBLINKView& view;
};

#endif // REDBLINKPRESENTER_HPP
