#ifndef REDNXTPRESENTER_HPP
#define REDNXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class REDNXTView;

class REDNXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    REDNXTPresenter(REDNXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~REDNXTPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    REDNXTPresenter();

    REDNXTView& view;
};

#endif // REDNXTPRESENTER_HPP
