#ifndef RTCNXTPRESENTER_HPP
#define RTCNXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class RTCNXTView;

class RTCNXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    RTCNXTPresenter(RTCNXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~RTCNXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);


    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    RTCNXTPresenter();

    RTCNXTView& view;
};

#endif // RTCNXTPRESENTER_HPP
