#ifndef SWTIMER3PRESENTER_HPP
#define SWTIMER3PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SWTIMER3View;

class SWTIMER3Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    SWTIMER3Presenter(SWTIMER3View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SWTIMER3Presenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    SWTIMER3Presenter();

    SWTIMER3View& view;
};

#endif // SWTIMER3PRESENTER_HPP
