#ifndef SWTIMER4PRESENTER_HPP
#define SWTIMER4PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SWTIMER4View;

class SWTIMER4Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    SWTIMER4Presenter(SWTIMER4View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SWTIMER4Presenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    SWTIMER4Presenter();

    SWTIMER4View& view;
};

#endif // SWTIMER4PRESENTER_HPP
