#ifndef SWTIMER5PRESENTER_HPP
#define SWTIMER5PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SWTIMER5View;

class SWTIMER5Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    SWTIMER5Presenter(SWTIMER5View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SWTIMER5Presenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    SWTIMER5Presenter();

    SWTIMER5View& view;
};

#endif // SWTIMER5PRESENTER_HPP
