#ifndef SWTIMERPRESENTER_HPP
#define SWTIMERPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class SWTIMERView;

class SWTIMERPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    SWTIMERPresenter(SWTIMERView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~SWTIMERPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    SWTIMERPresenter();

    SWTIMERView& view;
};

#endif // SWTIMERPRESENTER_HPP
