#ifndef THRPUTPRESENTER_HPP
#define THRPUTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class THRPUTView;

class THRPUTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    THRPUTPresenter(THRPUTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~THRPUTPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    THRPUTPresenter();

    THRPUTView& view;
};

#endif // THRPUTPRESENTER_HPP
