#ifndef TIMEVIEW_HPP
#define TIMEVIEW_HPP

#include <gui_generated/time_screen/TIMEViewBase.hpp>
#include <gui/time_screen/TIMEPresenter.hpp>

class TIMEView : public TIMEViewBase
{
public:
    TIMEView();
    virtual ~TIMEView() {}
    virtual void setupScreen();
    virtual void tearDownScreen();
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

       void moveNext();
       void movePrevious();
       void moveNextScreen();
       void moveBackScreen();
protected:
       uint8_t hours;
       uint8_t minutes;
       uint8_t seconds;
       uint32_t key_position;
       uint8_t rtcval;
       uint8_t res;
       uint8_t format;
       uint8_t rtcformat;
       uint8_t rtc_refresh_val;
       uint8_t wkdays;
       uint8_t date;
       uint8_t month;
       uint8_t year;
       int tickCounter;
       int digitalHours;
       int digitalMinutes;
       int digitalSeconds;
};

#endif // TIMEVIEW_HPP
