#ifndef WL01NXTPRESENTER_HPP
#define WL01NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL01NXTView;

class WL01NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL01NXTPresenter(WL01NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL01NXTPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    WL01NXTPresenter();

    WL01NXTView& view;
};

#endif // WL01NXTPRESENTER_HPP
