#ifndef WL02NXTPRESENTER_HPP
#define WL02NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL02NXTView;

class WL02NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL02NXTPresenter(WL02NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL02NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL02NXTPresenter();

    WL02NXTView& view;
};

#endif // WL02NXTPRESENTER_HPP
