#ifndef WL03NXTPRESENTER_HPP
#define WL03NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL03NXTView;

class WL03NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL03NXTPresenter(WL03NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL03NXTPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    WL03NXTPresenter();

    WL03NXTView& view;
};

#endif // WL03NXTPRESENTER_HPP
