#ifndef WL04NXTPRESENTER_HPP
#define WL04NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL04NXTView;

class WL04NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL04NXTPresenter(WL04NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL04NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL04NXTPresenter();

    WL04NXTView& view;
};

#endif // WL04NXTPRESENTER_HPP
