#ifndef WL05NXTPRESENTER_HPP
#define WL05NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL05NXTView;

class WL05NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL05NXTPresenter(WL05NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL05NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL05NXTPresenter();

    WL05NXTView& view;
};

#endif // WL05NXTPRESENTER_HPP
