#ifndef WL06BLINKPRESENTER_HPP
#define WL06BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL06BLINKView;

class WL06BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL06BLINKPresenter(WL06BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL06BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL06BLINKPresenter();

    WL06BLINKView& view;
};

#endif // WL06BLINKPRESENTER_HPP
