#ifndef WL06NXTPRESENTER_HPP
#define WL06NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL06NXTView;

class WL06NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL06NXTPresenter(WL06NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL06NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL06NXTPresenter();

    WL06NXTView& view;
};

#endif // WL06NXTPRESENTER_HPP
