#ifndef WL07BLINKPRESENTER_HPP
#define WL07BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL07BLINKView;

class WL07BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL07BLINKPresenter(WL07BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL07BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL07BLINKPresenter();

    WL07BLINKView& view;
};

#endif // WL07BLINKPRESENTER_HPP
