#ifndef WL07NXTPRESENTER_HPP
#define WL07NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL07NXTView;

class WL07NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL07NXTPresenter(WL07NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL07NXTPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    WL07NXTPresenter();

    WL07NXTView& view;
};

#endif // WL07NXTPRESENTER_HPP
