#ifndef WL08BLINKPRESENTER_HPP
#define WL08BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL08BLINKView;

class WL08BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL08BLINKPresenter(WL08BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL08BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL08BLINKPresenter();

    WL08BLINKView& view;
};

#endif // WL08BLINKPRESENTER_HPP
