#ifndef WL08NXTPRESENTER_HPP
#define WL08NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL08NXTView;

class WL08NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL08NXTPresenter(WL08NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL08NXTPresenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void watchdogstatus(uint8_t *val);

    virtual void trigger();

private:
    WL08NXTPresenter();

    WL08NXTView& view;
};

#endif // WL08NXTPRESENTER_HPP
