#ifndef WL09NXTPRESENTER_HPP
#define WL09NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL09NXTView;

class WL09NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL09NXTPresenter(WL09NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL09NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL09NXTPresenter();

    WL09NXTView& view;
};

#endif // WL09NXTPRESENTER_HPP
