#ifndef WL10BLINKPRESENTER_HPP
#define WL10BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL10BLINKView;

class WL10BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL10BLINKPresenter(WL10BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL10BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL10BLINKPresenter();

    WL10BLINKView& view;
};

#endif // WL10BLINKPRESENTER_HPP
