#ifndef WL10NXTPRESENTER_HPP
#define WL10NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL10NXTView;

class WL10NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL10NXTPresenter(WL10NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL10NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL10NXTPresenter();

    WL10NXTView& view;
};

#endif // WL10NXTPRESENTER_HPP
