#ifndef WL12BLINKPRESENTER_HPP
#define WL12BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL12BLINKView;

class WL12BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL12BLINKPresenter(WL12BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL12BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL12BLINKPresenter();

    WL12BLINKView& view;
};

#endif // WL12BLINKPRESENTER_HPP
