#ifndef WL12NXTPRESENTER_HPP
#define WL12NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL12NXTView;

class WL12NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL12NXTPresenter(WL12NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL12NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL12NXTPresenter();

    WL12NXTView& view;
};

#endif // WL12NXTPRESENTER_HPP
