#ifndef WL13NXTPRESENTER_HPP
#define WL13NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL13NXTView;

class WL13NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL13NXTPresenter(WL13NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL13NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL13NXTPresenter();

    WL13NXTView& view;
};

#endif // WL13NXTPRESENTER_HPP
