#ifndef WL14BLINKPRESENTER_HPP
#define WL14BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL14BLINKView;

class WL14BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL14BLINKPresenter(WL14BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL14BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL14BLINKPresenter();

    WL14BLINKView& view;
};

#endif // WL14BLINKPRESENTER_HPP
