#ifndef WL14NXTPRESENTER_HPP
#define WL14NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL14NXTView;

class WL14NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL14NXTPresenter(WL14NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL14NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL14NXTPresenter();

    WL14NXTView& view;
};

#endif // WL14NXTPRESENTER_HPP
