#ifndef WL15BLINKPRESENTER_HPP
#define WL15BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL15BLINKView;

class WL15BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL15BLINKPresenter(WL15BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL15BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL15BLINKPresenter();

    WL15BLINKView& view;
};

#endif // WL15BLINKPRESENTER_HPP
