#ifndef WL15NXTPRESENTER_HPP
#define WL15NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL15NXTView;

class WL15NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL15NXTPresenter(WL15NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL15NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL15NXTPresenter();

    WL15NXTView& view;
};

#endif // WL15NXTPRESENTER_HPP
