#ifndef WL16BLINKPRESENTER_HPP
#define WL16BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL16BLINKView;

class WL16BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL16BLINKPresenter(WL16BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL16BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL16BLINKPresenter();

    WL16BLINKView& view;
};

#endif // WL16BLINKPRESENTER_HPP
