#ifndef WL16NXTPRESENTER_HPP
#define WL16NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL16NXTView;

class WL16NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL16NXTPresenter(WL16NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL16NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL16NXTPresenter();

    WL16NXTView& view;
};

#endif // WL16NXTPRESENTER_HPP
