#ifndef WL17NXTPRESENTER_HPP
#define WL17NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL17NXTView;

class WL17NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL17NXTPresenter(WL17NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL17NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL17NXTPresenter();

    WL17NXTView& view;
};

#endif // WL17NXTPRESENTER_HPP
