#ifndef WL18BLINKPRESENTER_HPP
#define WL18BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL18BLINKView;

class WL18BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL18BLINKPresenter(WL18BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL18BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL18BLINKPresenter();

    WL18BLINKView& view;
};

#endif // WL18BLINKPRESENTER_HPP
