#ifndef WL18NXTPRESENTER_HPP
#define WL18NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL18NXTView;

class WL18NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL18NXTPresenter(WL18NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL18NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL18NXTPresenter();

    WL18NXTView& view;
};

#endif // WL18NXTPRESENTER_HPP
