#ifndef WL19BLINKPRESENTER_HPP
#define WL19BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL19BLINKView;

class WL19BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL19BLINKPresenter(WL19BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL19BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL19BLINKPresenter();

    WL19BLINKView& view;
};

#endif // WL19BLINKPRESENTER_HPP
