#ifndef WL20BLINKPRESENTER_HPP
#define WL20BLINKPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL20BLINKView;

class WL20BLINKPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL20BLINKPresenter(WL20BLINKView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL20BLINKPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL20BLINKPresenter();

    WL20BLINKView& view;
};

#endif // WL20BLINKPRESENTER_HPP
