#ifndef WL20NXTPRESENTER_HPP
#define WL20NXTPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WL20NXTView;

class WL20NXTPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WL20NXTPresenter(WL20NXTView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WL20NXTPresenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WL20NXTPresenter();

    WL20NXTView& view;
};

#endif // WL20NXTPRESENTER_HPP
