#ifndef WLS01PRESENTER_HPP
#define WLS01PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS01View;

class WLS01Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS01Presenter(WLS01View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS01Presenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WLS01Presenter();

    WLS01View& view;
};

#endif // WLS01PRESENTER_HPP
