#ifndef WLS02PRESENTER_HPP
#define WLS02PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS02View;

class WLS02Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS02Presenter(WLS02View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS02Presenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WLS02Presenter();

    WLS02View& view;
};

#endif // WLS02PRESENTER_HPP
