#ifndef WLS03PRESENTER_HPP
#define WLS03PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS03View;

class WLS03Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS03Presenter(WLS03View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS03Presenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WLS03Presenter();

    WLS03View& view;
};

#endif // WLS03PRESENTER_HPP
