#ifndef WLS05PRESENTER_HPP
#define WLS05PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS05View;

class WLS05Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS05Presenter(WLS05View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS05Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS05Presenter();

    WLS05View& view;
};

#endif // WLS05PRESENTER_HPP
