#ifndef WLS06PRESENTER_HPP
#define WLS06PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS06View;

class WLS06Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS06Presenter(WLS06View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS06Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS06Presenter();

    WLS06View& view;
};

#endif // WLS06PRESENTER_HPP
