#ifndef WLS07PRESENTER_HPP
#define WLS07PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS07View;

class WLS07Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS07Presenter(WLS07View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS07Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS07Presenter();

    WLS07View& view;
};

#endif // WLS07PRESENTER_HPP
