#ifndef WLS08PRESENTER_HPP
#define WLS08PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS08View;

class WLS08Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS08Presenter(WLS08View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS08Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS08Presenter();

    WLS08View& view;
};

#endif // WLS08PRESENTER_HPP
