#ifndef WLS09PRESENTER_HPP
#define WLS09PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS09View;

class WLS09Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS09Presenter(WLS09View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS09Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS09Presenter();

    WLS09View& view;
};

#endif // WLS09PRESENTER_HPP
