#ifndef WLS10PRESENTER_HPP
#define WLS10PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS10View;

class WLS10Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS10Presenter(WLS10View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS10Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS10Presenter();

    WLS10View& view;
};

#endif // WLS10PRESENTER_HPP
