#ifndef WLS11PRESENTER_HPP
#define WLS11PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS11View;

class WLS11Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS11Presenter(WLS11View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS11Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS11Presenter();

    WLS11View& view;
};

#endif // WLS11PRESENTER_HPP
