#ifndef WLS12PRESENTER_HPP
#define WLS12PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS12View;

class WLS12Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS12Presenter(WLS12View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS12Presenter() {};
    virtual void watchdogstatus(uint8_t *val);

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();

private:
    WLS12Presenter();

    WLS12View& view;
};

#endif // WLS12PRESENTER_HPP
