#ifndef WLS14PRESENTER_HPP
#define WLS14PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS14View;

class WLS14Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS14Presenter(WLS14View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS14Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS14Presenter();

    WLS14View& view;
};

#endif // WLS14PRESENTER_HPP
