#ifndef WLS15PRESENTER_HPP
#define WLS15PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS15View;

class WLS15Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS15Presenter(WLS15View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS15Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS15Presenter();

    WLS15View& view;
};

#endif // WLS15PRESENTER_HPP
