#ifndef WLS16PRESENTER_HPP
#define WLS16PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS16View;

class WLS16Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS16Presenter(WLS16View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS16Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS16Presenter();

    WLS16View& view;
};

#endif // WLS16PRESENTER_HPP
