#ifndef WLS18PRESENTER_HPP
#define WLS18PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS18View;

class WLS18Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS18Presenter(WLS18View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS18Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS18Presenter();

    WLS18View& view;
};

#endif // WLS18PRESENTER_HPP
