#ifndef WLS20PRESENTER_HPP
#define WLS20PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WLS20View;

class WLS20Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WLS20Presenter(WLS20View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WLS20Presenter() {};

    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

private:
    WLS20Presenter();

    WLS20View& view;
};

#endif // WLS20PRESENTER_HPP
