#ifndef WREEPROM1PRESENTER_HPP
#define WREEPROM1PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WREEPROM1View;

class WREEPROM1Presenter : public touchgfx::Presenter, public ModelListener
{
public:
    WREEPROM1Presenter(WREEPROM1View& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WREEPROM1Presenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    WREEPROM1Presenter();

    WREEPROM1View& view;
};

#endif // WREEPROM1PRESENTER_HPP
