#ifndef WRFLASHPRESENTER_HPP
#define WRFLASHPRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class WRFLASHView;

class WRFLASHPresenter : public touchgfx::Presenter, public ModelListener
{
public:
    WRFLASHPresenter(WRFLASHView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~WRFLASHPresenter() {};
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);
private:
    WRFLASHPresenter();

    WRFLASHView& view;
};

#endif // WRFLASHPRESENTER_HPP
