#include <gui/alarmascr_screen/ALARMASCRView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

ALARMASCRView::ALARMASCRView()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)
	aminutes = 0;
	aseconds = 0;
	awkdays =  0;
	key_position = 1;
	ares = 1;
	almaformat = 0;
	format = 0;
	alarm_status = 0;

	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;

	/* Active the first button */
	ALMAFMT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ALMAFMT.invalidate();


	/* Get the RTC DB */
	Get_DL(GET_RTC_SECOND, &Seconds);
	Get_DL(GET_RTC_MINUTE, &Minutes);
	Get_DL(GET_RTC_HOUR, &Hours);

    digitalHours = Hours;
    digitalMinutes = Minutes;
    digitalSeconds = Seconds;

    digitalClock2.invalidate();

	    /* Get the ALARM A time format */
  		Get_DL(RTC_ALARM_A_TIME_FORMAT, &format);

  		if(format == 0)
  		{
  		ahours = 1;
  		Unicode::snprintf(ALMAFMTBuffer, ALMAFMT_SIZE, "%d" , 12);
  		Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
  		}
  		else if(format == 1)
  		{
  		ahours = 0;
  		Unicode::snprintf(ALMAFMTBuffer, ALMAFMT_SIZE, "%d" , 24);
  		Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
  		}
  		Set_DL(RTC_ALARM_A_HOUR, &ahours);

  		ALMAFMT.invalidate();
  		ALMAHR.invalidate();

  		/* Get the ALARM A hours */
		Get_DL(RTC_ALARM_A_HOUR, &ahours);
		if((ahours>=0)&&(ahours<=23))
		{
		Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, "%d" , ahours);
		}
		ALMAHR.invalidate();

  		/* Get the ALARM A minutes */
		Get_DL(RTC_ALARM_A_MINUTE, &aminutes);
	    if((aminutes>=0)&&(aminutes<60))
	    {
		Unicode::snprintf(ALMAMINBuffer, ALMAMIN_SIZE, "%.2d" , aminutes);
	    }
		ALMAMIN.invalidate();

  		/* Get the ALARM A seconds */
		Get_DL(RTC_ALARM_A_SECOND, &aseconds);
	    if((aseconds>=0)&&(aseconds<60))
	    {
		Unicode::snprintf(ALMASECBuffer, ALMASEC_SIZE, "%.2d" , aseconds);
	    }
		ALMASEC.invalidate();

  		/* Get the ALARM A weekdays */
		Get_DL(RTC_ALARM_A_WEEK_DAY, (uint8_t *)&awkdays);

	    if((awkdays>=0)&&(awkdays<7))
	    {
	    	if(awkdays == 0)
	    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "SUN");
	    	else if(awkdays == 1)
	    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "MON");
	    	else if(awkdays == 2)
	    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "TUE");
	    	else if(awkdays == 3)
	    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "WED");
	    	else if(awkdays == 4)
	    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "THR");
	    	else if(awkdays == 5)
	    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "FRI");
	    	else if(awkdays == 6)
	    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "SAT");

	    }
		ALMADAY.invalidate();

#endif

}

void ALARMASCRView::setupScreen()
{
    ALARMASCRViewBase::setupScreen();
}

void ALARMASCRView::tearDownScreen()
{
    ALARMASCRViewBase::tearDownScreen();
}

void ALARMASCRView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        key_position++;

		if (6 == key_position)
		    key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ALMADAY.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMADAY.invalidate();

			/* Select the Keypad button */
			ALMAFMT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMAFMT.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ALMAFMT.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMAFMT.invalidate();

			/* Select the Keypad button */
			ALMAHR.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMAHR.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			ALMAHR.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMAHR.invalidate();

			/* Select the Keypad button */
			ALMAMIN.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMAMIN.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			ALMAMIN.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMAMIN.invalidate();

			/* Select the Keypad button */
			ALMASEC.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMASEC.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			ALMASEC.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMASEC.invalidate();

			/* Select the Keypad button */
			ALMADAY.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMADAY.invalidate();
			break;
		default:
			break;
		}
	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:

		    if((format == 0))
	 	    {
		    	ahours = 0;
		    	Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
		    	Unicode::snprintf(ALMAFMTBuffer, ALMAFMT_SIZE, "%d" , 24);

		    	format = 1;
		    }
		    /* Set the RTC ALARM A time format */
	    	Set_DL(RTC_ALARM_A_TIME_FORMAT, &format);
	    	Set_DL(RTC_ALARM_A_HOUR, &ahours);
		    ALMAFMT.invalidate();
		    ALMAHR.invalidate();
		    break;

		case 2:
		    if ((ahours >= 1) && (ahours < 12) && (0 == format))
		    {
		    	ahours++;
			    Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
			}
		    else if((ahours >= 0) && (ahours < 23) && (1 == format))
		    {
		    	ahours++;
			    Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
		    }

		    /* Set the RTC ALARM A hours */
	    	Set_DL(RTC_ALARM_A_HOUR, &ahours);
		    ALMAHR.invalidate();
		    break;
		case 3:
		    if ((aminutes >= 0) && (aminutes < 59))
		    {
			    aminutes++;
			    Unicode::snprintf(ALMAMINBuffer, ALMAMIN_SIZE, " %d" , aminutes);
		    }

		    /* Set the RTC ALARM A minutes */
		    Set_DL(RTC_ALARM_A_MINUTE, &aminutes);
		    ALMAMIN.invalidate();
		    break;
		case 4:
		    if ((aseconds >= 0) && (aseconds < 59) )
		    {
		    	aseconds ++;
			    Unicode::snprintf(ALMASECBuffer, ALMASEC_SIZE, " %d" , aseconds);
		    }

		    /* Set the RTC ALARM A seconds */
	    	Set_DL(RTC_ALARM_A_SECOND, &aseconds);
		    ALMASEC.invalidate();
		    break;
		case 5:
		    if ((awkdays >= 0) && (awkdays <= 7))
		    {
		    	awkdays ++;
		    	if(awkdays == 1)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "MON");
		    	else if(awkdays == 2)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "TUE");
		    	else if(awkdays == 3)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "WED");
		    	else if(awkdays == 4)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "THR");
		    	else if(awkdays == 5)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "FRI");
		    	else if(awkdays == 6)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "SAT");
		    	else if(awkdays == 7)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "SUN");

		    	if(awkdays > 7)
				awkdays = 1;

		    }

		    /* Set the RTC ALARM A week days */
	    	Set_DL(RTC_ALARM_A_WEEK_DAY,(uint8_t *)&awkdays);
		    ALMADAY.invalidate();
		    break;
		default :
		    break;
	    }
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;
		switch (position)
		{

		case 1:
		    if ((format == 1))
		    {
		    	format = 0;
		    	ahours = 1;
			    Unicode::snprintf(ALMAFMTBuffer, ALMAFMT_SIZE, "%d" , 12);
			    Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
			    almaformat = 0;
		    }
		    /* Set the RTC ALARM A time format */
	    	Set_DL(RTC_ALARM_A_TIME_FORMAT, &almaformat);
	    	Set_DL(RTC_ALARM_A_HOUR, &ahours);
		    ALMAFMT.invalidate();
		    ALMAHR.invalidate();
		    break;
		case 2:
		    if ((ahours > 0) && (ahours <= 12)&& (0 == format))
		    {
		    	if(ahours >= 2)
		    	ahours --;
			    Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
		    }
		    else if((ahours < 24)&&(ahours > 0) && (1 == format))
		    {
		    	ahours --;
			    Unicode::snprintf(ALMAHRBuffer, ALMAHR_SIZE, " %d" , ahours);
		    }
		    /* Set the RTC ALARM A hours */
	    	Set_DL(RTC_ALARM_A_HOUR, &ahours);
		    ALMAHR.invalidate();
		    break;
        case 3:
		    if ((aminutes > 0) && (aminutes <= 59))
		    {
			    aminutes --;
			    Unicode::snprintf(ALMAMINBuffer, ALMAMIN_SIZE, " %d" , aminutes);
		    }

		    /* Set the RTC ALARM A minutes */
		    Set_DL(RTC_ALARM_A_MINUTE, &aminutes);
		    ALMAMIN.invalidate();
		    break;
		case 4:
		    if ((aseconds > 0) && (aseconds <= 59) )
		    {
		    	aseconds --;
			    Unicode::snprintf(ALMASECBuffer, ALMASEC_SIZE, " %d" , aseconds);
		    }

		    /* Set the RTC ALARM A seconds */
	    	Set_DL(RTC_ALARM_A_SECOND, &aseconds);
		    ALMASEC.invalidate();
		    break;
		case 5:
		    if ((awkdays > 1) && (awkdays <= 7))
		    {
		    	awkdays --;
		    	if(awkdays == 6)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "SAT");
		    	else if(awkdays == 5)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "FRI");
		    	else if(awkdays == 4)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "THR");
		    	else if(awkdays == 3)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "WED");
		    	else if(awkdays == 2)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "TUE");
		    	else if(awkdays == 1)
		    		Unicode::snprintf(ALMADAYBuffer, ALMADAY_SIZE, "MON");

		    }

		    /* Set the RTC ALARM A weekdays */
	    	Set_DL(RTC_ALARM_A_WEEK_DAY, (uint8_t *)&awkdays);
		    ALMADAY.invalidate();
		    break;
		default :
		    break;
        }
	}
	else
	if(KEY4_SHORT_PRESS == val)
	{
		/* Set the ALARM A */
		Set_DL(SET_ALARM_A, &ares);
	}
	else
	if(KEY4_LONG_PRESS == val)

	{		/* Long Press Keypad button */
		application().gotoRTCNXTScreenNoTransition();
	}

#endif
}

void ALARMASCRView::alarmupdate(uint8_t val)
{
	if(ALARM_A_UPDATE == val)
	{
		Unicode::snprintf(ALARMOCRBuffer, ALARMOCR_SIZE, "Alarm_Occured" );
	}
	ALARMOCR.invalidate();
}
void ALARMASCRView::trigger()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;

   tickCounter++;
   if( 10 <= tickCounter)
   {
	   tickCounter = 0;
		/* Get the RTC DB */
		Get_DL(GET_RTC_SECOND, &Seconds);
		Get_DL(GET_RTC_MINUTE, &Minutes);
		Get_DL(GET_RTC_HOUR, &Hours);

	    //screenViewBase::setupScreen();
	    digitalHours = Hours;
	    digitalMinutes = Minutes;
	    digitalSeconds = Seconds;

        digitalClock2.setTime24Hour(digitalHours, digitalMinutes, digitalSeconds);

	    digitalClock2.invalidate();
   }
#endif
}

void ALARMASCRView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

