#include <gui/alarmbscr_screen/ALARMBSCRView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

ALARMBSCRView::ALARMBSCRView()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	bminutes = 0;
	bseconds = 0;
	bwkdays =  0;
	bres  =    1;
	almbformat = 0;
	key_position = 1;
	bformat = 0;

	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;

	/* Active the first button */
	ALMBFMT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ALMBFMT.invalidate();

	/* Get the RTC DB */
	Get_DL(GET_RTC_SECOND, &Seconds);
	Get_DL(GET_RTC_MINUTE, &Minutes);
	Get_DL(GET_RTC_HOUR, &Hours);

    digitalHours = Hours;
    digitalMinutes = Minutes;
    digitalSeconds = Seconds;

    digitalClock3.invalidate();

	/* Get the ALARM B time format */
	Get_DL(RTC_ALARM_B_TIME_FORMAT, &bformat);

	if(bformat == 0)
	{
		bhours = 1;;
		Unicode::snprintf(ALMBFMTBuffer, ALMBFMT_SIZE, "%d" , 12);
		Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
	}
	else if(bformat == 1)
	{
		bhours = 0;
		Unicode::snprintf(ALMBFMTBuffer, ALMBFMT_SIZE, "%d" , 24);
		Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
	}
	Set_DL(RTC_ALARM_B_HOUR, &bhours);

	ALMBFMT.invalidate();
	ALMBHR.invalidate();

	/* Get the ALARM B hours */
	Get_DL(RTC_ALARM_B_HOUR, &bhours);
	if((bhours>=0)&&(bhours<=23))
	{
	Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, "%.2d" , bhours);
	}
	ALMBHR.invalidate();

	/* Get the ALARM B minutes */
	Get_DL(RTC_ALARM_B_MINUTE, &bminutes);
    if((bminutes>=0)&&(bminutes<60))
    {
	Unicode::snprintf(ALMBMINBuffer, ALMBMIN_SIZE, "%.2d" , bminutes);
    }
	ALMBMIN.invalidate();

	/* Get the ALARM B seconds */
	Get_DL(RTC_ALARM_B_SECOND, &bseconds);
    if((bseconds>=0)&&(bseconds<60))
    {
	Unicode::snprintf(ALMBSECBuffer, ALMBSEC_SIZE, "%.2d" , bseconds);
    }
	ALMBSEC.invalidate();

	/* Get the ALARM B weekdays */
	Get_DL(RTC_ALARM_B_WEEK_DAY, (uint8_t *)&bwkdays);
    if((bwkdays>=0)&&(bwkdays<7))
    {
    	if(bwkdays == 0)
    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "SUN");
    	else if(bwkdays == 1)
    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "MON");
    	else if(bwkdays == 2)
    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "TUE");
    	else if(bwkdays == 3)
    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "WED");
    	else if(bwkdays == 4)
    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "THR");
    	else if(bwkdays == 5)
    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "FRI");
    	else if(bwkdays == 6)
    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "SAT");
    }
	ALMBDAY.invalidate();

#endif
}

void ALARMBSCRView::setupScreen()
{
    ALARMBSCRViewBase::setupScreen();
}

void ALARMBSCRView::tearDownScreen()
{
    ALARMBSCRViewBase::tearDownScreen();
}

void ALARMBSCRView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        key_position++;

		if (6 == key_position)
		    key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ALMBDAY.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMBDAY.invalidate();

			/* Select the Keypad button */
			ALMBFMT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMBFMT.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ALMBFMT.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMBFMT.invalidate();

			/* Select the Keypad button */
			ALMBHR.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMBHR.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			ALMBHR.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMBHR.invalidate();

			/* Select the Keypad button */
			ALMBMIN.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMBMIN.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			ALMBMIN.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMBMIN.invalidate();

			/* Select the Keypad button */
			ALMBSEC.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMBSEC.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			ALMBSEC.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALMBSEC.invalidate();

			/* Select the Keypad button */
			ALMBDAY.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALMBDAY.invalidate();
			break;
		default:
			break;
		}
	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
		    if((bformat == 0))
	 	    {
		    	bhours = 0;
		    	Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
		    	Unicode::snprintf(ALMBFMTBuffer, ALMBFMT_SIZE, "%d" , 24);

		    	bformat = 1;
		    }
		    /* Set the RTC ALARM B time format */
	    	Set_DL(RTC_ALARM_B_TIME_FORMAT, &bformat);
	    	Set_DL(RTC_ALARM_B_HOUR, &bhours);
		    ALMBFMT.invalidate();
		    ALMBHR.invalidate();
		    break;
		case 2:
		    if ((bhours >= 1) && (bhours < 12) && (0 == bformat))
		    {
		    	bhours++;
			    Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
			}
		    else if((bhours >= 0) && (bhours < 23) && (1 == bformat))
		    {
		    	bhours++;
			    Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
		    }

		    /* Set the RTC ALARM B hours */
	    	Set_DL(RTC_ALARM_B_HOUR, &bhours);
		    ALMBHR.invalidate();
		    break;
		case 3:
		    if ((bminutes >= 0) && (bminutes < 59))
		    {
			    bminutes ++;
			    Unicode::snprintf(ALMBMINBuffer, ALMBMIN_SIZE, " %d" , bminutes);
		    }

		    /* Set the RTC ALARM B minutes */
	    	Set_DL(RTC_ALARM_B_MINUTE, &bminutes);
		    ALMBMIN.invalidate();
		    break;
		case 4:
		    if ((bseconds >= 0) && (bseconds < 59) )
		    {
		    	bseconds ++;
			    Unicode::snprintf(ALMBSECBuffer, ALMBSEC_SIZE, " %d" , bseconds);
		    }

		    /* Set the RTC ALARM B seconds */
	    	Set_DL(RTC_ALARM_B_SECOND, &bseconds);
		    ALMBSEC.invalidate();
		    break;
		case 5:
		    if ((bwkdays >= 0) && (bwkdays <= 7))
		    {
		    	bwkdays ++;
		    	if(bwkdays == 1)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "MON");
		    	else if(bwkdays == 2)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "TUE");
		    	else if(bwkdays == 3)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "WED");
		    	else if(bwkdays == 4)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "THR");
		    	else if(bwkdays == 5)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "FRI");
		    	else if(bwkdays == 6)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "SAT");
		    	else if(bwkdays == 7)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "SUN");

		    	if(bwkdays > 7)
				bwkdays = 1;
		    }
		    /* Set the RTC ALARM B weekdays */
	    	Set_DL(RTC_ALARM_B_WEEK_DAY,(uint8_t *)&bwkdays);
		    ALMBDAY.invalidate();
		    break;
		default :
		    break;
	    }
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;
		switch (position)
		{
		case 1:
		    if ((bformat == 1))
		    {
		    	bformat = 0;
		    	bhours = 1;
			    Unicode::snprintf(ALMBFMTBuffer, ALMBFMT_SIZE, "%d" , 12);
			    Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
			    almbformat = 0;
		    }
		    /* Set the RTC ALARM B time format */
	    	Set_DL(RTC_ALARM_B_TIME_FORMAT, &almbformat);
	    	Set_DL(RTC_ALARM_B_HOUR, &bhours);
		    ALMBFMT.invalidate();
		    ALMBHR.invalidate();
		    break;
		case 2:
		    if ((bhours > 0) && (bhours <= 12)&& (0 == bformat))
		    {
		    	if(bhours >= 2)
		    	bhours --;
			    Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
		    }
		    else if((bhours < 24)&&(bhours > 0) && (1 == bformat))
		    {
		    	bhours --;
			    Unicode::snprintf(ALMBHRBuffer, ALMBHR_SIZE, " %d" , bhours);
		    }
		    /* Set the RTC ALARM B hours */
	    	Set_DL(RTC_ALARM_B_HOUR, &bhours);
		    ALMBHR.invalidate();
		    break;
        case 3:
		    if ((bminutes > 0) && (bminutes <= 59))
		    {
			    bminutes --;
			    Unicode::snprintf(ALMBMINBuffer, ALMBMIN_SIZE, " %d" , bminutes);
		    }

		    /* Set the RTC ALARM B minutes */
	    	Set_DL(RTC_ALARM_B_MINUTE, &bminutes);
		    ALMBMIN.invalidate();
		    break;
		case 4:
		    if ((bseconds > 0) && (bseconds <= 59) )
		    {
		    	bseconds --;
			    Unicode::snprintf(ALMBSECBuffer, ALMBSEC_SIZE, " %d" , bseconds);
		    }

		    /* Set the RTC ALARM B seconds */
	    	Set_DL(RTC_ALARM_B_SECOND, &bseconds);
		    ALMBSEC.invalidate();
		    break;
		case 5:
		    if ((bwkdays > 1) && (bwkdays <= 7))
		    {
		    	bwkdays --;

		    	if(bwkdays == 6)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "SAT");
		    	else if(bwkdays == 5)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "FRI");
		    	else if(bwkdays == 4)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "THR");
		    	else if(bwkdays == 3)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "WED");
		    	else if(bwkdays == 2)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "TUE");
		    	else if(bwkdays == 1)
		    		Unicode::snprintf(ALMBDAYBuffer, ALMBDAY_SIZE, "MON");
		    }

		    /* Set the RTC ALARM B weekdays */
	    	Set_DL(RTC_ALARM_B_WEEK_DAY,(uint8_t *)&bwkdays);
		    ALMBDAY.invalidate();
		    break;
		default :
		    break;
        }
	}
	else
	if(KEY4_SHORT_PRESS == val)
	{
		/* Set the ALARM B */
		Set_DL(SET_ALARM_B, &bres);
	}
	else
	if(KEY4_LONG_PRESS == val)

	{		/* Long Press Keypad button */
		application().gotoRTCNXTScreenNoTransition();
	}

#endif
}

void ALARMBSCRView::alarmupdate(uint8_t val)
{
	if(ALARM_B_UPDATE == val)
	{
		Unicode::snprintf(ALARMBOCRBuffer, ALARMBOCR_SIZE, "Alarm_Occured" );
	}
	ALARMBOCR.invalidate();
}
void ALARMBSCRView::trigger()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;

   tickCounter++;
   if( 10 <= tickCounter)
   {
	   tickCounter = 0;
		/* Get the RTC DB */
		Get_DL(GET_RTC_SECOND, &Seconds);
		Get_DL(GET_RTC_MINUTE, &Minutes);
		Get_DL(GET_RTC_HOUR, &Hours);

	    //screenViewBase::setupScreen();
	    digitalHours = Hours;
	    digitalMinutes = Minutes;
	    digitalSeconds = Seconds;

        digitalClock3.setTime24Hour(digitalHours, digitalMinutes, digitalSeconds);

	    digitalClock3.invalidate();
   }
#endif
}



void ALARMBSCRView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
