#include <gui/ambblink_screen/AMBBLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

AMBBLINKView::AMBBLINKView()
{
#if (SDK_SERVICE_LED == PS_ENABLE)

#if(CONF_AMB_LED_PS_STATE == PS_ENABLE)
	blink = 0;

	/* Get the AMB LED Status from the DB */
	Get_DL(LED_AMB_STATE, &state);
	if (LED_ON == state)
	{
		Unicode::snprintf(AMBONBuffer, AMBON_SIZE, "ON");
	}
	else
		Unicode::snprintf(AMBONBuffer, AMBON_SIZE, "OFF");

	AMBON.invalidate();

	/* Get the AMB LED blink period from the DB */
	Get_DL(LED_AMB_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(AMBBLBuffer, AMBBL_SIZE, "  %d" , blink);
	AMBBL.invalidate();

#endif

#endif
}

void AMBBLINKView::setupScreen()
{
    AMBBLINKViewBase::setupScreen();
}

void AMBBLINKView::tearDownScreen()
{
    AMBBLINKViewBase::tearDownScreen();
}

void AMBBLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_LED == PS_ENABLE)

#if(CONF_AMB_LED_PS_STATE == PS_ENABLE)
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{

		 if (LED_OFF == state)
		 {
			 state = LED_ON;
			 /* Set the AMB LED Status */
			 Unicode::snprintf(AMBONBuffer, AMBON_SIZE, "ON");
		 }
		 else
		 {
			 state = LED_OFF;
			 /* Set the AMB LED Status */
			 Unicode::snprintf(AMBONBuffer, AMBON_SIZE, "OFF");
        }

		 Set_DL(LED_AMB_STATE, &state);
		 AMBON.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(AMBBLBuffer, AMBBL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(AMBBLBuffer, AMBBL_SIZE, "Max-%d" , blink);
		}

		/* Set the AMB LED blink period */
		Set_DL(LED_AMB_BLINKING, (uint8_t *)&blink);
		state = LED_ON;
		/* Set the AMB LED Status */
		Set_DL(LED_AMB_STATE, &state);
		AMBBL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(AMBBLBuffer, AMBBL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(AMBBLBuffer, AMBBL_SIZE, "Min-%d" , blink);
		}

		/* Set the AMBER LED blink period */
		Set_DL(LED_AMB_BLINKING, (uint8_t *)&blink);
		state = LED_ON;
		/* Set the AMB LED Status */
		Set_DL(LED_AMB_STATE, &state);
		AMBBL.invalidate();
	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

#endif

#endif
}

void AMBBLINKView::moveNextScreen()
{
	switch(key_position)
	{

	}
}

void AMBBLINKView::moveBackScreen()
{
	application().gotoAMBNXTScreenNoTransition();
}
void AMBBLINKView::moveNext()
{
}
void AMBBLINKView::movePrevious()
{
}

void AMBBLINKView::trigger()
{

}



void AMBBLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
