#include <gui/camera_screen/CameraView.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
#include "../../../../Core/Maximatecc/Inc/Data_Layer.h"
#include "../../../../Drivers/Maximatecc/inc/camera.h"

#define MAX_NUM_OF_MODE               4
#define VFHF_MAX                      2

void CameraView::updateResByStandard()
{   VideoStandardID();
	if (bVidDet_PAL)
	    	        	{
	    		x0 = PS_PAL_CAMERA_X0_ORIGIN;
	    		y0 = PS_PAL_CAMERA_Y0_ORIGIN;
	    		w0 = PS_PAL_CAMERA_X0_WIDTH;
	    		h0 = PS_PAL_CAMERA_Y0_HEIGHT;
	    	        	}
	    	else
	    	        	{
	    		x0 = PS_NTSC_CAMERA_X0_ORIGIN;
	    		y0 = PS_NTSC_CAMERA_Y0_ORIGIN;
	    		w0 = PS_NTSC_CAMERA_X0_WIDTH;
	    		h0 = PS_NTSC_CAMERA_Y0_HEIGHT;
	    	        	}
}

CameraView::CameraView()
{
#if (SDK_SERVICE_CAMERA == PS_ENABLE)
	mode = FULL_SCREEN_ON;
//	mode = RESIZE_TO_FULL_SCREEN_ON;
	x0_index = 0;
	y0_index = 0;
	h0_index = 0;
	w0_index = 0;
	dxy0_index = 0;
	streaming_mode = 0;
	vfindex = 0;
	vf = 0;
	hf = 0;
#endif
}

void CameraView::setupScreen()
{
	keyUpdate(KEY1_SHORT_PRESS);
	CameraViewBase::setupScreen();
}

void CameraView::tearDownScreen()
{
    CameraViewBase::tearDownScreen();
}

void CameraView::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}



void CameraView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_CAMERA == PS_ENABLE)
	if (KEY1_SHORT_PRESS == val)
	{
		mode++;
        if(MAX_NUM_OF_MODE == mode)
        {
        	mode = 1;
        }

    	dxy0_index = 0;
    	updateResByStandard();

        if (FULL_SCREEN_ON == mode)
        {
        	Unicode::snprintf(CAModeTABuffer, CAMODETA_SIZE, "FULL SCREEN");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
        }
        else
        if (RESIZE_TO_FULL_SCREEN_ON == mode)
        {
        	Unicode::snprintf(CAModeTABuffer, CAMODETA_SIZE, "Resize to FULL SCREEN");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
        }
        else
        if (DISPLAY_AS_IT_IS_ON == mode)
        {
        	Unicode::snprintf(CAModeTABuffer, CAMODETA_SIZE, "Display As it is");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
        }
//        else
//        if (CAMERA_STREAM_OFF == mode)
//        {
//        	Unicode::snprintf(CAModeTABuffer, CAMODETA_SIZE, "Camera OFF");
//			x0 = 0;
//			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
//			y0 = 0;
//			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
//			w0 = 0;
//			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
//			h0 = 0;
//			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
//			dx0 = 0;
//			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
//			dy0 = 0;
//			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
//        }
		vf = 0;
		Unicode::snprintf(VFTABuffer, VFTA_SIZE, "%d", dx0);
		hf = 0;
		Unicode::snprintf(HFTABuffer, HFTA_SIZE, "%d", dy0);

	}
	else
	if(KEY1_LONG_PRESS == val)
		moveBackScreen();
	else
	if (KEY2_SHORT_PRESS == val)
	{
		if (FULL_SCREEN_ON == mode)
        {
        	Unicode::snprintf(CAModeTABuffer, 10, "FULL SCREEN");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
        }
	}
	else
	if (KEY2_LONG_PRESS == val)
	{
		if (FULL_SCREEN_ON == mode)
        {
        	Unicode::snprintf(CAModeTABuffer, 10, "FULL SCREEN");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
        }
		Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
	}
	else
	if (KEY3_SHORT_PRESS == val)
	{
		if (FULL_SCREEN_ON == mode)
        {
        	Unicode::snprintf(CAModeTABuffer, 10, "FULL SCREEN");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
        }
	}
	else
	if (KEY3_LONG_PRESS == val)
	{
		if (FULL_SCREEN_ON == mode)
        {
        	Unicode::snprintf(CAModeTABuffer, 10, "FULL SCREEN");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
        }
	}
	else
	if (KEY4_SHORT_PRESS == val)
	{

		if (FULL_SCREEN_ON == mode)
        {

        	Unicode::snprintf(CAModeTABuffer, 10, "FULL SCREEN");
			Unicode::snprintf(CSX0TABuffer, CSX0TA_SIZE, "%d", x0);
			Unicode::snprintf(CSY0TABuffer, CSY0TA_SIZE, "%d", y0);
			Unicode::snprintf(CSW0TABuffer, CSW0TA_SIZE, "%d", w0);
			Unicode::snprintf(CSH0TABuffer, CSH0TA_SIZE, "%d", h0);
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
			vfindex++;
			if(VFHF_MAX < vfindex)
				vfindex = 0;
			switch(vfindex)
			{
			case 0:
				vf = 0;
				hf = 0;
				break;
			case 1:
				vf = 1;
				hf = 0;
				break;
			case 2:
				vf = 0;
				hf = 1;
				break;
			}
			Unicode::snprintf(VFTABuffer, VFTA_SIZE, "%d", vf);
			Unicode::snprintf(HFTABuffer, HFTA_SIZE, "%d", hf);

        }
		else
	    if (RESIZE_TO_FULL_SCREEN_ON == mode)
	    {
			dx0 = 0;
			Unicode::snprintf(DSY0TA_1_1Buffer, DSY0TA_1_1_SIZE, "%d", dx0);
			dy0 = 0;
			Unicode::snprintf(DSY0TA_1Buffer, DSY0TA_1_SIZE, "%d", dy0);
	    }
	}
	else
	if (KEY4_LONG_PRESS == val)
	{
		if (FULL_SCREEN_ON == mode)
        {
			Set_DL(CAMERA_VIDEO_FLIP_VERTICAL, &vf);
			Set_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, &hf);

			/* Call the DB Variable to set the Full screen Mode */
			Set_DL(CAMERA_VIDEO_MODE, &mode);

			mode = CAMERA_STREAM_ON;
			Set_DL(CAMERA_VIDEO_STREAM, &mode);
        }
		else
		if (RESIZE_TO_FULL_SCREEN_ON == mode)
		{
			if (bVidDet_PAL)
			            {
						Set_DL(PAL_CAMERA_X0_WIDTH, (uint8_t *) &w0);
						Set_DL(PAL_CAMERA_Y0_HEIGHT, (uint8_t *) &h0);
						Set_DL(PAL_CAMERA_X0_ORIGIN, (uint8_t *) &x0);
						Set_DL(PAL_CAMERA_Y0_ORIGIN, (uint8_t *) &y0);
						}
			if (bVidDet_NTSC)
						{
						Set_DL(NTSC_CAMERA_X0_WIDTH, (uint8_t *) &w0);
						Set_DL(NTSC_CAMERA_Y0_HEIGHT, (uint8_t *) &h0);
						Set_DL(NTSC_CAMERA_X0_ORIGIN, (uint8_t *) &x0);
						Set_DL(NTSC_CAMERA_Y0_ORIGIN, (uint8_t *) &y0);
						}
			Set_DL(CAMERA_VIDEO_FLIP_VERTICAL, &vf);
			Set_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, &hf);
			/* Call the DB Variable to set the Full screen Mode */
			Set_DL(CAMERA_VIDEO_MODE, &mode);

			mode = CAMERA_STREAM_ON;
			Set_DL(CAMERA_VIDEO_STREAM, &mode);
		}
		else
		if (DISPLAY_AS_IT_IS_ON == mode)
		{
			if (bVidDet_PAL)
			{
				Set_DL(PAL_CAMERA_X0_ORIGIN, (uint8_t *) &x0);
				Set_DL(PAL_CAMERA_Y0_ORIGIN, (uint8_t *) &y0);
			}
			if (bVidDet_NTSC)
			{
				Set_DL(NTSC_CAMERA_X0_ORIGIN, (uint8_t *) &x0);
				Set_DL(NTSC_CAMERA_Y0_ORIGIN, (uint8_t *) &y0);
			}

#if (SDK_SERVICE_LCD == PS_ENABLE)
			Set_DL(DISPLAY_X0_ORIGIN, (uint8_t *) &dx0);
			Set_DL(DISPLAY_Y0_ORIGIN, (uint8_t *) &dy0);
#endif

			Set_DL(CAMERA_VIDEO_FLIP_VERTICAL, &vf);
			Set_DL(CAMERA_VIDEO_FLIP_HORIZONTAL, &hf);
			/* Call the DB Variable to set the Full screen Mode */
			Set_DL(CAMERA_VIDEO_MODE, &mode);

			mode = CAMERA_STREAM_ON;
			Set_DL(CAMERA_VIDEO_STREAM, &mode);
		}
	}

	__background.invalidate();
		Camera.invalidate();
		textArea1.invalidate();
		line1.invalidate();
		textArea1_1.invalidate();
		textArea1_1_1.invalidate();
		button1.invalidate();
		textArea1_1_2.invalidate();
		box1.invalidate();
		CSX0TA.invalidate();
		textArea1_1_2_1.invalidate();
		box1_1.invalidate();
		CSY0TA.invalidate();
		textArea1_1_2_1_1.invalidate();
		box1_1_1.invalidate();
		CSW0TA.invalidate();
		textArea1_1_2_1_1_1.invalidate();
		box1_1_1_1.invalidate();
		CSH0TA.invalidate();
		textArea1_1_3.invalidate();
		textArea1_1_2_2.invalidate();
		box1_2.invalidate();
		DSY0TA_1_1.invalidate();
		textArea1_1_2_2_1.invalidate();
		box1_2_1.invalidate();
		DSY0TA_1.invalidate();
		textArea2.invalidate();
		textArea2_1.invalidate();
		textArea2_1_1.invalidate();
		textArea2_1_1_1.invalidate();
		CAModeTA.invalidate();
		textArea1_1_2_2_1_1.invalidate();
		box1_2_1_1.invalidate();
		VFTA.invalidate();
		textArea1_1_2_2_1_1_1.invalidate();
		box1_2_1_1_1.invalidate();
		HFTA.invalidate();
#endif
}

void CameraView::trigger()
{
}

void CameraView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

