#include <gui/can2_screen/CAN2View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
Unicode::UnicodeChar can_buffer0[64];
uint8_t can_rxbuffer0[64];
Unicode::UnicodeChar trxbuffer0[64];
uint8_t can0buf[64];
uint8_t can0_buf[10];

CAN2View::CAN2View()
{
	key_position = 0;
	can0_key_pos = 0;
}

void CAN2View::setupScreen()
{
	CAN2ViewBase::setupScreen();
}

void CAN2View::tearDownScreen()
{
	CAN2ViewBase::tearDownScreen();
}

void CAN2View::trigger()
{

#if (SDK_SERVICE_FDCAN == PS_ENABLE)
	uint8_t status;

	/* Get the RX status */
	Get_DL(CAN0_RX_DATA_SIZE, &status);

	if(0 != status)
	{
		memset(&can_rxbuffer0[0], 0x00, sizeof(can_rxbuffer0));
		/* Read the Rx data from the DB */
		Get_DL(CAN0_RX_DATA, (uint8_t *)&can_rxbuffer0[0]);
		memset(&trxbuffer0[0], 0x00, sizeof(trxbuffer0));
		Unicode::strncpy(&trxbuffer0[0], (const char*)&can_rxbuffer0[0] ,
				strlen((const char*)can_rxbuffer0));

		memset(CAN0RCVBuffer, 0x00, sizeof(CAN0RCVBuffer));
		Unicode::snprintf(CAN0RCVBuffer, CAN0RCV_SIZE, "%x %x %x %x %x %x %x %x", can_rxbuffer0[0],
				can_rxbuffer0[1], can_rxbuffer0[2], can_rxbuffer0[3], can_rxbuffer0[4], can_rxbuffer0[5],
				can_rxbuffer0[6], can_rxbuffer0[7]);
		CAN0RCV.invalidate();

	}

#endif
}

void CAN2View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_FDCAN == PS_ENABLE)

	if((KEY1_LONG_PRESS == val))
	{
		can0_key_pos++;

		if (5 == can0_key_pos)
			can0_key_pos = 1;

		switch(can0_key_pos)
		{
			case 1:

				Get_DL(CAN_CH0_STATES, &can0_buf[0]);

				if(CAN_BUS_OFF != can0_buf[0])
				{
					Get_DL(CAN0_RX_DATA_IS_AVAILABLE, &can0_buf[0]);
					Unicode::snprintf(CAN0TEXTBuffer, 10, "%d", can0_buf);
					CAN0TEXT.invalidate();

					Get_DL(CAN_CH0_COMM_STATE_EVENTS, &can0_buf[0]);
					Unicode::snprintf(CAN0TEXTBuffer, 10, "%d", can0_buf);
					CAN0TEXT.invalidate();

					Get_DL(CAN0_RX_BYTE_COUNT, &can0_buf[0]);
					Unicode::snprintf(CAN0TEXTBuffer, 10, "%d", can0_buf);
					CAN0TEXT.invalidate();

					Get_DL(CAN0_TX_BYTE_COUNT, &can0_buf[0]);
					Unicode::snprintf(CAN0TEXTBuffer, 10, "%d", can0_buf);
					CAN0TEXT.invalidate();
				}
				break;

			case 2:

				can0_buf[0] = ENABLE;
				Set_DL(CAN_CH0_FILTER_INDEX_ENABLE, &can0_buf[0]);

				can0_buf[0] = 10;
				Set_DL(CAN_CH0_FILTER_INDEX_ID, &can0_buf[0]);

				can0_buf[0] = CAN_MODE_STANDARD_ID;
				Set_DL(CAN_CH0_MODE, &can0_buf[0]);

				break;

			case 3:
				/*
				 * CAN0 Supporting baud rate
				 * BAUDRATE_50K
				 * BAUDRATE_100K
				 * BAUDRATE_125K
				 * BAUDRATE_250K
				 * BAUDRATE_500K
				 * BAUDRATE_1000K
				 */
				can0_buf[0] = BAUDRATE_250K;
				Set_DL(CAN_CH0_BAUDRATE, &can0_buf[0]);
				break;

			case 4:

				can0_buf[0] = TRUE;
				Set_DL(CAN_CH0_RESET, &can0_buf[0]);
				break;

			case 5:

				can0_buf[0] = TRUE;
				Set_DL(CAN_CH0_DRIVER_RESET, &can0_buf[0]);
				break;
		}

	}

	else
	if((KEY2_SHORT_PRESS == val))
	{

		key_position++;

		const char str10[] = {65, 66, 67, 68, 69, 70, 71, 72};
		const char str11[] = {72, 71, 70, 69, 68, 67, 66, 65};
		const char str12[] = {73, 74, 75, 76, 77, 78, 79, 80};
		const char str13[] = {80, 79, 78, 77, 76, 75, 74, 73};

		if (5 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:

			/* Clear the buffer */
			memset(&can_buffer0[0], 0x00, sizeof(can_buffer0));
			Unicode::strncpy(can_buffer0, str10 , strlen(str10));
			Unicode::snprintf(CAN0SENDBuffer, 20, "%s", can_buffer0);
			CAN0SEND.invalidate();
			break;

		case 2:

			/* Clear the buffer */
			memset(&can_buffer0[0], 0x00, sizeof(can_buffer0));
			Unicode::strncpy(can_buffer0, str11 , strlen(str11));
			Unicode::snprintf(CAN0SENDBuffer, 20, "%s", can_buffer0);
			CAN0SEND.invalidate();
		    break;

		case 3:

			/* Clear the buffer */
			memset(&can_buffer0[0], 0x00, sizeof(can_buffer0));
			Unicode::strncpy(can_buffer0, str12 , strlen(str12));
			Unicode::snprintf(CAN0SENDBuffer, 20, "%s", can_buffer0);
			CAN0SEND.invalidate();
			break;

		case 4:

			/* Clear the buffer */
			memset(&can_buffer0[0], 0x00, sizeof(can_buffer0));
			Unicode::strncpy(can_buffer0, str13 , strlen(str13));
			Unicode::snprintf(CAN0SENDBuffer, 20, "%s", can_buffer0);
			CAN0SEND.invalidate();
			break;

		default:
			 ;
		 break;

	   }

    }

	else
	if(KEY2_LONG_PRESS == val)
	{


	}

	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		application().gotoCANXTScreenNoTransition();
	}

	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		Unicode::toUTF8(can_buffer0, can0buf, 8);

		/*set the USB tx data */
		Set_DL(CAN0_TX_DATA , (uint8_t *)&can0buf[0]);

	}
#endif
}

void CAN2View::moveNextScreen()
{

}

void CAN2View::moveBackScreen()
{

}

void CAN2View::moveNext()
{

}

void CAN2View::movePrevious()
{

}

void CAN2View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}


