#include <gui/can_screen/CANView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
Unicode::UnicodeChar can_buffer1[64];
uint8_t can_rxbuffer1[64];
Unicode::UnicodeChar trxbuffer1[64];
uint8_t can1buf[64];
uint8_t can1_buf[10];
CANView::CANView()
{
	key_position = 0;
	can1_key_pos = 0;
}

void CANView::setupScreen()
{
	CANViewBase::setupScreen();
}

void CANView::tearDownScreen()
{
	CANViewBase::tearDownScreen();
}

void CANView::trigger()
{

#if (SDK_SERVICE_FDCAN == PS_ENABLE)
	uint8_t status;

	/* Get the RX status */
	Get_DL(CAN1_RX_DATA_SIZE, &status);

	if(0 != status)
	{
		memset(&can_rxbuffer1[0], 0x00, sizeof(can_rxbuffer1));
		/* Read the Rx data from the DB */
		Get_DL(CAN1_RX_DATA, (uint8_t *)&can_rxbuffer1[0]);
		memset(&trxbuffer1[0], 0x00, sizeof(trxbuffer1));
		Unicode::strncpy(&trxbuffer1[0], (const char*)&can_rxbuffer1[0] ,
				strlen((const char*)can_rxbuffer1));

		memset(CAN1RCVBuffer, 0x00, sizeof(CAN1RCVBuffer));
		Unicode::snprintf(CAN1RCVBuffer, CAN1RCV_SIZE, "%x %x %x %x %x %x %x %x", can_rxbuffer1[0],
				can_rxbuffer1[1], can_rxbuffer1[2], can_rxbuffer1[3], can_rxbuffer1[4], can_rxbuffer1[5],
				can_rxbuffer1[6], can_rxbuffer1[7]);
		CAN1RCV.invalidate();

	}

#endif
}

void CANView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_FDCAN == PS_ENABLE)

	if((KEY1_LONG_PRESS == val))
	{
		can1_key_pos++;

		if (5 == can1_key_pos)
			can1_key_pos = 1;

		switch(can1_key_pos)
		{
			case 1:

				Get_DL(CAN_CH1_STATES, &can1_buf[0]);

				if(CAN_BUS_OFF != can1_buf[0])
				{
					Get_DL(CAN1_RX_DATA_IS_AVAILABLE, &can1_buf[0]);
					Unicode::snprintf(CAN1TEXTBuffer, 10, "%d", can1_buf);
					CAN1TEXT.invalidate();

					Get_DL(CAN_CH1_COMM_STATE_EVENTS, &can1_buf[0]);
					Unicode::snprintf(CAN1TEXTBuffer, 10, "%d", can1_buf);
					CAN1TEXT.invalidate();

					Get_DL(CAN1_RX_BYTE_COUNT, &can1_buf[0]);
					Unicode::snprintf(CAN1TEXTBuffer, 10, "%d", can1_buf);
					CAN1TEXT.invalidate();

					Get_DL(CAN1_TX_BYTE_COUNT, &can1_buf[0]);
					Unicode::snprintf(CAN1TEXTBuffer, 10, "%d", can1_buf);
					CAN1TEXT.invalidate();
				}
				break;

			case 2:

				can1_buf[0] = ENABLE;
				Set_DL(CAN_CH1_FILTER_INDEX_ENABLE, &can1_buf[0]);

				can1_buf[0] = 20;
				Set_DL(CAN_CH1_FILTER_INDEX_ID, &can1_buf[0]);

				can1_buf[0] = CAN_MODE_STANDARD_ID;
				Set_DL(CAN_CH1_MODE, &can1_buf[0]);
				break;

			case 3:

				/*
				 * CAN1 Supporting baud rate
				 * BAUDRATE_50K
				 * BAUDRATE_100K
				 * BAUDRATE_125K
				 * BAUDRATE_250K
				 * BAUDRATE_500K
				 * BAUDRATE_1000K
				 */
				can1_buf[0] = BAUDRATE_250K;
				Set_DL(CAN_CH1_BAUDRATE, &can1_buf[0]);
				break;

			case 4:

				can1_buf[0] = TRUE;
				Set_DL(CAN_CH1_RESET, &can1_buf[0]);
				break;

			case 5:

				can1_buf[0] = TRUE;
				Set_DL(CAN_CH1_DRIVER_RESET, &can1_buf[0]);
				break;
		}
	}

	else
	if((KEY2_SHORT_PRESS == val))
	{

		key_position++;

		const char str10[] = {65, 66, 67, 68, 69, 70, 71, 72};
		const char str11[] = {72, 71, 70, 69, 68, 67, 66, 65};
		const char str12[] = {73, 74, 75, 76, 77, 78, 79, 80};
		const char str13[] = {80, 79, 78, 77, 76, 75, 74, 73};

		if (5 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:

			/* Clear the buffer */
			memset(&can_buffer1[0], 0x00, sizeof(can_buffer1));
			Unicode::strncpy(can_buffer1, str10 , strlen(str10));
			Unicode::snprintf(CAN1SENDBuffer, 20, "%s", can_buffer1);
			CAN1SEND.invalidate();
			break;

		case 2:

			/* Clear the buffer */
			memset(&can_buffer1[0], 0x00, sizeof(can_buffer1));
			Unicode::strncpy(can_buffer1, str11 , strlen(str11));
			Unicode::snprintf(CAN1SENDBuffer, 20, "%s", can_buffer1);
			CAN1SEND.invalidate();
		    break;

		case 3:

			/* Clear the buffer */
			memset(&can_buffer1[0], 0x00, sizeof(can_buffer1));
			Unicode::strncpy(can_buffer1, str12 , strlen(str12));
			Unicode::snprintf(CAN1SENDBuffer, 20, "%s", can_buffer1);
			CAN1SEND.invalidate();
			break;

		case 4:

			/* Clear the buffer */
			memset(&can_buffer1[0], 0x00, sizeof(can_buffer1));
			Unicode::strncpy(can_buffer1, str13 , strlen(str13));
			Unicode::snprintf(CAN1SENDBuffer, 20, "%s", can_buffer1);
			CAN1SEND.invalidate();
			break;

		default:
			 ;
		 break;

	   }

    }

	else
	if(KEY2_LONG_PRESS == val)
	{


	}

	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		application().gotoCANXTScreenNoTransition();
	}

	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		Unicode::toUTF8(can_buffer1, can1buf, 8);

		/*set the USB tx data */
		Set_DL(CAN1_TX_DATA , (uint8_t *)&can1buf[0]);

	}
#endif
}

void CANView::moveNextScreen()
{

}

void CANView::moveBackScreen()
{

}

void CANView::moveNext()
{

}

void CANView::movePrevious()
{

}

void CANView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
