#include <gui/date_screen/DATEView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
DATEView::DATEView()
{
	wkdays 		 = 1;
	date 		 = 0;
	month 		 = 1;
	year 		 = 0;
	res 		 = 1;
	key_position = 1;


	/* Active the first button */
	WKDAY.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	WKDAY.invalidate();

    Get_DL(GET_RTC_TIME_FORMAT, &format);
    Set_DL(RTC_TIME_FORMAT, &format);
    Get_DL(GET_RTC_HOUR, &hours);
    Set_DL(RTC_HOUR, &hours);
    Get_DL(GET_RTC_MINUTE, &minutes);
    Set_DL(RTC_MINUTE, &minutes);
    Get_DL(GET_RTC_SECOND, &seconds);
    Set_DL(RTC_SECOND, &seconds);

	/* Get the RTC weekdays */
	Get_DL(GET_RTC_WEEK_DAY, (uint8_t *)&wkdays);
	Set_DL(RTC_WEEK_DAY, (uint8_t *)&wkdays);

    if((wkdays>=0)&&(wkdays<7))
    {
    	if(wkdays == 1)
    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "MON");
    	else if(wkdays == 2)
    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "TUE");
    	else if(wkdays == 3)
    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "WED");
    	else if(wkdays == 4)
    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "THR");
    	else if(wkdays == 5)
    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "FRI");
    	else if(wkdays == 6)
    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "SAT");
    	else if(wkdays == 0)
    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "SUN");
    }
    WKDAY.invalidate();

	/* Get the RTC date */
	Get_DL(GET_RTC_DATE, &date);
	Set_DL(RTC_DATE, &date);

    if((date>=0)&&(date<=31))
    {
    	Unicode::snprintf(DATEBuffer, DATE_SIZE, "%.2d" , date);
    }
	DATE.invalidate();

	/* Get the RTC month */
	Get_DL(GET_RTC_MONTH, &month);
	Set_DL(RTC_MONTH, &month);

    if((month>=0)&&(month<12))
    {
    	if(month == 0)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JAN");
    	else if(month == 1)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "FEB");
    	else if(month == 2)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "MAR");
    	else if(month == 3)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "APR");
    	else if(month == 4)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "MAY");
    	else if(month == 5)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JUN");
    	else if(month == 6)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JLY");
    	else if(month == 7)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "AUG");
    	else if(month == 8)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "SEP");
    	else if(month == 9)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "OCT");
    	else if(month == 10)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "NOV");
    	else if(month == 11)
    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "DEC");
    }
    MONTH.invalidate();

	/* Get the RTC year */
	Get_DL(GET_RTC_YEAR, &year);
	Set_DL(RTC_YEAR, &year);

    if((year>=0)&&(year<=99))
    {
    	Unicode::snprintf(YEARBuffer, YEAR_SIZE, "%.2d" , year);
    }
	YEAR.invalidate();


}

void DATEView::setupScreen()
{
    DATEViewBase::setupScreen();
}

void DATEView::tearDownScreen()
{
    DATEViewBase::tearDownScreen();
}

void DATEView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))

	{
		key_position++;

			if (5 == key_position)
				key_position = 1;

			switch(key_position)
			{
			case 1:
				/* DESelect the Keypad button */
				YEAR.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				YEAR.invalidate();

				/* Select the Keypad button */
				WKDAY.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				WKDAY.invalidate();
				break;
			case 2:
				/* DESelect the Keypad button */
				WKDAY.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				WKDAY.invalidate();

				/* Select the Keypad button */
				DATE.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				DATE.invalidate();
				break;
			case 3:
				/* DESelect the Keypad button */
				DATE.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				DATE.invalidate();

				/* Select the Keypad button */
				MONTH.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				MONTH.invalidate();
				break;
			case 4:
				/* DESelect the Keypad button */
				MONTH.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				MONTH.invalidate();

				/* Select the Keypad button */
				YEAR.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				YEAR.invalidate();
				break;
			default:
					break;
			}
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))

	{
		uint32_t position = key_position;

		switch (position)
		{
		case 1:
		    if ((wkdays >= 0) && (wkdays <= 7))
		    {
		    	wkdays ++;

		    	if(wkdays == 2)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "TUE");
		    	else if(wkdays == 3)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "WED");
		    	else if(wkdays == 4)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "THR");
		    	else if(wkdays == 5)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "FRI");
		    	else if(wkdays == 6)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "SAT");
		    	else if(wkdays == 7)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "SUN");
		    }

		    /* Set the RTC wkdays */
	    	Set_DL(RTC_WEEK_DAY, (uint8_t*)&wkdays);
	    	WKDAY.invalidate();
		    break;
		case 2:
		    if ((date >= 0) && (date < 31))
		    {
		    	date ++;
		    	Unicode::snprintf(DATEBuffer, DATE_SIZE, "%d" , date);
		    }

		    /* Set the RTC date */
	    	Set_DL(RTC_DATE, &date);
	    	DATE.invalidate();
		    break;
		case 3:
		    if ((month >= 0) && (month < 11) )
		    {
		    	month ++;
		    	if(month == 1)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "FEB");
		    	else if(month == 2)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "MAR");
		    	else if(month == 3)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "APR");
		    	else if(month == 4)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "MAY");
		    	else if(month == 5)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JUN");
		    	else if(month == 6)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JLY");
		    	else if(month == 7)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "AUG");
		    	else if(month == 8)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "SEP");
		    	else if(month == 9)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "OCT");
		    	else if(month == 10)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "NOV");
		    	else if(month == 11)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "DEC");
		    }

		    /* Set the RTC month */
	    	Set_DL(RTC_MONTH, &month);
	    	MONTH.invalidate();
		    break;
		case 4:
		    if ((year >= 0) && (year < 99))
		    {
		    	year ++;
		    	Unicode::snprintf(YEARBuffer, YEAR_SIZE, "%d" , year);
		    }

		    /* Set the RTC year */
	    	Set_DL(RTC_YEAR, &year);
	    	YEAR.invalidate();
		    break;
		default :
		    break;
	    }

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;
		switch (position)
		{

		case 1:
		    if ((wkdays > 1) && (wkdays <= 7))
		    {
		    	wkdays --;

		    	if(wkdays == 6)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "SAT");
		    	else if(wkdays == 5)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "FRI");
		    	else if(wkdays == 4)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "THR");
		    	else if(wkdays == 3)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "WED");
		    	else if(wkdays == 2)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "TUE");
		    	else if(wkdays == 1)
		    		Unicode::snprintf(WKDAYBuffer, WKDAY_SIZE, "MON");
		    }

		    /* Set the RTC wkdays */
	    	Set_DL(RTC_WEEK_DAY, (uint8_t*)&wkdays);
	    	WKDAY.invalidate();
		    break;
        case 2:
		    if ((date > 1) && (date <= 31))
		    {
		    	date --;
		    	Unicode::snprintf(DATEBuffer, DATE_SIZE, "%d" , date);
		    }

		    /* Set the RTC date */
	    	Set_DL(RTC_DATE, &date);
	    	DATE.invalidate();
		    break;
		case 3:
		    if ((month > 0) && (month < 12) )
		    {
		    	month --;
		    	if(month == 10)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "NOV");
		    	else if(month == 9)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "OCT");
		    	else if(month == 8)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "SEP");
		    	else if(month == 7)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "AUG");
		    	else if(month == 6)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JLY");
		    	else if(month == 5)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JUN");
		    	else if(month == 4)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "MAY");
		    	else if(month == 3)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "APR");
		    	else if(month == 2)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "MAR");
		    	else if(month == 1)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "FEB");
		    	else if(month == 0)
		    		Unicode::snprintf(MONTHBuffer, MONTH_SIZE, "JAN");
		    }

		    /* Set the RTC month */
	    	Set_DL(RTC_MONTH, &month);
	    	MONTH.invalidate();
		    break;
		case 4:
		    if ((year > 0) && (year <= 99))
		    {
		    	year --;
		    	Unicode::snprintf(YEARBuffer, YEAR_SIZE, "%d" , year);
		    }

		    /* Set the RTC year */
	    	Set_DL(RTC_YEAR, &year);
		    YEAR.invalidate();
		    break;
		default :
		    break;
        }

}
	else
	if(KEY4_SHORT_PRESS == val)
	{
		Set_DL(SET_RTC, &res);
	}
	else
	if(KEY4_LONG_PRESS == val)
	{
		/* Long Press Keypad button */
		application().gotoRTCSCRScreenNoTransition();
	}

}


void DATEView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

void DATEView::trigger( )
{

}
