#include <gui/dout_screen/DOutView.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

DOutView::DOutView()
{
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
	state = 0;
	key_position = 1;
	/* Active the first button */
	HSTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	HSTA.invalidate();

	Get_DL(DIGITAL_OUTPUT_01_CFG, &state);
	if(state == CONF_LOW_SIDE_DRIVER)
	{
		Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "LowSide");
	}
	else if(state == CONF_HIGH_SIDE_DRIVER)
	{
		Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "HighSide");
	}
	else
	{
		Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "OpenDrive");
	}
#endif
}

void DOutView::setupScreen()
{
    DOutViewBase::setupScreen();
}

void DOutView::tearDownScreen()
{
    DOutViewBase::tearDownScreen();
}

void DOutView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveEnter();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void DOutView::moveEnter()
{
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)

	switch(key_position)
	{
		case 1:
			state = CONF_HIGH_SIDE_DRIVER;

			/* Set the High side Digital Output */
			Set_DL(DIGITAL_OUTPUT_01_CFG, &state);

			Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "HighSide");
			break;
		case 2:
			state = CONF_LOW_SIDE_DRIVER;

			/* Set the Low side Digital Output */
			Set_DL(DIGITAL_OUTPUT_01_CFG, &state);

			Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "LowSide");
			break;
		case 3:

			state = 0;

			Get_DL(DIGITAL_OUTPUT_01_CFG, &state);

			if(state == CONF_LOW_SIDE_DRIVER)
			{
				Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "LowSide");
			}
			else if(state == CONF_HIGH_SIDE_DRIVER)
			{
				Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "HighSide");
			}
			else
			{
				Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "OpenDrive");
			}

			state = CONF_DIGITAL_OUTPUT_ON;
			/* Set the open drive Digital Output */
			Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

			break;
		case 4:

			state = CONF_DIGITAL_OUTPUT_OFF;
			/* Set the open drive Digital Output */
			Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

			Unicode::snprintf(DISTTABuffer, DISTTA_SIZE, "OpenDrive");

			break;
		default:
			break;
			}
	DISTTA.invalidate();

#endif
}

void DOutView::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}

void DOutView::movePrevious()
{
	key_position--;

	if (0 == key_position)
		key_position = 4;

	switch(key_position)
	{
	case 1:
		/* DESelect the Keypad button */
		HSTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		HSTA.invalidate();

		/* Select the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LSTA.invalidate();
		break;

	case 2:
		/* DESelect the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LSTA.invalidate();

		/* Select the Keypad button */
		ONTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		ONTA.invalidate();
		break;

	case 3:
		/* DESelect the Keypad button */
		ONTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		ONTA.invalidate();

		/* Select the Keypad button */
		OFFTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		OFFTA.invalidate();
		break;

	case 4:
		/* DESelect the Keypad button */
		OFFTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		OFFTA.invalidate();

		/* Select the Keypad button */
		HSTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		HSTA.invalidate();
		break;
	default :
        break;
	}
}


void DOutView::moveNext()
{
	key_position++;

	if (5 == key_position)
		key_position = 1;

	switch(key_position)
	{
	case 1:
		/* DESelect the Keypad button */
		OFFTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		OFFTA.invalidate();

		/* Select the Keypad button */
		HSTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		HSTA.invalidate();
		break;

	case 2:
		/* DESelect the Keypad button */
		HSTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		HSTA.invalidate();

		/* Select the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LSTA.invalidate();
		break;

	case 3:
		/* DESelect the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LSTA.invalidate();

		/* Select the Keypad button */
		ONTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		ONTA.invalidate();
		break;

	case 4:
		/* DESelect the Keypad button */
		ONTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		ONTA.invalidate();

		/* Select the Keypad button */
		OFFTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		OFFTA.invalidate();
		break;

	default :
		break;
	}
}

void DOutView::trigger()
{

}

void DOutView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
