#include <gui/eeprom1_screen/EEPROM1View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

EEPROM1View::EEPROM1View()
{
	key_position= 1;
	value = 0;
	place1 = 1;
	/* Active the first button */
	EPROM.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	EPROM.invalidate();
}

void EEPROM1View::setupScreen()
{
    EEPROM1ViewBase::setupScreen();
}

void EEPROM1View::tearDownScreen()
{
    EEPROM1ViewBase::tearDownScreen();
}

void EEPROM1View::trigger()
{

}

void EEPROM1View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_EEPROM == PS_ENABLE)
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			PLHLDR.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			PLHLDR.invalidate();

			/* Select the Keypad button */
			EPROM.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			EPROM.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			EPROM.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			EPROM.invalidate();

			/* Select the Keypad button */
			PLHLDR.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			PLHLDR.invalidate();
			break;
		default:
			break;
		}
	}

	else
	if(KEY2_SHORT_PRESS == val)
	{
		uint32_t position = key_position;

		switch (position)
		{
		case 1:
			break;

		break;
		case 2:
			if ((place1 < 65535) && (place1 >= 0))
			{
				place1 ++;
				Unicode::snprintf(PLHLDRBuffer, PLHLDR_SIZE, " %d" , place1);
			}
			else
			{
				Unicode::snprintf(PLHLDRBuffer, PLHLDR_SIZE, "Max-%d" , place1);
			}

			PLHLDR.invalidate();
			break;
		default:
			break;
		}
	}
	else
	if(KEY2_LONG_PRESS == val)
	{
		application().gotoWREEPROM1ScreenNoTransition();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{
		case 1:
			break;

		case 2:
		if ((place1 > 0) && (place1 <= 65535))
		{
			place1 --;
			Unicode::snprintf(PLHLDRBuffer, PLHLDR_SIZE, " %d" , place1);
		}
		else
		{
			Unicode::snprintf(PLHLDRBuffer, PLHLDR_SIZE, "Min-%d" , place1);
		}

		PLHLDR.invalidate();
		break;
		default:
			break;
		}

	}

	else
	if(KEY4_SHORT_PRESS == val)
	{
		Get_DL((START_EEPROM+place1),(uint8_t *)&value);
		Unicode::snprintf(READTXTBuffer, READTXT_SIZE, "%d" , value);
		READTXT.invalidate();
	}

	else
	if(KEY4_LONG_PRESS == val)
	{
		application().gotoIngtestScreenNoTransition();
	}
#endif
}

void EEPROM1View::moveNextScreen()
{

}

void EEPROM1View::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}
void EEPROM1View::moveNext()
{
}
void EEPROM1View::movePrevious()
{
}

void EEPROM1View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
