#include <gui/flash_screen/FLASHView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
extern uint8_t w_idx;

FLASHView::FLASHView()
{
	key_position= 1;
	value = 0;
	rdflash = 0;
	/* Active the first button */
	WRITE.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	WRITE.invalidate();
}

void FLASHView::setupScreen()
{
    FLASHViewBase::setupScreen();
}

void FLASHView::tearDownScreen()
{
    FLASHViewBase::tearDownScreen();
}

void FLASHView::trigger()
{

}

void FLASHView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			RDFLASH.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			RDFLASH.invalidate();

			/* Select the Keypad button */
			WRITE.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WRITE.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WRITE.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WRITE.invalidate();

			/* Select the Keypad button */
			RDFLASH.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			RDFLASH.invalidate();
			break;
		default:
			break;
		}
	}

	else
	if(KEY2_SHORT_PRESS == val)
	{
		if ((rdflash < 65535) && (rdflash >= 0))
		{
			rdflash ++;
			Unicode::snprintf(RDFLASHBuffer, RDFLASH_SIZE, "%.2d" , rdflash);
		}
		else
		{
			Unicode::snprintf(RDFLASHBuffer, RDFLASH_SIZE, "Max-%d" , rdflash);
		}

		RDFLASH.invalidate();
	}

	else
	if(KEY2_LONG_PRESS == val)
	{
	application().gotoWRFLASHScreenNoTransition();
	}

	else
	if(KEY3_SHORT_PRESS == val)
	{

		if ((rdflash > 0) && (rdflash <= 65535))
		{
			rdflash --;
			Unicode::snprintf(RDFLASHBuffer, RDFLASH_SIZE, "%.2d" , rdflash);
		}
		else
		{
			Unicode::snprintf(RDFLASHBuffer, RDFLASH_SIZE, "Min-%.2d" , rdflash);
		}

		RDFLASH.invalidate();
	}
	else
	if(KEY3_LONG_PRESS == val)
	{
#if (SDK_SERVICE_QSPI == PS_ENABLE)
		QSPI_Read(&rdata[0], rdflash, sizeof(rdata));
		Unicode::snprintf(READTXTBuffer, READTXT_SIZE, "%d" , rdata[w_idx]);
		READTXT.invalidate();
#endif
	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoIngtestScreenNoTransition();
	}

}

void FLASHView::moveNextScreen()
{

}

void FLASHView::moveBackScreen()
{

}
void FLASHView::moveNext()
{
}
void FLASHView::movePrevious()
{
}

void FLASHView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
