#include <gui/ingtest_screen/IngtestView.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

IngtestView::IngtestView()
{
	key_position = 1;

	/* Active the first button */
	KPTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	KPTA.invalidate();
}
void IngtestView::trigger()
{
	this->getRootContainer().invalidate();
}
void IngtestView::setupScreen()
{
    IngtestViewBase::setupScreen();
}

void IngtestView::tearDownScreen()
{
    IngtestViewBase::tearDownScreen();
}

void IngtestView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
        moveNextScreen();
	}

}
void IngtestView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoKeypadScreenNoTransition();
		break;

	case 3:
		application().gotoPWRMNTRScreenNoTransition();
		break;

	case 2:
		application().gotoLTSScreenNoTransition();
		break;

	case 8:
		application().gotoWarningLightScreenNoTransition();
		break;

	case 9:
		application().gotoUSBScreenNoTransition();
		break;

	case 14:
		application().gotoLEDLTScreenNoTransition();
		break;

	case 15:
		application().gotoBLEScreenNoTransition();
		break;


	case 4:
		application().gotoRTCNXTScreenNoTransition();
		break;

	case 5:
		application().gotoEEPROM1ScreenNoTransition();
		break;

	case 13:
		application().gotoCIScreenNoTransition();
		break;

	case 6:
		application().gotoLCDScreenNoTransition();
		break;

	case 7:
		application().gotoDOutScreenNoTransition();
		break;

	case 10:
		application().gotoSWTIMERScreenNoTransition();
		break;

	case 11:
		application().gotoWTDOGScreenNoTransition();
		break;

	case 12:
		application().gotoCANXTScreenNoTransition();
		break;

	case 16:
		application().gotoCameraScreenNoTransition();
		break;

	case 17:
		application().gotoPOWERMODEScreenNoTransition();
		break;

	case 18:
		application().gotoJ1939ScreenNoTransition();
		break;

	case 19:
		application().gotoFLASHScreenNoTransition();
		break;

	case 20:
		application().gotoTHRPUTScreenNoTransition();
		break;

	default:
		break;

	}
}
void IngtestView::moveNext()
{
	key_position++;

	if (21 == key_position)
		key_position = 1;

	switch(key_position)
	{
	case 1:
		/* DESelect the Keypad button */
		THRPUT.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		THRPUT.invalidate();

		/* Select the Keypad button */
		KPTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		KPTA.invalidate();
		break;
	case 2:
		/* DESelect the Keypad button */
		KPTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		KPTA.invalidate();

		/* Select the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LSTA.invalidate();
		break;
	case 3:
		/* DESelect the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LSTA.invalidate();

		/* Select the Keypad button */
		PMOTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		PMOTA.invalidate();
		break;
	case 4:
		/* DESelect the Keypad button */
		PMOTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		PMOTA.invalidate();

		/* Select the Keypad button */
		RTCTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		RTCTA.invalidate();
		break;
	case 5:
		/* DESelect the Keypad button */
		RTCTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		RTCTA.invalidate();

		/* Select the Keypad button */
		EETA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		EETA.invalidate();
		break;
	case 6:
		/* DESelect the Keypad button */
		EETA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		EETA.invalidate();

		/* Select the Keypad button */
		LCDTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LCDTA.invalidate();
		break;
	case 7:
		/* DESelect the Keypad button */
		LCDTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LCDTA.invalidate();

		/* Select the Keypad button */
		DOTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		DOTA.invalidate();
		break;
	case 8:
		/* DESelect the Keypad button */
		DOTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		DOTA.invalidate();

		/* Select the Keypad button */
		WLTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		WLTA.invalidate();
		break;
	case 9:
		/* DESelect the Keypad button */
		WLTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		WLTA.invalidate();

		/* Select the Keypad button */
		USBTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		USBTA.invalidate();
		break;
	case 10:
		/* DESelect the Keypad button */
		USBTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		USBTA.invalidate();

		/* Select the Keypad button */
		TMRTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		TMRTA.invalidate();
		break;
	case 11:
		/* DESelect the Keypad button */
		TMRTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		TMRTA.invalidate();

		/* Select the Keypad button */
		WDTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		WDTA.invalidate();
		break;
	case 12:
		/* DESelect the Keypad button */
		WDTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		WDTA.invalidate();

		/* Select the Keypad button */
		CANTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		CANTA.invalidate();
		break;
	case 13:
		/* DESelect the Keypad button */
		CANTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		CANTA.invalidate();

		/* Select the Keypad button */
		CITA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		CITA.invalidate();
		break;
	case 14:
		/* DESelect the Keypad button */
		CITA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		CITA.invalidate();

		/* Select the Keypad button */
		LEDTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LEDTA.invalidate();
		break;
	case 15:
		/* DESelect the Keypad button */
		LEDTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LEDTA.invalidate();

		/* Select the Keypad button */
		BLETA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		BLETA.invalidate();
		break;
	case 16:
		/* DESelect the Keypad button */
		BLETA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		BLETA.invalidate();

		/* Select the Keypad button */
		CAMTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		CAMTA.invalidate();
		break;
	case 17:
		/* DESelect the Keypad button */
		CAMTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		CAMTA.invalidate();

		/* Select the Keypad button */
		PMTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		PMTA.invalidate();
		break;
	case 18:
		/* DESelect the Keypad button */
		PMTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		PMTA.invalidate();

		/* Select the Keypad button */
		JTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		JTA.invalidate();
		break;
	case 19:
		/* DESelect the Keypad button */
		JTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		JTA.invalidate();

		/* Select the Keypad button */
		FLSH.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		FLSH.invalidate();
		break;
	case 20:
		/* DESelect the Keypad button */
		FLSH.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		FLSH.invalidate();

		/* Select the Keypad button */
		THRPUT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		THRPUT.invalidate();
		break;
	default:
		break;
	}
}

void IngtestView::movePrevious()
{
	key_position--;

	if (0 == key_position)
		key_position = 20;

	switch(key_position)
	{
	case 1:
		/* Select the Keypad button */
		KPTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		KPTA.invalidate();

		/* DESelect the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LSTA.invalidate();
		break;

	case 2:
		/* Select the Keypad button */
		LSTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LSTA.invalidate();

		/* DESelect the Keypad button */
		PMOTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		PMOTA.invalidate();

		break;
	case 3:
		/* Select the Keypad button */
		PMOTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		PMOTA.invalidate();

		/* DESelect the Keypad button */
		RTCTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		RTCTA.invalidate();
		break;

	case 4:
		/* Select the Keypad button */
		RTCTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		RTCTA.invalidate();

		/* DESelect the Keypad button */
		EETA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		EETA.invalidate();
		break;
	case 5:

		/* Select the Keypad button */
		EETA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		EETA.invalidate();

		/* DESelect the Keypad button */
		LCDTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LCDTA.invalidate();

		break;
	case 6:
		/* Select the Keypad button */
		LCDTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LCDTA.invalidate();

		/* DESelect the Keypad button */
		DOTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		DOTA.invalidate();

		break;
	case 7:
    	/* Select the Keypad button */
		DOTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		DOTA.invalidate();

		/* DESelect the Keypad button */
		WLTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		WLTA.invalidate();
        break;
	case 8:
		/* Select the Keypad button */
		WLTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		WLTA.invalidate();

		/* DESelect the Keypad button */
		USBTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		USBTA.invalidate();

		break;
	case 9:
		/* Select the Keypad button */
		USBTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		USBTA.invalidate();

		/* DESelect the Keypad button */
		TMRTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		TMRTA.invalidate();

		break;
	case 10:
		/* Select the Keypad button */
		TMRTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		TMRTA.invalidate();

		/* DESelect the Keypad button */
		WDTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		WDTA.invalidate();

		break;
	case 11:
		/* Select the Keypad button */
		WDTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		WDTA.invalidate();

		/* DESelect the Keypad button */
		CANTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		CANTA.invalidate();

		break;
	case 12:
		/* Select the Keypad button */
		CANTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		CANTA.invalidate();

		/* DESelect the Keypad button */
		CITA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		CITA.invalidate();

		break;
	case 13:
		/* Select the Keypad button */
		CITA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		CITA.invalidate();

		/* DESelect the Keypad button */
		LEDTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		LEDTA.invalidate();

		break;
	case 14:
		/* Select the Keypad button */
		LEDTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		LEDTA.invalidate();

		/* DESelect the Keypad button */
		BLETA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		BLETA.invalidate();

		break;
	case 15:
		/* Select the Keypad button */
		BLETA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		BLETA.invalidate();

		/* DESelect the Keypad button */
		CAMTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		CAMTA.invalidate();

		break;
	case 16:
		/* Select the Keypad button */
		CAMTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		CAMTA.invalidate();

		/* DESelect the Keypad button */
		PMTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		PMTA.invalidate();

		break;
	case 17:
		/* Select the Keypad button */
		PMTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		PMTA.invalidate();

		/* DESelect the Keypad button */
		JTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		JTA.invalidate();

		break;
	case 18:
		/* Select the Keypad button */
		JTA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		JTA.invalidate();

		/* DESelect the Keypad button */
		FLSH.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		FLSH.invalidate();
		break;
	case 19:
		/* Select the Keypad button */
		FLSH.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		FLSH.invalidate();

		/* DESelect the Keypad button */
		THRPUT.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		THRPUT.invalidate();
		break;
	case 20:
		/* Select the Keypad button */
		THRPUT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		THRPUT.invalidate();

		/* DESelect the Keypad button */
		KPTA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		KPTA.invalidate();
		break;
	default:
		break;
	}
}


void IngtestView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
