#include <gui/j1939_screen/J1939View.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

extern pvt_variable pv;
J1939View::J1939View()
{
	key_position = 1;
	/* Active the first button */
	DM1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	DM1.invalidate();
}

void J1939View::setupScreen()
{
    J1939ViewBase::setupScreen();
}

void J1939View::tearDownScreen()
{
    J1939ViewBase::tearDownScreen();
}

void J1939View::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveEnter();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void J1939View::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 3;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			DM1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			DM1.invalidate();

			/* Select the Keypad button */
			DM2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			DM2.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			DM2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			DM2.invalidate();

			break;
		case 3:
			/* Select the Keypad button */
			DM1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			DM1.invalidate();
			break;
		default:
				break;
		}

}

void J1939View::moveNext()
{
	key_position++;

			if (4 == key_position)
				key_position = 1;

			switch(key_position)
			{
			case 1:
				/* Select the Keypad button */
				DM1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				DM1.invalidate();
				break;
			case 2:
				/* DESelect the Keypad button */
				DM1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				DM1.invalidate();

				/* Select the Keypad button */
				DM2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				DM2.invalidate();
				break;
			case 3:
				/* DESelect the Keypad button */
				DM2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				DM2.invalidate();

				break;
				default:
					break;
			}


}
void J1939View::moveEnter()
{
	uint16_t val;
	switch(key_position)
	{
	case 1:

		val = 0x84;
		Set_DL(CAN0_DEST_ADD, (uint8_t *)&val);

		val = 1;
		Set_DL(SEND_CAN0_DM1, (uint8_t *)&val);
		break;

	case 2:

		val = 0x84;
		Set_DL(CAN0_DEST_ADD, (uint8_t *)&val);

		val = 1;
		Set_DL(SEND_CAN0_DM2, (uint8_t *)&val);
		break;
	default:
		break;

	}
}

void J1939View::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}

void J1939View::trigger()
{

	uint16_t val = 0;

	count_val++;

	/* Update J1939 Value */
	if (33 > count_val)
	{
		return;
	}
	count_val = 0;

	/* Get ENGFUELDELIVERYPRESS */
	Get_DL(ENGINE_FUEL_DELIVERY_PRESSURE, (uint8_t*)&val);

	Unicode::snprintf(ENGFUELTXTBuffer, ENGFUELTXT_SIZE, "%X", val);
	ENGFUELTXT.invalidate();

	/* Get ENGINEOILLEVEL */
	Get_DL(ENGINE_OIL_LEVEL, (uint8_t*)&val);

	Unicode::snprintf(ENGOILLEVTXTBuffer, ENGOILLEVTXT_SIZE, "%X", val);
	ENGOILLEVTXT.invalidate();

	/* Get ENGINEOILPRESSURE */
	Get_DL(ENGINE_OIL_PRESSURE_1, (uint8_t*)&val);

	Unicode::snprintf(ENGOILPRETXTBuffer, ENGOILPRETXT_SIZE, "%X", val);
	ENGOILPRETXT.invalidate();

	/* Get COOLANTPRESSURE */
	Get_DL(ENGINE_COOLANT_PRESSURE_1, (uint8_t*)&val);

	Unicode::snprintf(COOLANTPRETXTBuffer, COOLANTPRETXT_SIZE, "%X", val);
	COOLANTPRETXT.invalidate();

}

void J1939View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

