#include <gui/lcd_screen/LCDView.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

LCDView::LCDView()
{
#if (SDK_SERVICE_LCD == PS_ENABLE)

	brightness_value = 0;

	/* Get the LCD Brightness value from the DB */
	Get_DL(LCD_STATE , &state);
	Get_DL(LCD_BRIGHTNESS, (uint8_t *)&brightness_value);
	Unicode::snprintf(LCDTABuffer, LCDTA_SIZE, "%d", brightness_value);
	LCDTA.invalidate();

#endif
}

void LCDView::trigger()
{

}

void LCDView::setupScreen()
{
    LCDViewBase::setupScreen();
}

void LCDView::tearDownScreen()
{
    LCDViewBase::tearDownScreen();
}

void LCDView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		brightnessinc();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		brightnessdec();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		enter();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}
#define LCD_BRT_MAX 100
#define LCD_BRT_MIN 0
void LCDView::brightnessinc()
{
#if (SDK_SERVICE_LCD == PS_ENABLE)

	brightness_value++;
	if (!(LCD_BRT_MAX >= brightness_value))
		brightness_value = LCD_BRT_MAX;

	Set_DL(LCD_BRIGHTNESS, (uint8_t *)&brightness_value);

	if (LCD_BRT_MAX == brightness_value)
		Unicode::snprintf(LCDTABuffer, LCDTA_SIZE, "MAX - %d", brightness_value);
	else
		Unicode::snprintf(LCDTABuffer, LCDTA_SIZE, "%d", brightness_value);
	LCDTA.invalidate();

#endif
}

void LCDView::brightnessdec()
{
#if (SDK_SERVICE_LCD == PS_ENABLE)

	brightness_value--;
	if (!(LCD_BRT_MIN <= brightness_value))
		brightness_value = LCD_BRT_MIN;

	Set_DL(LCD_BRIGHTNESS, (uint8_t *)&brightness_value);

	if (LCD_BRT_MIN == brightness_value)
		Unicode::snprintf(LCDTABuffer, LCDTA_SIZE, "Min - %d", brightness_value);
	else
		Unicode::snprintf(LCDTABuffer, LCDTA_SIZE, "%d", brightness_value);
	LCDTA.invalidate();

#endif
}

void LCDView::enter()
{
#if (SDK_SERVICE_LCD == PS_ENABLE)
    if (LCD_CONF_OFF == state)
    {
    	state = LCD_CONF_ON;
		/* Set the LCD Status */
    	Set_DL(LCD_STATE, &state);
    	Unicode::snprintf(LCDSTBuffer, LCDST_SIZE, "ON");
    }
    else
    {
    	state = LCD_CONF_OFF;
		/* Set the LCD Status */
    	Set_DL(LCD_STATE, &state);
        Unicode::snprintf(LCDSTBuffer, LCDST_SIZE, "OFF");
    }

    LCDST.invalidate();
#endif
}
void LCDView::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}


void LCDView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
