#include <gui/ledlt_screen/LEDLTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

LEDLTView::LEDLTView()
{
	key_position = 1;
	/* Active the first button */
	REDLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	REDLED.invalidate();
}

void LEDLTView::trigger()
{

}

void LEDLTView::setupScreen()
{
    LEDLTViewBase::setupScreen();
}

void LEDLTView::tearDownScreen()
{
    LEDLTViewBase::tearDownScreen();
}

void LEDLTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}

void LEDLTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoREDNXTScreenNoTransition();
		break;

	case 2:
		application().gotoAMBNXTScreenNoTransition();
		break;

	default:
		break;

	}
}

void LEDLTView::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}
void LEDLTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			AMBLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			AMBLED.invalidate();

			/* Select the Keypad button */
			REDLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			REDLED.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			REDLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			REDLED.invalidate();

			/* Select the Keypad button */
			AMBLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			AMBLED.invalidate();
			break;
		default:
				break;
		}

}
void LEDLTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			REDLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			REDLED.invalidate();

			/* Select the Keypad button */
			AMBLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			AMBLED.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			AMBLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			AMBLED.invalidate();

			/* Select the Keypad button */
			REDLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			REDLED.invalidate();
			break;
		default:
				break;
		}
}

void LEDLTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

