#include <gui/model/Model.hpp>
#include <gui/model/ModelListener.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

Model::Model() : modelListener(0)
{

	wd_feed = 0;
	wd_triggered = 0;
}

void Model::tick()
{
	int8_t res;

#if (SDK_SERVICE_KEYPAD == PS_ENABLE)

   uint8_t key_status = 0;
   static uint8_t key_change = 0;


   modelListener->trigger();

   res = Get_DL(IS_PS_INIT_DONE, &key_status);

   if (TRUE != key_status)
	   return;

   wd_feed++;
   /* Get the Status */
   modelListener->watchdogstatus(&key_status);
#if (SDK_SERVICE_WATCHDOG == PS_ENABLE)
   /* Check for the WD stop button status*/
   if ( (1 <= key_status) && (10 >= key_status) && (0 == wd_triggered))
   {
	   wd_triggered = key_status;
   }

   if ((10 == wd_feed) && (1 != wd_triggered))
   {
#if(USER_TASK_WD0 == PS_ENABLE)
	  Set_DL(WD0_PING , &key_status);
#endif
   }
   else
   if ((20 == wd_feed) && (2 != wd_triggered))
   {
#if(USER_TASK_WD1 == PS_ENABLE)
	  Set_DL(WD1_PING , &key_status);
#endif
   }
   else
   if ((30 == wd_feed) && (3 != wd_triggered))
   {
#if(USER_TASK_WD2 == PS_ENABLE)
	  Set_DL(WD2_PING , &key_status);
#endif
   }
   else
   if ((40 == wd_feed) && (4 != wd_triggered))
   {
#if(USER_TASK_WD3 == PS_ENABLE)
	  Set_DL(WD3_PING , &key_status);
#endif
   }
   else
   if ((50 == wd_feed) && (5 != wd_triggered))
   {
#if(USER_TASK_WD4 == PS_ENABLE)
	  Set_DL(WD4_PING , &key_status);
#endif
   }
   else
   if ((60 == wd_feed) && (6 != wd_triggered))
   {
#if(USER_TASK_WD5 == PS_ENABLE)
	  Set_DL(WD5_PING , &key_status);
#endif
   }
   else
   if ((70 == wd_feed) && (7 != wd_triggered))
   {
#if(USER_TASK_WD6 == PS_ENABLE)
	  Set_DL(WD6_PING , &key_status);
#endif
   }
   else
   if ((80 == wd_feed) && (8 != wd_triggered))
   {
#if(USER_TASK_WD7 == PS_ENABLE)
	  Set_DL(WD7_PING , &key_status);
#endif
   }
   else
   if ((90 == wd_feed) && (9 != wd_triggered))
   {
#if(USER_TASK_WD8 == PS_ENABLE)
	  Set_DL(WD8_PING , &key_status);
#endif
   }
   else
   if ((100 == wd_feed) && (10 != wd_triggered))
   {
#if(USER_TASK_WD9 == PS_ENABLE)
	  Set_DL(WD9_PING , &key_status);
#endif
	  wd_feed = 0;
   }
#endif



#if(CONF_KEYPAD_01_STATE == PS_ENABLE)
  if(key_change ==10)
  {
       key_change=0;
   /* Read the Key Status from the DB */
   res = Get_DL(KEY_STATUS_01, &key_status);
   if (KEY_INACTIVE != key_status)
   {
	   if (KEY_ACTIVE == key_status)
		   modelListener->keyUpdate(KEY1_ACTIVE);
	   else
       if (CONTINUOUS_PRESSED == key_status)
       {
           modelListener->keyUpdate(KEY1_SHORT_PRESS);
       }
	   else
	   if (SHORT_PRESSED == key_status)
	   {
		   key_status = 1;

		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_01, &key_status);
		   modelListener->keyUpdate(KEY1_SHORT_PRESS);
	   }
	   else
	   if (LONG_PRESSED == key_status)
	   {
		   key_status = 1;
		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_01, &key_status);
		   modelListener->keyUpdate(KEY1_LONG_PRESS);
	   }
   }
#endif	//KEYPAD_01

#if(CONF_KEYPAD_02_STATE == PS_ENABLE)
   /* Read the Key Status from the DB */
   res = Get_DL(KEY_STATUS_02, &key_status);
   if (KEY_INACTIVE != key_status)
   {
	   if (KEY_ACTIVE == key_status)
		   modelListener->keyUpdate(KEY2_ACTIVE);
	    else
       if (CONTINUOUS_PRESSED == key_status)
       {
           modelListener->keyUpdate(KEY2_SHORT_PRESS);
       }
	   else
	   if (SHORT_PRESSED == key_status)
	   {
		   key_status = 1;

		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_02, &key_status);
		   modelListener->keyUpdate(KEY2_SHORT_PRESS);
	   }
	   else
	   if (LONG_PRESSED == key_status)
	   {
		   key_status = 1;
		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_02, &key_status);
		   modelListener->keyUpdate(KEY2_LONG_PRESS);
	   }
   }
#endif	//KEYPAD_02

#if(CONF_KEYPAD_03_STATE == PS_ENABLE)
   /* Read the Key Status from the DB */
   res = Get_DL(KEY_STATUS_03, &key_status);
   if (KEY_INACTIVE != key_status)
   {
	   if (KEY_ACTIVE == key_status)
		   modelListener->keyUpdate(KEY3_ACTIVE);
	   else
	   if (SHORT_PRESSED == key_status)
	   {
		   key_status = 1;

		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_03, &key_status);
		   modelListener->keyUpdate(KEY3_SHORT_PRESS);
	   }
	   else
	   if (LONG_PRESSED == key_status)
	   {
		   key_status = 1;
		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_03, &key_status);
		   modelListener->keyUpdate(KEY3_LONG_PRESS);
	   }
   }
#endif	//KEYPAD_03

#if(CONF_KEYPAD_04_STATE == PS_ENABLE)
   /* Read the Key Status from the DB */
   res = Get_DL(KEY_STATUS_04, &key_status);
   if (KEY_INACTIVE != key_status)
   {
	   if (KEY_ACTIVE == key_status)
		   modelListener->keyUpdate(KEY4_ACTIVE);
	   else
	   if (SHORT_PRESSED == key_status)
	   {
		   key_status = 1;

		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_04, &key_status);
		   modelListener->keyUpdate(KEY4_SHORT_PRESS);
	   }
	   else
	   if (LONG_PRESSED == key_status)
	   {
		   key_status = 1;
		   /* ACK the Keypress */
		   res = Set_DL(KEY_PRESS_04, &key_status);
		   modelListener->keyUpdate(KEY4_LONG_PRESS);
	   }
   }
#endif	//KEYPAD_04
  }
  else
  {
      key_change++;
  }
#endif //SDK_SERVICE_KEYPAD

#if (SDK_SERVICE_RTC == PS_ENABLE)

   uint8_t alarm_status = 0;

   /* Read the Alarm A Status from the DB */
   res = Get_DL(ALARM_A_STATUS, &alarm_status);
   if (ALARM_OCCURED == alarm_status)
   {
	   alarm_status = 0;
	   /* Set the ALARM A status*/
	   res = Set_DL(ALARM_A_STATUS, &alarm_status);
	   modelListener->alarmupdate(ALARM_A_UPDATE);
   }

   /* Read the Alarm B Status from the DB */
   res = Get_DL(ALARM_B_STATUS, &alarm_status);
   if (ALARM_OCCURED == alarm_status)
   {
	   alarm_status = 0;
	   /* Set the ALARM B status*/
	   res = Set_DL(ALARM_B_STATUS, &alarm_status);
	   modelListener->alarmupdate(ALARM_B_UPDATE);
   }
#endif
   /* removing warning */
   if(res == 0)
   {

   }

}
