#include <gui/powermode_screen/POWERMODEView.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

POWERMODEView::POWERMODEView()
{
	key_position = 1;
	/* Active the first button */
	SLPMD.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	SLPMD.invalidate();
}

void POWERMODEView::setupScreen()
{
    POWERMODEViewBase::setupScreen();
}

void POWERMODEView::tearDownScreen()
{
    POWERMODEViewBase::tearDownScreen();
}

void POWERMODEView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveEnter();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void POWERMODEView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 3;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			SLPMD.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SLPMD.invalidate();

			/* Select the Keypad button */
			STPMD.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STPMD.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			STPMD.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STPMD.invalidate();

			/* Select the Keypad button */
			STDMD.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STDMD.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			STDMD.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STDMD.invalidate();

			/* Select the Keypad button */
			SLPMD.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SLPMD.invalidate();
			break;

		default:
				break;
		}

}

void POWERMODEView::moveNext()
{
	key_position++;

			if (4 == key_position)
				key_position = 1;

			switch(key_position)
			{
			case 1:
				/* DESelect the Keypad button */
				STDMD.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				STDMD.invalidate();

				/* Select the Keypad button */
				SLPMD.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				SLPMD.invalidate();
				break;
			case 2:
				/* DESelect the Keypad button */
				SLPMD.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				SLPMD.invalidate();

				/* Select the Keypad button */
				STPMD.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				STPMD.invalidate();
				break;
			case 3:
				/* DESelect the Keypad button */
				STPMD.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				STPMD.invalidate();

				/* Select the Keypad button */
				STDMD.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				STDMD.invalidate();
				break;

			default:
					break;
			}


}
void POWERMODEView::moveEnter()
{
#if (SDK_SERVICE_PM == PS_ENABLE)
	switch(key_position)
	{
		case 1:
			/* Sleep Mode */
			pm_state = PM_SLEEP_MODE;

			Set_DL(POWER_MODE, &pm_state);
			break;

		case 2:
			/* Stop Mode */
			pm_state = PM_STOP_MODE;

			Set_DL(POWER_MODE, &pm_state);
			break;

		case 3:
			/* Standby Mode */
			pm_state = PM_STANDBY_MODE;

			Set_DL(POWER_MODE, &pm_state);
			break;

		default:
			break;
	}
#endif
}

void POWERMODEView::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}

void POWERMODEView::trigger()
{

}

void POWERMODEView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
