#include <gui/pwrmntr_screen/PWRMNTRView.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

PWRMNTRView::PWRMNTRView()
{
	key_position = 1;
	/* Active the first button */
	IGNST.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	IGNST.invalidate();
}

void PWRMNTRView::setupScreen()
{
    PWRMNTRViewBase::setupScreen();
}

void PWRMNTRView::tearDownScreen()
{
    PWRMNTRViewBase::tearDownScreen();
}

void PWRMNTRView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveEnter();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void PWRMNTRView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			IGNST.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			IGNST.invalidate();
			/* Select the Keypad button */
			BATLVL.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BATLVL.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BATLVL.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BATLVL.invalidate();

			/* Select the Keypad button */
			IGNST.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			IGNST.invalidate();
			break;
		default:
				break;
		}

}

void PWRMNTRView::moveNext()
{
	key_position++;

			if (3 == key_position)
				key_position = 1;

			switch(key_position)
			{
			case 1:
				/* DESelect the Keypad button */
				BATLVL.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				BATLVL.invalidate();

				/* Select the Keypad button */
				IGNST.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				IGNST.invalidate();
				break;
			case 2:
				/* DESelect the Keypad button */
				IGNST.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				IGNST.invalidate();
				/* Select the Keypad button */
				BATLVL.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				BATLVL.invalidate();
				break;
			default:
					break;
			}


}
void PWRMNTRView::moveEnter()
{

}

void PWRMNTRView::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}

void PWRMNTRView::trigger()
{
#if (SDK_SERVICE_POWER_MONITOR == PS_ENABLE)
	uint16_t val = 0;

	pwr_update ++;

	/* Update AI1 Value */
	if (33 > pwr_update)
	{
		return;
	}
	pwr_update = 0;

	switch(key_position)
	{
		case 1:
			/* Get ignition Status */
			Get_DL(IGNITION_STATUS, (uint8_t*)&val);
			Unicode::snprintf(PWRTXTBuffer, PWRTXT_SIZE, "%d", val);
			PWRTXT.invalidate();
			break;

		case 2:
			/* Get Battery level */
			Get_DL(BATTERY_LEVEL, (uint8_t*)&val);
			Unicode::snprintfFloat(PWRTXTBuffer, PWRTXT_SIZE, "%.2f", val);
			PWRTXT.invalidate();
			break;
	}
#endif
}

void PWRMNTRView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
