#include <gui/redblink_screen/REDBLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

REDBLINKView::REDBLINKView()
{
#if (SDK_SERVICE_LED == PS_ENABLE)

#if(CONF_RED_LED_PS_STATE == PS_ENABLE)
	blink = 0;

	/* Get the RED LED Status from the DB */
	Get_DL(LED_RED_STATE, &state);
	if (LED_ON == state)
	{
		Unicode::snprintf(REDONBuffer, REDON_SIZE, "ON");
	}
	else
		Unicode::snprintf(REDONBuffer, REDON_SIZE, "OFF");

	REDON.invalidate();
	/* Get the RED LED blink period from the DB */
	Get_DL(LED_RED_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(REDBLBuffer, REDBL_SIZE, "  %d" , blink);
	REDBL.invalidate();
#endif

#endif
}

void REDBLINKView::trigger()
{

}


void REDBLINKView::setupScreen()
{
    REDBLINKViewBase::setupScreen();
}

void REDBLINKView::tearDownScreen()
{
    REDBLINKViewBase::tearDownScreen();
}

void REDBLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_LED == PS_ENABLE)

#if(CONF_RED_LED_PS_STATE == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{

		 if (LED_OFF == state)
		 {
			 state = LED_ON;
			 /* Set the RED LED Status */
			 Set_DL(LED_RED_STATE, &state);
			 Unicode::snprintf(REDONBuffer, REDON_SIZE, "ON");
		 }
		 else
		 {
			 state = LED_OFF;
			 /* Set the RED LED Status */
			 Set_DL(LED_RED_STATE, &state);
			 Unicode::snprintf(REDONBuffer, REDON_SIZE, "OFF");
        }

		 REDON.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(REDBLBuffer, REDBL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(REDBLBuffer, REDBL_SIZE, "Max-%d" , blink);
		}

		/* Set the RED LED blink period */
		Set_DL(LED_RED_BLINKING, (uint8_t *)&blink);
		state = LED_ON;
		/* Set the RED LED Status */
		Set_DL(LED_RED_STATE, &state);
		REDBL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(REDBLBuffer, REDBL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(REDBLBuffer, REDBL_SIZE, "Min-%d" , blink);
		}

		/* Set the RED LED blink period */
		Set_DL(LED_RED_BLINKING, (uint8_t *)&blink);
		state = LED_ON;
		/* Set the Warning Light Status */
		Set_DL(LED_RED_STATE, &state);
		REDBL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();
#endif

#endif
}

void REDBLINKView::moveNextScreen()
{
	switch(key_position)
	{

	}
}

void REDBLINKView::moveBackScreen()
{
	application().gotoREDNXTScreenNoTransition();
}
void REDBLINKView::moveNext()
{
}
void REDBLINKView::movePrevious()
{
}
void REDBLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

