#include <gui/rednxt_screen/REDNXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

REDNXTView::REDNXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFLED.invalidate();
}

void REDNXTView::setupScreen()
{
    REDNXTViewBase::setupScreen();
}

void REDNXTView::tearDownScreen()
{
    REDNXTViewBase::tearDownScreen();
}

void REDNXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void REDNXTView::trigger()
{

}


void REDNXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoREDSTAScreenNoTransition();
		break;

	case 2:
		application().gotoREDBLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void REDNXTView::moveBackScreen()
{
	application().gotoLEDLTScreenNoTransition();
}
void REDNXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKLED.invalidate();

			/* Select the Keypad button */
			ONOFFLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFLED.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFLED.invalidate();

			/* Select the Keypad button */
			BLINKLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKLED.invalidate();
			break;
		default:
				break;
		}

}
void REDNXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFLED.invalidate();

			/* Select the Keypad button */
			BLINKLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKLED.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKLED.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKLED.invalidate();

			/* Select the Keypad button */
			ONOFFLED.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFLED.invalidate();
			break;
		default:
				break;
		}
}

void REDNXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
