#include <gui/rtcnxt_screen/RTCNXTView.hpp>
#include <touchgfx/Color.hpp>
#include "stm32h7xx_hal.h"
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

RTCNXTView::RTCNXTView()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)
	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;

	key_position = 1;
	/* Active the first button */
	RTCTM.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	RTCTM.invalidate();


	/* Get the RTC DB */
	Get_DL(GET_RTC_SECOND, &Seconds);
	Get_DL(GET_RTC_MINUTE, &Minutes);
	Get_DL(GET_RTC_HOUR, &Hours);

    digitalHours = Hours;
    digitalMinutes = Minutes;
    digitalSeconds = Seconds;

    digitalClock1.invalidate();
#endif /*SDK_SERVICE_RTC*/
}

void RTCNXTView::trigger()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;
   tickCounter++;
   if( 10 <= tickCounter)
   {
	   tickCounter = 0;
		/* Get the RTC DB */
		Get_DL(GET_RTC_SECOND, &Seconds);
		Get_DL(GET_RTC_MINUTE, &Minutes);
		Get_DL(GET_RTC_HOUR, &Hours);

	    //screenViewBase::setupScreen();
	    digitalHours = Hours;
	    digitalMinutes = Minutes;
	    digitalSeconds = Seconds;

        digitalClock1.setTime24Hour(digitalHours, digitalMinutes, digitalSeconds);

	    digitalClock1.invalidate();
   }

#endif
}

void RTCNXTView::setupScreen()
{
    RTCNXTViewBase::setupScreen();

}

void RTCNXTView::tearDownScreen()
{
    RTCNXTViewBase::tearDownScreen();
}

void RTCNXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}

void RTCNXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoRTCSCRScreenNoTransition();
		break;

	case 2:
		application().gotoALARMASCRScreenNoTransition();
		break;

	case 3:
		application().gotoALARMBSCRScreenNoTransition();
		break;

	default:
		break;

	}
}

void RTCNXTView::moveBackScreen()
{
	application().gotoIngtestScreenNoTransition();
}
void RTCNXTView::moveNext()
{
	key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ALARMB.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALARMB.invalidate();

			/* Select the Keypad button */
			RTCTM.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			RTCTM.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			RTCTM.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			RTCTM.invalidate();

			/* Select the Keypad button */
			ALARMA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALARMA.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			ALARMA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALARMA.invalidate();

			/* Select the Keypad button */
			ALARMB.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALARMB.invalidate();
			break;

		default:
				break;
		}

}
void RTCNXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 3;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			RTCTM.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			RTCTM.invalidate();

			/* Select the Keypad button */
			ALARMA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALARMA.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ALARMA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALARMA.invalidate();

			/* Select the Keypad button */
			ALARMB.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ALARMB.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			ALARMB.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ALARMB.invalidate();

			/* Select the Keypad button */
			RTCTM.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			RTCTM.invalidate();
			break;

		default:
				break;
		}
}


void RTCNXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
