#include <gui/rtcscr_screen/RTCSCRView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

RTCSCRView::RTCSCRView()
{

	key_position = 1;
	/* Active the first button */
	SET_TIME.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	SET_TIME.invalidate();

}


void RTCSCRView::trigger()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;
   tickCounter++;
   if( 10 <= tickCounter)
   {
	   tickCounter = 0;
	   /* Get the RTC DB */
	   Get_DL(GET_RTC_SECOND, &Seconds);
	   Get_DL(GET_RTC_MINUTE, &Minutes);
	   Get_DL(GET_RTC_HOUR, &Hours);

	   //screenViewBase::setupScreen();
	   digitalHours = Hours;
	   digitalMinutes = Minutes;
	   digitalSeconds = Seconds;

	   digitalClock1.setTime24Hour(digitalHours, digitalMinutes, digitalSeconds);

	   digitalClock1.invalidate();
   }

#endif

}

void RTCSCRView::setupScreen()
{
    RTCSCRViewBase::setupScreen();
}

void RTCSCRView::tearDownScreen()
{
    RTCSCRViewBase::tearDownScreen();
}

void RTCSCRView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        key_position++;

		if (3 == key_position)
		    key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			SET_DATE.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SET_DATE.invalidate();

			/* Select the Keypad button */
			SET_TIME.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SET_TIME.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			SET_TIME.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SET_TIME.invalidate();

			/* Select the Keypad button */
			SET_DATE.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SET_DATE.invalidate();
			break;
		default:
			break;
		}
	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{


    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		switch(key_position)
		{
		case 1:
			application().gotoTIMEScreenNoTransition();
			break;

		case 2:
			application().gotoDATEScreenNoTransition();
			break;

		default:
			break;

		}

	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoRTCNXTScreenNoTransition();
	}
#endif
}


void RTCSCRView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

