#include <gui/swtimer1_screen/SWTIMER1View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

static uint32_t cal_timeout1 = 0;
uint32_t sw_timeout;

SWTIMER1View::SWTIMER1View()
{
	state = 2;
	timeout = 0;
	key_position = 1;
    shot = 0;
	/* Active the first button */
	VLT1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	VLT1.invalidate();
}

void SWTIMER1View::setupScreen()
{
    SWTIMER1ViewBase::setupScreen();
}

void SWTIMER1View::tearDownScreen()
{
    SWTIMER1ViewBase::tearDownScreen();
}

void SWTIMER1View::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer1_state = 0;
	uint8_t rtc1_val = 0;
	uint8_t timeout_val = 0;

	Get_DL(TIMER_CALLBACK_01, &timer1_state);

	if(CALLBACK_OCCURED == timer1_state)
	{

		timeout_val = 1000/sw_timeout;

		if(timeout_val == cal_timeout1)
		{
#if (SDK_SERVICE_RTC == PS_ENABLE)
			GET_DB(GET_RTC_SECOND, &rtc1_val);
#endif	//SDK_SERVICE_RTC

			Unicode::snprintf(TMRTXT1Buffer, TMRTXT1_SIZE, "%d", rtc1_val);
			TMRTXT1.invalidate();

			cal_timeout1 = 0;


		}
		cal_timeout1++;
	}

#endif
}

void SWTIMER1View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			STATE1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STATE1.invalidate();

			/* Select the Keypad button */
			VLT1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			VLT1.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			VLT1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			VLT1.invalidate();

			/* Select the Keypad button */
			SST1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SST1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			SST1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SST1.invalidate();

			/* Select the Keypad button */
			STATE1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STATE1.invalidate();
			break;
		default:
			break;
		}

	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
			if ((timeout < 1300) && (timeout >= 0))
			{
				timeout ++;
				sw_timeout = (timeout * 50);
				Unicode::snprintf(VLT1Buffer, VLT1_SIZE, " %d" , sw_timeout);
			}
			else
			{
				Unicode::snprintf(VLT1Buffer, VLT1_SIZE, "Max-%d" , timeout);
			}

		    /* Set the Timer Timeout_1 */
			SET_DB(TIMER_TIMEOUT_01, (uint8_t *)&sw_timeout);

			VLT1.invalidate();
		    break;
		case 2:

			if(shot == 0)
			{
				Unicode::snprintf(SST1Buffer, SST1_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST1Buffer, SST1_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_1 */
		    SET_DB(TIMER_MODE_01, (uint8_t *)&shot);
		    SST1.invalidate();
		    break;
		case 3:

			if(state == 1)
			{
				Unicode::snprintf(STATE1Buffer, STATE1_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE1Buffer, STATE1_SIZE, "Active");
				state = 1;
			}

			STATE1.invalidate();
		    break;
         default:
	        break;
		}
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
		if ((timeout > 0) && (timeout <= 1300))
		{
			timeout --;
			sw_timeout = (timeout * 50);
			Unicode::snprintf(VLT1Buffer, VLT1_SIZE, " %d" , sw_timeout);
		}
		else
		{
			Unicode::snprintf(VLT1Buffer, VLT1_SIZE, "Min-%d" , timeout);
		}
		/* Set the Timer Timeout_1 */
		SET_DB(TIMER_TIMEOUT_01, (uint8_t *)&sw_timeout);

		VLT1.invalidate();
	    break;
		case 2:
			if(shot == 0)
			{
				Unicode::snprintf(SST1Buffer, SST1_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST1Buffer, SST1_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_1 */
		    SET_DB(TIMER_MODE_01, (uint8_t *)&shot);
		    SST1.invalidate();
			break;
		case 3:
			if(state == 1)
			{
				Unicode::snprintf(STATE1Buffer, STATE1_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE1Buffer, STATE1_SIZE, "Active");
				state = 1;
			}

			STATE1.invalidate();
			break;
		default:
			break;
		}
    }

	else
	if((KEY4_SHORT_PRESS == val))
	{
		SET_DB(TIMER_STATUS_01, &state);
	}
	else
    if((KEY4_LONG_PRESS == val))
    {
		application().gotoSWTIMERScreenNoTransition();
    }
#endif
}


void SWTIMER1View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

