#include <gui/swtimer2_screen/SWTIMER2View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

static uint32_t cal_timeout2 = 0;
uint32_t sw_timeout2;

SWTIMER2View::SWTIMER2View()
{
	state = 2;
	timeout = 0;
	key_position = 1;
    shot = 0;
	/* Active the first button */
	VLT2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	VLT2.invalidate();
}

void SWTIMER2View::setupScreen()
{
    SWTIMER2ViewBase::setupScreen();
}

void SWTIMER2View::tearDownScreen()
{
    SWTIMER2ViewBase::tearDownScreen();
}

void SWTIMER2View::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer2_state = 0;
	uint8_t rtc2_val = 0;
	uint8_t timeout_val = 0;

	Get_DL(TIMER_CALLBACK_02, &timer2_state);

	if(CALLBACK_OCCURED == timer2_state)
	{
		timeout_val = 1000/sw_timeout2;

		if(timeout_val == cal_timeout2)
		{
#if (SDK_SERVICE_RTC == PS_ENABLE)
			GET_DB(GET_RTC_SECOND, &rtc2_val);
#endif //rtc
			Unicode::snprintf(TMRTXT2Buffer, TMRTXT2_SIZE, "%d", rtc2_val);
			TMRTXT2.invalidate();

			cal_timeout2 = 0;
		}

		cal_timeout2++;
	}

#endif
}

void SWTIMER2View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			STATE2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STATE2.invalidate();

			/* Select the Keypad button */
			VLT2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			VLT2.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			VLT2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			VLT2.invalidate();

			/* Select the Keypad button */
			SST2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SST2.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			SST2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SST2.invalidate();

			/* Select the Keypad button */
			STATE2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STATE2.invalidate();
			break;
		default:
			break;
		}

	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
			if ((timeout < 1300) && (timeout >= 0))
			{
				timeout ++;
				sw_timeout2 = (timeout * 50);
				Unicode::snprintf(VLT2Buffer, VLT2_SIZE, " %d" , sw_timeout2);
			}
			else
			{
				Unicode::snprintf(VLT2Buffer, VLT2_SIZE, "Max-%d" , timeout);
			}

			/* Set the Timer Timeout_2 */
			SET_DB(TIMER_TIMEOUT_02, (uint8_t *)&sw_timeout2);

			VLT2.invalidate();
		    break;
		case 2:

			if(shot == 0)
			{
				Unicode::snprintf(SST2Buffer, SST2_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST2Buffer, SST2_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_2 */
		    SET_DB(TIMER_MODE_02, (uint8_t *)&shot);
		    SST2.invalidate();
		    break;
		case 3:

			if(state == 1)
			{
				Unicode::snprintf(STATE2Buffer, STATE2_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE2Buffer, STATE2_SIZE, "Active");
				state = 1;
			}

			STATE2.invalidate();
		    break;
         default:
	        break;
		}
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
		if ((timeout > 0) && (timeout <= 1300))
		{
			timeout --;
			sw_timeout2 = (timeout * 50);
			Unicode::snprintf(VLT2Buffer, VLT2_SIZE, " %d" , sw_timeout2);
		}
		else
		{
			Unicode::snprintf(VLT2Buffer, VLT2_SIZE, "Min-%d" , timeout);
		}
		/* Set the Timer Timeout_2 */
		SET_DB(TIMER_TIMEOUT_02, (uint8_t *)&sw_timeout2);

		VLT2.invalidate();
	    break;
		case 2:
			if(shot == 0)
			{
				Unicode::snprintf(SST2Buffer, SST2_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST2Buffer, SST2_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_2 */
		    SET_DB(TIMER_MODE_02, (uint8_t *)&shot);
		    SST2.invalidate();
			break;
		case 3:
			if(state == 1)
			{
				Unicode::snprintf(STATE2Buffer, STATE2_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE2Buffer, STATE2_SIZE, "Active");
				state = 1;
			}

			STATE2.invalidate();
			break;
		default:
			break;
		}
    }

	else
	if((KEY4_SHORT_PRESS == val))
	{
		SET_DB(TIMER_STATUS_02, &state);
	}
	else
    if((KEY4_LONG_PRESS == val))
    {
		application().gotoSWTIMERScreenNoTransition();
    }
#endif
}


void SWTIMER2View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

