#include <gui/swtimer3_screen/SWTIMER3View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

static uint32_t cal_timeout3 = 0;
uint32_t sw_timeout3;

SWTIMER3View::SWTIMER3View()
{
	state = 2;
	timeout = 0;
	key_position = 1;
    shot = 0;
	/* Active the first button */
	VLT3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	VLT3.invalidate();
}

void SWTIMER3View::setupScreen()
{
    SWTIMER3ViewBase::setupScreen();
}

void SWTIMER3View::tearDownScreen()
{
    SWTIMER3ViewBase::tearDownScreen();
}

void SWTIMER3View::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer3_state = 0;
	uint8_t rtc3_val = 0;
	uint8_t timeout_val;

	Get_DL(TIMER_CALLBACK_03, &timer3_state);

	if(CALLBACK_OCCURED == timer3_state)
	{
		timeout_val = 1000/sw_timeout3;

		if(timeout_val == cal_timeout3)
		{
#if (SDK_SERVICE_RTC == PS_ENABLE)
			GET_DB(GET_RTC_SECOND, &rtc3_val);
#endif //rtc
			Unicode::snprintf(TMRTXT3Buffer, TMRTXT3_SIZE, "%d", rtc3_val);
			TMRTXT3.invalidate();

			cal_timeout3 = 0;
		}
		cal_timeout3++;
	}

#endif
}

void SWTIMER3View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			STATE3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STATE3.invalidate();

			/* Select the Keypad button */
			VLT3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			VLT3.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			VLT3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			VLT3.invalidate();

			/* Select the Keypad button */
			SST3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SST3.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			SST3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SST3.invalidate();

			/* Select the Keypad button */
			STATE3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STATE3.invalidate();
			break;
		default:
			break;
		}

	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
			if ((timeout < 1300) && (timeout >= 0))
			{
				timeout ++;
				sw_timeout3 = (timeout * 50);
				Unicode::snprintf(VLT3Buffer, VLT3_SIZE, " %d" , sw_timeout3);
			}
			else
			{
				Unicode::snprintf(VLT3Buffer, VLT3_SIZE, "Max-%d" , timeout);
			}

			/* Set the Timer Timeout_3 */
			SET_DB(TIMER_TIMEOUT_03, (uint8_t *)&sw_timeout3);

			VLT3.invalidate();
		    break;
		case 2:

			if(shot == 0)
			{
				Unicode::snprintf(SST3Buffer, SST3_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST3Buffer, SST3_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_3 */
		    SET_DB(TIMER_MODE_03, (uint8_t *)&shot);
		    SST3.invalidate();
		    break;
		case 3:

			if(state == 1)
			{
				Unicode::snprintf(STATE3Buffer, STATE3_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE3Buffer, STATE3_SIZE, "Active");
				state = 1;
			}

			STATE3.invalidate();
		    break;
         default:
	        break;
		}
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
		if ((timeout > 0) && (timeout <= 1300))
		{
			timeout --;
			sw_timeout3 = (timeout * 50);
			Unicode::snprintf(VLT3Buffer, VLT3_SIZE, " %d" , sw_timeout3);
		}
		else
		{
			Unicode::snprintf(VLT3Buffer, VLT3_SIZE, "Min-%d" , timeout);
		}
		/* Set the Timer Timeout_3 */
		SET_DB(TIMER_TIMEOUT_03, (uint8_t *)&sw_timeout3);

		VLT3.invalidate();
	    break;
		case 2:
			if(shot == 0)
			{
				Unicode::snprintf(SST3Buffer, SST3_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST3Buffer, SST3_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_3 */
		    SET_DB(TIMER_MODE_03, (uint8_t *)&shot);
		    SST3.invalidate();
			break;
		case 3:
			if(state == 1)
			{
				Unicode::snprintf(STATE3Buffer, STATE3_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE3Buffer, STATE3_SIZE, "Active");
				state = 1;
			}

			STATE3.invalidate();
			break;
		default:
			break;
		}
    }

	else
	if((KEY4_SHORT_PRESS == val))
	{
		SET_DB(TIMER_STATUS_03, &state);
	}
	else
    if((KEY4_LONG_PRESS == val))
    {
		application().gotoSWTIMERScreenNoTransition();
    }
#endif
}


void SWTIMER3View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

