#include <gui/swtimer4_screen/SWTIMER4View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

static uint32_t cal_timeout4 = 0;
uint32_t sw_timeout4;

SWTIMER4View::SWTIMER4View()
{
	state = 2;
	timeout = 0;
	key_position = 1;
    shot = 0;
	/* Active the first button */
	VLT4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	VLT4.invalidate();
}

void SWTIMER4View::setupScreen()
{
    SWTIMER4ViewBase::setupScreen();
}

void SWTIMER4View::tearDownScreen()
{
    SWTIMER4ViewBase::tearDownScreen();
}

void SWTIMER4View::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer4_state = 0;
	uint8_t rtc4_val = 0;
	uint8_t timeout_val = 0;

	Get_DL(TIMER_CALLBACK_04, &timer4_state);
	if(CALLBACK_OCCURED == timer4_state)
	{
		timeout_val = 1000/sw_timeout4;

		if(timeout_val == cal_timeout4)
		{
#if (SDK_SERVICE_RTC == PS_ENABLE)
			GET_DB(GET_RTC_SECOND, &rtc4_val);
#endif //rtc
			Unicode::snprintf(TMRTXT4Buffer, TMRTXT4_SIZE, "%d", rtc4_val);
			TMRTXT4.invalidate();

			cal_timeout4 = 0;
		}

		cal_timeout4++;
	}

#endif
}

void SWTIMER4View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			STATE4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STATE4.invalidate();

			/* Select the Keypad button */
			VLT4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			VLT4.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			VLT4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			VLT4.invalidate();

			/* Select the Keypad button */
			SST4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SST4.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			SST4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SST4.invalidate();

			/* Select the Keypad button */
			STATE4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STATE4.invalidate();
			break;
		default:
			break;
		}

	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
			if ((timeout < 1300) && (timeout >= 0))
			{
				timeout ++;
				sw_timeout4 = (timeout * 50);
				Unicode::snprintf(VLT4Buffer, VLT4_SIZE, " %d" , sw_timeout4);
			}
			else
			{
				Unicode::snprintf(VLT4Buffer, VLT4_SIZE, "Max-%d" , timeout);
			}

			/* Set the Timer Timeout_4 */
			SET_DB(TIMER_TIMEOUT_04, (uint8_t *)&sw_timeout4);

			VLT4.invalidate();
		    break;
		case 2:

			if(shot == 0)
			{
				Unicode::snprintf(SST4Buffer, SST4_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST4Buffer, SST4_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_4 */
		    SET_DB(TIMER_MODE_04, (uint8_t *)&shot);
		    SST4.invalidate();
		    break;
		case 3:

			if(state == 1)
			{
				Unicode::snprintf(STATE4Buffer, STATE4_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE4Buffer, STATE4_SIZE, "Active");
				state = 1;
			}

			STATE4.invalidate();
		    break;
         default:
	        break;
		}
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
		if ((timeout > 0) && (timeout <= 1300))
		{
			timeout --;
			sw_timeout4 = (timeout * 50);
			Unicode::snprintf(VLT4Buffer, VLT4_SIZE, " %d" , sw_timeout4);
		}
		else
		{
			Unicode::snprintf(VLT4Buffer, VLT4_SIZE, "Min-%d" , timeout);
		}
		/* Set the Timer Timeout_4 */
		SET_DB(TIMER_TIMEOUT_04, (uint8_t *)&sw_timeout4);

		VLT4.invalidate();
	    break;
		case 2:
			if(shot == 0)
			{
				Unicode::snprintf(SST4Buffer, SST4_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST4Buffer, SST4_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_4 */
		    SET_DB(TIMER_MODE_04, (uint8_t *)&shot);
		    SST4.invalidate();
			break;
		case 3:
			if(state == 1)
			{
				Unicode::snprintf(STATE4Buffer, STATE4_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE4Buffer, STATE4_SIZE, "Active");
				state = 1;
			}

			STATE4.invalidate();
			break;
		default:
			break;
		}
    }

	else
	if((KEY4_SHORT_PRESS == val))
	{
		SET_DB(TIMER_STATUS_04, &state);
	}
	else
    if((KEY4_LONG_PRESS == val))
    {
		application().gotoSWTIMERScreenNoTransition();
    }
#endif
}


void SWTIMER4View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

