#include <gui/swtimer5_screen/SWTIMER5View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

static uint32_t cal_timeout5 = 0;
uint32_t sw_timeout5;

SWTIMER5View::SWTIMER5View()
{
	state = 2;
	timeout = 0;
	key_position = 1;
    shot = 0;
	/* Active the first button */
	VLT5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	VLT5.invalidate();
}

void SWTIMER5View::setupScreen()
{
    SWTIMER5ViewBase::setupScreen();
}

void SWTIMER5View::tearDownScreen()
{
    SWTIMER5ViewBase::tearDownScreen();
}

void SWTIMER5View::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer5_state = 0;
	uint8_t rtc5_val = 0;
	uint8_t timeout_val = 0;

	Get_DL(TIMER_CALLBACK_05, &timer5_state);
	if(CALLBACK_OCCURED == timer5_state)
	{
		timeout_val = 1000/sw_timeout5;

		if(timeout_val == cal_timeout5)
		{
#if (SDK_SERVICE_RTC == PS_ENABLE)
			GET_DB(GET_RTC_SECOND, &rtc5_val);
#endif //rtc
			Unicode::snprintf(TMRTXT5Buffer, TMRTXT5_SIZE, "%d", rtc5_val);
			TMRTXT5.invalidate();

			cal_timeout5 = 0;
		}
		cal_timeout5++;
	}

#endif
}

void SWTIMER5View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			STATE5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STATE5.invalidate();

			/* Select the Keypad button */
			VLT5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			VLT5.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			VLT5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			VLT5.invalidate();

			/* Select the Keypad button */
			SST5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SST5.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			SST5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SST5.invalidate();

			/* Select the Keypad button */
			STATE5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STATE5.invalidate();
			break;
		default:
			break;
		}

	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
			if ((timeout < 1300) && (timeout >= 0))
			{
				timeout ++;
				sw_timeout5 = (timeout * 50);
				Unicode::snprintf(VLT5Buffer, VLT5_SIZE, " %d" , sw_timeout5);
			}
			else
			{
				Unicode::snprintf(VLT5Buffer, VLT5_SIZE, "Max-%d" , timeout);
			}

			/* Set the Timer Timeout_5 */
			SET_DB(TIMER_TIMEOUT_05, (uint8_t *)&sw_timeout5);

			VLT5.invalidate();
		    break;
		case 2:

			if(shot == 0)
			{
				Unicode::snprintf(SST5Buffer, SST5_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST5Buffer, SST5_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_5 */
		    SET_DB(TIMER_MODE_05, (uint8_t *)&shot);
		    SST5.invalidate();
		    break;
		case 3:

			if(state == 1)
			{
				Unicode::snprintf(STATE5Buffer, STATE5_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE5Buffer, STATE5_SIZE, "Active");
				state = 1;
			}

			STATE5.invalidate();
		    break;
         default:
	        break;
		}
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
		if ((timeout > 0) && (timeout <= 1300))
		{
			timeout --;
			sw_timeout5 = (timeout * 50);
			Unicode::snprintf(VLT5Buffer, VLT5_SIZE, " %d" , sw_timeout5);
		}
		else
		{
			Unicode::snprintf(VLT5Buffer, VLT5_SIZE, "Min-%d" , timeout);
		}
		/* Set the Timer Timeout_5 */
		SET_DB(TIMER_TIMEOUT_05, (uint8_t *)&sw_timeout5);

		VLT5.invalidate();
	    break;
		case 2:
			if(shot == 0)
			{
				Unicode::snprintf(SST5Buffer, SST5_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST5Buffer, SST5_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_5 */
		    SET_DB(TIMER_MODE_05, (uint8_t *)&shot);
		    SST5.invalidate();
			break;
		case 3:
			if(state == 1)
			{
				Unicode::snprintf(STATE5Buffer, STATE5_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE5Buffer, STATE5_SIZE, "Active");
				state = 1;
			}

			STATE5.invalidate();
			break;
		default:
			break;
		}
    }

	else
	if((KEY4_SHORT_PRESS == val))
	{
		SET_DB(TIMER_STATUS_05, &state);
	}
	else
    if((KEY4_LONG_PRESS == val))
    {
		application().gotoSWTIMERScreenNoTransition();
    }
#endif
}


void SWTIMER5View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

