#include <gui/swtimer6_screen/SWTIMER6View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

static uint32_t cal_timeout6 = 0;
uint32_t sw_timeout6;

SWTIMER6View::SWTIMER6View()
{
	state = 2;
	timeout = 0;
	key_position = 1;
    shot = 0;
	/* Active the first button */
	VLT6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	VLT6.invalidate();
}

void SWTIMER6View::setupScreen()
{
    SWTIMER6ViewBase::setupScreen();
}

void SWTIMER6View::tearDownScreen()
{
    SWTIMER6ViewBase::tearDownScreen();
}

void SWTIMER6View::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer6_state = 0;
	uint8_t rtc6_val = 0;
	uint8_t timeout_val = 0;

	Get_DL(TIMER_CALLBACK_06, &timer6_state);
	if(CALLBACK_OCCURED == timer6_state)
	{
		timeout_val = 1000/sw_timeout6;

		if(timeout_val == cal_timeout6)
		{
#if (SDK_SERVICE_RTC == PS_ENABLE)
			GET_DB(GET_RTC_SECOND, &rtc6_val);
#endif //rtc
			Unicode::snprintf(TMRTXT6Buffer, TMRTXT6_SIZE, "%d", rtc6_val);
			TMRTXT6.invalidate();

			cal_timeout6 = 0;
		}

		cal_timeout6++;
	}

#endif
}

void SWTIMER6View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			STATE6.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			STATE6.invalidate();

			/* Select the Keypad button */
			VLT6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			VLT6.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			VLT6.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			VLT6.invalidate();

			/* Select the Keypad button */
			SST6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			SST6.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			SST6.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			SST6.invalidate();

			/* Select the Keypad button */
			STATE6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			STATE6.invalidate();
			break;
		default:
			break;
		}

	}
	else if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
			if ((timeout < 1300) && (timeout >= 0))
			{
				timeout ++;
				sw_timeout6 = (timeout * 50);
				Unicode::snprintf(VLT6Buffer, VLT6_SIZE, " %d" , sw_timeout6);
			}
			else
			{
				Unicode::snprintf(VLT6Buffer, VLT6_SIZE, "Max-%d" , timeout);
			}

			/* Set the Timer Timeout_6 */
			SET_DB(TIMER_TIMEOUT_06, (uint8_t *)&sw_timeout6);

			VLT6.invalidate();
		    break;
		case 2:

			if(shot == 0)
			{
				Unicode::snprintf(SST6Buffer, SST6_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST6Buffer, SST6_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_6 */
		    SET_DB(TIMER_MODE_06, (uint8_t *)&shot);
		    SST6.invalidate();
		    break;
		case 3:

			if(state == 1)
			{
				Unicode::snprintf(STATE6Buffer, STATE6_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE6Buffer, STATE6_SIZE, "Active");
				state = 1;
			}

			STATE6.invalidate();
		    break;
         default:
	        break;
		}
    }
	else if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{

		case 1:
		if ((timeout > 0) && (timeout <= 1300))
		{
			timeout --;
			sw_timeout6 = (timeout * 50);
			Unicode::snprintf(VLT6Buffer, VLT6_SIZE, " %d" , sw_timeout6);
		}
		else
		{
			Unicode::snprintf(VLT6Buffer, VLT6_SIZE, "Min-%d" , timeout);
		}
		/* Set the Timer Timeout_6 */
		SET_DB(TIMER_TIMEOUT_06, (uint8_t *)&sw_timeout6);

		VLT6.invalidate();
	    break;
		case 2:
			if(shot == 0)
			{
				Unicode::snprintf(SST6Buffer, SST6_SIZE, "Cont Shot");
				shot = 1;
			}
			else if(shot == 1)
			{
				Unicode::snprintf(SST6Buffer, SST6_SIZE, "Single Shot");
				shot = 0;
			}
			/* Set the Timer Mode_6 */
		    SET_DB(TIMER_MODE_06, (uint8_t *)&shot);
		    SST6.invalidate();
			break;
		case 3:
			if(state == 1)
			{
				Unicode::snprintf(STATE6Buffer, STATE6_SIZE, "Inactive");
				state = 2;
			}
			else if(state == 2)
			{
				Unicode::snprintf(STATE6Buffer, STATE6_SIZE, "Active");
				state = 1;
			}

			STATE6.invalidate();
			break;
		default:
			break;
		}
    }

	else
	if((KEY4_SHORT_PRESS == val))
	{
		SET_DB(TIMER_STATUS_06, &state);
	}
	else
    if((KEY4_LONG_PRESS == val))
    {
		application().gotoSWTIMERScreenNoTransition();
    }
#endif
}


void SWTIMER6View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

