#include <gui/time_screen/TIMEView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
TIMEView::TIMEView()
{
	minutes 	 = 0;
	seconds 	 = 0;
	res 		 = 1;
	key_position = 1;
	format 		 = 0;
	rtcformat 	 = 0;

	/* Active the first button */
	FORMAT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	FORMAT.invalidate();

    Get_DL(GET_RTC_WEEK_DAY, (uint8_t *)&wkdays);
    Set_DL(RTC_WEEK_DAY, (uint8_t *)&wkdays);
    Get_DL(GET_RTC_DATE, &date);
    Set_DL(RTC_DATE, &date);
    Get_DL(GET_RTC_MONTH, &month);
    Set_DL(RTC_MONTH, &month);
    Get_DL(GET_RTC_YEAR, &year);
    Set_DL(RTC_YEAR, &year);

	/* Get the RTC time format */
  	Get_DL(GET_RTC_TIME_FORMAT, &format);
  	Set_DL(RTC_TIME_FORMAT, &format);

  	if(format == 1)
  	{
  		hours = 1;
  		Unicode::snprintf(FORMATBuffer, FORMAT_SIZE, "%d" , 12);
  		Unicode::snprintf(HOURBuffer, HOUR_SIZE, " %d" , hours);
  	}
  	else if(format == 0)
  	{
  		hours = 0;
  		Unicode::snprintf(FORMATBuffer, FORMAT_SIZE, "%d" , 24);
  		Unicode::snprintf(HOURBuffer, HOUR_SIZE, " %d" , hours);
  	}

  	FORMAT.invalidate();
  	HOUR.invalidate();

  	/* Get the RTC hours */
	Get_DL(GET_RTC_HOUR, &hours);
	Set_DL(RTC_HOUR, &hours);

	if((hours>=0)&&(hours<=23))
	{
		Unicode::snprintf(HOURBuffer, HOUR_SIZE, "%d" , hours);
	}
	HOUR.invalidate();

	/* Get the RTC minutes */
	Get_DL(GET_RTC_MINUTE, &minutes);
	Set_DL(RTC_MINUTE, &minutes);

    if((minutes>=0)&&(minutes<60))
    {
    	Unicode::snprintf(MINBuffer, MIN_SIZE, "%.2d" , minutes);
    }
	MIN.invalidate();

	/* Get the RTC seconds */
	Get_DL(GET_RTC_SECOND, &seconds);
	Set_DL(RTC_SECOND, &seconds);

    if((seconds>=0)&&(seconds<60))
    {
    	Unicode::snprintf(SECBuffer, SEC_SIZE, "%.2d" , seconds);
    }
	SEC.invalidate();

}

void TIMEView::setupScreen()
{
    TIMEViewBase::setupScreen();
}

void TIMEView::tearDownScreen()
{
    TIMEViewBase::tearDownScreen();
}

void TIMEView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (5 == key_position)
			key_position = 1;

		switch(key_position)
		{
			case 1:
				/* DESelect the Keypad button */
				SEC.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				SEC.invalidate();

				/* Select the Keypad button */
				FORMAT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				FORMAT.invalidate();
				break;

			case 2:
				/* DESelect the Keypad button */
				FORMAT.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				FORMAT.invalidate();

				/* Select the Keypad button */
				HOUR.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				HOUR.invalidate();
				break;

			case 3:
				/* DESelect the Keypad button */
				HOUR.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				HOUR.invalidate();

				/* Select the Keypad button */
				MIN.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				MIN.invalidate();
				break;

			case 4:
				/* DESelect the Keypad button */
				MIN.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				MIN.invalidate();

				/* Select the Keypad button */
				SEC.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				SEC.invalidate();
				break;

			default:
				break;
		}
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{
			case 1:
				if((format == 1))
				{
					hours = 0;
					Unicode::snprintf(HOURBuffer, HOUR_SIZE, "%d" , hours);
					Unicode::snprintf(FORMATBuffer, FORMAT_SIZE, " %d" , 24);

					format = 0;
				}

				/* Set the RTC  time format */
				Set_DL(RTC_TIME_FORMAT, &format);
				Set_DL(RTC_HOUR, &hours);
				FORMAT.invalidate();
				HOUR.invalidate();
				break;

			case 2:
				if ((hours >= 1) && (hours < 12) && (1 == format))
				{
					hours++;
					Unicode::snprintf(HOURBuffer, HOUR_SIZE, " %d" , hours);
				}
				else if((hours >= 0) && (hours < 23) && (0 == format))
				{
					hours++;
					Unicode::snprintf(HOURBuffer, HOUR_SIZE, " %d" , hours);
				}

				/* Set the RTC hours */
				Set_DL(RTC_HOUR, &hours);
				HOUR.invalidate();
				break;

			case 3:
				if ((minutes >= 0) && (minutes < 59))
				{
					minutes ++;
					Unicode::snprintf(MINBuffer, MIN_SIZE, "%d" , minutes);
				}
				MIN.invalidate();

				/* Set the RTC minutes */
				Set_DL(RTC_MINUTE, &minutes);
				break;

			case 4:
				if ((seconds >= 0) && (seconds < 59) )
				{
					seconds ++;
					Unicode::snprintf(SECBuffer, SEC_SIZE, "%d" , seconds);
				}
				SEC.invalidate();

				/* Set the RTC seconds */
				Set_DL(RTC_SECOND, &seconds);
				break;

			default:
				break;
		}
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;
		switch (position)
		{
			case 1:
				if ((format == 0))
				{
					format = 1;
					hours = 1;
					Unicode::snprintf(FORMATBuffer, FORMAT_SIZE, "%d" , 12);
					Unicode::snprintf(HOURBuffer, HOUR_SIZE, " %d" , hours);
					rtcformat = 1;
				}
				/* Set the RTC time format */
				Set_DL(RTC_TIME_FORMAT, &rtcformat);
				Set_DL(RTC_HOUR, &hours);
				FORMAT.invalidate();
				HOUR.invalidate();
				break;
			case 2:
				if ((hours > 0) && (hours <= 12)&& (1 == format))
				{
					if(hours >= 2)
						hours --;
					Unicode::snprintf(HOURBuffer, HOUR_SIZE, " %d" , hours);
				}
				else if((hours < 24)&&(hours > 0) && (0 == format))
				{
					hours --;
					Unicode::snprintf(HOURBuffer, HOUR_SIZE, " %d" , hours);
				}
				/* Set the RTC hours */
				Set_DL(RTC_HOUR, &hours);
				HOUR.invalidate();
				break;
			case 3:
				if ((minutes > 0) && (minutes <= 59))
				{
					minutes --;
					Unicode::snprintf(MINBuffer, MIN_SIZE, "%d" , minutes);
				}

				/* Set the RTC minutes */
				Set_DL(RTC_MINUTE, &minutes);
				MIN.invalidate();
				break;
			case 4:
				if ((seconds > 0) && (seconds <= 59) )
				{
					seconds --;
					Unicode::snprintf(SECBuffer, SEC_SIZE, "%d" , seconds);
				}

				/* Set the RTC seconds */
				Set_DL(RTC_SECOND, &seconds);
				SEC.invalidate();
				break;
			default:
				break;
		}
	}
	else
	if(KEY4_SHORT_PRESS == val)
	{
		Set_DL(SET_RTC, &res);
	}
	else
	if(KEY4_LONG_PRESS == val)
	{
		/* Long Press Keypad button */
		application().gotoRTCSCRScreenNoTransition();
	}
}

void TIMEView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

void TIMEView::trigger( )
{
#if (SDK_SERVICE_RTC == PS_ENABLE)

	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;
   tickCounter++;
   if( 10 <= tickCounter)
   {
	   tickCounter = 0;
	   /* Get the RTC DB */
	   Get_DL(GET_RTC_SECOND, &Seconds);
	   Get_DL(GET_RTC_MINUTE, &Minutes);
	   Get_DL(GET_RTC_HOUR, &Hours);

	   //screenViewBase::setupScreen();
	   digitalHours = Hours;
	   digitalMinutes = Minutes;
	   digitalSeconds = Seconds;

	   digitalClock1.setTime24Hour(digitalHours, digitalMinutes, digitalSeconds);

	   digitalClock1.invalidate();
   }

#endif

}

