#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
#include <gui/wl01blink_screen/WL01BLINKView.hpp>

WL01BLINKView::WL01BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_01_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL01ONBuffer, WL01ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL01ONBuffer, WL01ON_SIZE, "OFF");

	WL01ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_01_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS01BLBuffer, WLS01BL_SIZE, "  %d" , blink);
	WLS01BL.invalidate();

#endif
}

void WL01BLINKView::trigger()
{

}

void WL01BLINKView::setupScreen()
{
    WL01BLINKViewBase::setupScreen();
}

void WL01BLINKView::tearDownScreen()
{
    WL01BLINKViewBase::tearDownScreen();
}

void WL01BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_01_STATE, &state);
			 Unicode::snprintf(WL01ONBuffer, WL01ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_01_STATE, &state);
			 Unicode::snprintf(WL01ONBuffer, WL01ON_SIZE, "OFF");
        }

		 WL01ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS01BLBuffer, WLS01BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS01BLBuffer, WLS01BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_01_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_01_STATE, &state);
		WLS01BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS01BLBuffer, WLS01BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS01BLBuffer, WLS01BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_01_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_01_STATE, &state);
		WLS01BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL01BLINKView::moveNextScreen()
{

}

void WL01BLINKView::moveBackScreen()
{
	application().gotoWL01NXTScreenNoTransition();
}
void WL01BLINKView::moveNext()
{
}
void WL01BLINKView::movePrevious()
{
}

void WL01BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
