#include <gui/wl02blink_screen/WL02BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL02BLINKView::WL02BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_02_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL02ONBuffer, WL02ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL02ONBuffer, WL02ON_SIZE, "OFF");

	WL02ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_02_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS02BLBuffer, WLS02BL_SIZE, "  %d" , blink);
	WLS02BL.invalidate();

#endif
}


void WL02BLINKView::trigger()
{

}

void WL02BLINKView::setupScreen()
{
    WL02BLINKViewBase::setupScreen();
}

void WL02BLINKView::tearDownScreen()
{
    WL02BLINKViewBase::tearDownScreen();
}

void WL02BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_02_STATE, &state);
			 Unicode::snprintf(WL02ONBuffer, WL02ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_02_STATE, &state);
			 Unicode::snprintf(WL02ONBuffer, WL02ON_SIZE, "OFF");
        }

		 WL02ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS02BLBuffer, WLS02BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS02BLBuffer, WLS02BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_02_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_02_STATE, &state);
		WLS02BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS02BLBuffer, WLS02BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS02BLBuffer, WLS02BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_02_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_02_STATE, &state);
		WLS02BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL02BLINKView::moveNextScreen()
{

}

void WL02BLINKView::moveBackScreen()
{
	application().gotoWL02NXTScreenNoTransition();
}
void WL02BLINKView::moveNext()
{
}
void WL02BLINKView::movePrevious()
{
}



void WL02BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
