#include <gui/wl04blink_screen/WL04BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL04BLINKView::WL04BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_04_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL04ONBuffer, WL04ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL04ONBuffer, WL04ON_SIZE, "OFF");

	WL04ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_04_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS04BLBuffer, WLS04BL_SIZE, "  %d" , blink);
	WLS04BL.invalidate();
#endif
}

void WL04BLINKView::trigger()
{

}

void WL04BLINKView::setupScreen()
{
    WL04BLINKViewBase::setupScreen();
}

void WL04BLINKView::tearDownScreen()
{
    WL04BLINKViewBase::tearDownScreen();
}

void WL04BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_04_STATE, &state);
			 Unicode::snprintf(WL04ONBuffer, WL04ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_04_STATE, &state);
			 Unicode::snprintf(WL04ONBuffer, WL04ON_SIZE, "OFF");
        }

		 WL04ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS04BLBuffer, WLS04BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS04BLBuffer, WLS04BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_04_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_04_STATE, &state);
		WLS04BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS04BLBuffer, WLS04BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS04BLBuffer, WLS04BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_04_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_04_STATE, &state);
		WLS04BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL04BLINKView::moveNextScreen()
{

}

void WL04BLINKView::moveBackScreen()
{
	application().gotoWL04NXTScreenNoTransition();
}
void WL04BLINKView::moveNext()
{
}
void WL04BLINKView::movePrevious()
{
}


void WL04BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
