#include <gui/wl04nxt_screen/WL04NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL04NXTView::WL04NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL04.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL04.invalidate();
}


void WL04NXTView::trigger()
{

}

void WL04NXTView::setupScreen()
{
    WL04NXTViewBase::setupScreen();
}

void WL04NXTView::tearDownScreen()
{
    WL04NXTViewBase::tearDownScreen();
}

void WL04NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL04NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS04ScreenNoTransition();
		break;

	case 2:
		application().gotoWL04BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL04NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL04NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL04.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL04.invalidate();

			/* Select the Keypad button */
			ONOFFWL04.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL04.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL04.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL04.invalidate();

			/* Select the Keypad button */
			BLINKWL04.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL04.invalidate();
			break;
		default:
				break;
		}

}
void WL04NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL04.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL04.invalidate();

			/* Select the Keypad button */
			BLINKWL04.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL04.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL04.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL04.invalidate();

			/* Select the Keypad button */
			ONOFFWL04.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL04.invalidate();
			break;
		default:
				break;
		}
}



void WL04NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
