#include <gui/wl05blink_screen/WL05BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL05BLINKView::WL05BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_05_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL05ONBuffer, WL05ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL05ONBuffer, WL05ON_SIZE, "OFF");

	WL05ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_05_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS05BLBuffer, WLS05BL_SIZE, "  %d" , blink);
	WLS05BL.invalidate();

#endif
}


void WL05BLINKView::trigger()
{

}

void WL05BLINKView::setupScreen()
{
    WL05BLINKViewBase::setupScreen();
}

void WL05BLINKView::tearDownScreen()
{
    WL05BLINKViewBase::tearDownScreen();
}

void WL05BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_05_STATE, &state);
			 Unicode::snprintf(WL05ONBuffer, WL05ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_05_STATE, &state);
			 Unicode::snprintf(WL05ONBuffer, WL05ON_SIZE, "OFF");
        }

		 WL05ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS05BLBuffer, WLS05BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS05BLBuffer, WLS05BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_05_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_05_STATE, &state);
		WLS05BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS05BLBuffer, WLS05BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS05BLBuffer, WLS05BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_05_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_05_STATE, &state);
		WLS05BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL05BLINKView::moveNextScreen()
{

}

void WL05BLINKView::moveBackScreen()
{
	application().gotoWL05NXTScreenNoTransition();
}
void WL05BLINKView::moveNext()
{
}
void WL05BLINKView::movePrevious()
{
}


void WL05BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
