#include <gui/wl06blink_screen/WL06BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL06BLINKView::WL06BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_06_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL06ONBuffer, WL06ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL06ONBuffer, WL06ON_SIZE, "OFF");

	WL06ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_06_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS06BLBuffer, WLS06BL_SIZE, "  %d" , blink);
	WLS06BL.invalidate();

#endif
}

void WL06BLINKView::trigger()
{

}

void WL06BLINKView::setupScreen()
{
    WL06BLINKViewBase::setupScreen();
}

void WL06BLINKView::tearDownScreen()
{
    WL06BLINKViewBase::tearDownScreen();
}

void WL06BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_06_STATE, &state);
			 Unicode::snprintf(WL06ONBuffer, WL06ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_06_STATE, &state);
			 Unicode::snprintf(WL06ONBuffer, WL06ON_SIZE, "OFF");
        }

		 WL06ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS06BLBuffer, WLS06BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS06BLBuffer, WLS06BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_06_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_06_STATE, &state);
		WLS06BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS06BLBuffer, WLS06BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS06BLBuffer, WLS06BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_06_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_06_STATE, &state);
		WLS06BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL06BLINKView::moveNextScreen()
{

}

void WL06BLINKView::moveBackScreen()
{
	application().gotoWL06NXTScreenNoTransition();
}
void WL06BLINKView::moveNext()
{
}
void WL06BLINKView::movePrevious()
{
}


void WL06BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
