#include <gui/wl06nxt_screen/WL06NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL06NXTView::WL06NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL06.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL06.invalidate();
}

void WL06NXTView::trigger()
{

}

void WL06NXTView::setupScreen()
{
    WL06NXTViewBase::setupScreen();
}

void WL06NXTView::tearDownScreen()
{
    WL06NXTViewBase::tearDownScreen();
}

void WL06NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL06NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS06ScreenNoTransition();
		break;

	case 2:
		application().gotoWL06BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL06NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL06NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL06.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL06.invalidate();

			/* Select the Keypad button */
			ONOFFWL06.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL06.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL06.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL06.invalidate();

			/* Select the Keypad button */
			BLINKWL06.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL06.invalidate();
			break;
		default:
				break;
		}

}
void WL06NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL06.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL06.invalidate();

			/* Select the Keypad button */
			BLINKWL06.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL06.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL06.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL06.invalidate();

			/* Select the Keypad button */
			ONOFFWL06.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL06.invalidate();
			break;
		default:
				break;
		}
}



void WL06NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

