#include <gui/wl07nxt_screen/WL07NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL07NXTView::WL07NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL07.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL07.invalidate();
}

void WL07NXTView::trigger()
{

}

void WL07NXTView::setupScreen()
{
    WL07NXTViewBase::setupScreen();
}

void WL07NXTView::tearDownScreen()
{
    WL07NXTViewBase::tearDownScreen();
}

void WL07NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL07NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS07ScreenNoTransition();
		break;

	case 2:
		application().gotoWL07BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL07NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL07NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL07.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL07.invalidate();

			/* Select the Keypad button */
			ONOFFWL07.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL07.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL07.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL07.invalidate();

			/* Select the Keypad button */
			BLINKWL07.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL07.invalidate();
			break;
		default:
				break;
		}

}
void WL07NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL07.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL07.invalidate();

			/* Select the Keypad button */
			BLINKWL07.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL07.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL07.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL07.invalidate();

			/* Select the Keypad button */
			ONOFFWL07.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL07.invalidate();
			break;
		default:
				break;
		}
}


void WL07NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}


