#include <gui/wl08nxt_screen/WL08NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL08NXTView::WL08NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL08.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL08.invalidate();
}

void WL08NXTView::trigger()
{

}

void WL08NXTView::setupScreen()
{
    WL08NXTViewBase::setupScreen();
}

void WL08NXTView::tearDownScreen()
{
    WL08NXTViewBase::tearDownScreen();
}

void WL08NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL08NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS08ScreenNoTransition();
		break;

	case 2:
		application().gotoWL08BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL08NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL08NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL08.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL08.invalidate();

			/* Select the Keypad button */
			ONOFFWL08.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL08.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL08.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL08.invalidate();

			/* Select the Keypad button */
			BLINKWL08.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL08.invalidate();
			break;
		default:
				break;
		}

}
void WL08NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL08.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL08.invalidate();

			/* Select the Keypad button */
			BLINKWL08.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL08.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL08.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL08.invalidate();

			/* Select the Keypad button */
			ONOFFWL08.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL08.invalidate();
			break;
		default:
				break;
		}
}


void WL08NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}


