#include <gui/wl10blink_screen/WL10BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL10BLINKView::WL10BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_10_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL10ONBuffer, WL10ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL10ONBuffer, WL10ON_SIZE, "OFF");

	WL10ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_10_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS10BLBuffer, WLS10BL_SIZE, "  %d" , blink);
	WLS10BL.invalidate();

#endif
}

void WL10BLINKView::trigger()
{

}

void WL10BLINKView::setupScreen()
{
    WL10BLINKViewBase::setupScreen();
}

void WL10BLINKView::tearDownScreen()
{
    WL10BLINKViewBase::tearDownScreen();
}

void WL10BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_10_STATE, &state);
			 Unicode::snprintf(WL10ONBuffer, WL10ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_10_STATE, &state);
			 Unicode::snprintf(WL10ONBuffer, WL10ON_SIZE, "OFF");
        }

		 WL10ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS10BLBuffer, WLS10BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS10BLBuffer, WLS10BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_10_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_10_STATE, &state);
		WLS10BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS10BLBuffer, WLS10BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS10BLBuffer, WLS10BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_10_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_10_STATE, &state);
		WLS10BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL10BLINKView::moveNextScreen()
{

}

void WL10BLINKView::moveBackScreen()
{
	application().gotoWL10NXTScreenNoTransition();
}
void WL10BLINKView::moveNext()
{
}
void WL10BLINKView::movePrevious()
{
}



void WL10BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
