#include <gui/wl10nxt_screen/WL10NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL10NXTView::WL10NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL10.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL10.invalidate();
}


void WL10NXTView::trigger()
{

}

void WL10NXTView::setupScreen()
{
    WL10NXTViewBase::setupScreen();
}

void WL10NXTView::tearDownScreen()
{
    WL10NXTViewBase::tearDownScreen();
}

void WL10NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL10NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS10ScreenNoTransition();
		break;

	case 2:
		application().gotoWL10BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL10NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL10NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL10.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL10.invalidate();

			/* Select the Keypad button */
			ONOFFWL10.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL10.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL10.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL10.invalidate();

			/* Select the Keypad button */
			BLINKWL10.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL10.invalidate();
			break;
		default:
				break;
		}

}
void WL10NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL10.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL10.invalidate();

			/* Select the Keypad button */
			BLINKWL10.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL10.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL10.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL10.invalidate();

			/* Select the Keypad button */
			ONOFFWL10.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL10.invalidate();
			break;
		default:
				break;
		}
}


void WL10NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

