#include <gui/wl11nxt_screen/WL11NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL11NXTView::WL11NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL11.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL11.invalidate();
}

void WL11NXTView::trigger()
{

}

void WL11NXTView::setupScreen()
{
    WL11NXTViewBase::setupScreen();
}

void WL11NXTView::tearDownScreen()
{
    WL11NXTViewBase::tearDownScreen();
}


void WL11NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL11NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS11ScreenNoTransition();
		break;

	case 2:
		application().gotoWL11BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL11NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL11NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL11.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL11.invalidate();

			/* Select the Keypad button */
			ONOFFWL11.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL11.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL11.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL11.invalidate();

			/* Select the Keypad button */
			BLINKWL11.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL11.invalidate();
			break;
		default:
				break;
		}

}
void WL11NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL11.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL11.invalidate();

			/* Select the Keypad button */
			BLINKWL11.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL11.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL11.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL11.invalidate();

			/* Select the Keypad button */
			ONOFFWL11.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL11.invalidate();
			break;
		default:
				break;
		}
}



void WL11NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

