#include <gui/wl12blink_screen/WL12BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL12BLINKView::WL12BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_12_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL12ONBuffer, WL12ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL12ONBuffer, WL12ON_SIZE, "OFF");

	WL12ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_12_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS12BLBuffer, WLS12BL_SIZE, "  %d" , blink);
	WLS12BL.invalidate();

#endif
}

void WL12BLINKView::trigger()
{

}

void WL12BLINKView::setupScreen()
{
    WL12BLINKViewBase::setupScreen();
}

void WL12BLINKView::tearDownScreen()
{
    WL12BLINKViewBase::tearDownScreen();
}

void WL12BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_12_STATE, &state);
			 Unicode::snprintf(WL12ONBuffer, WL12ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_12_STATE, &state);
			 Unicode::snprintf(WL12ONBuffer, WL12ON_SIZE, "OFF");
        }

		 WL12ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS12BLBuffer, WLS12BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS12BLBuffer, WLS12BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_12_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_12_STATE, &state);
		WLS12BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS12BLBuffer, WLS12BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS12BLBuffer, WLS12BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_12_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_12_STATE, &state);
		WLS12BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL12BLINKView::moveNextScreen()
{

}

void WL12BLINKView::moveBackScreen()
{
	application().gotoWL12NXTScreenNoTransition();
}
void WL12BLINKView::moveNext()
{
}
void WL12BLINKView::movePrevious()
{
}


void WL12BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}


