#include <gui/wl12nxt_screen/WL12NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL12NXTView::WL12NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL12.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL12.invalidate();
}


void WL12NXTView::trigger()
{

}


void WL12NXTView::setupScreen()
{
    WL12NXTViewBase::setupScreen();
}

void WL12NXTView::tearDownScreen()
{
    WL12NXTViewBase::tearDownScreen();
}

void WL12NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL12NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS12ScreenNoTransition();
		break;

	case 2:
		application().gotoWL12BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL12NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL12NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL12.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL12.invalidate();

			/* Select the Keypad button */
			ONOFFWL12.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL12.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL12.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL12.invalidate();

			/* Select the Keypad button */
			BLINKWL12.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL12.invalidate();
			break;
		default:
				break;
		}

}
void WL12NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL12.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL12.invalidate();

			/* Select the Keypad button */
			BLINKWL12.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL12.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL12.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL12.invalidate();

			/* Select the Keypad button */
			ONOFFWL12.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL12.invalidate();
			break;
		default:
				break;
		}
}



void WL12NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

