#include <gui/wl13nxt_screen/WL13NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL13NXTView::WL13NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL13.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL13.invalidate();
}


void WL13NXTView::trigger()
{

}

void WL13NXTView::setupScreen()
{
    WL13NXTViewBase::setupScreen();
}

void WL13NXTView::tearDownScreen()
{
    WL13NXTViewBase::tearDownScreen();
}

void WL13NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL13NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS13ScreenNoTransition();
		break;

	case 2:
		application().gotoWL13BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL13NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL13NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL13.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL13.invalidate();

			/* Select the Keypad button */
			ONOFFWL13.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL13.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL13.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL13.invalidate();

			/* Select the Keypad button */
			BLINKWL13.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL13.invalidate();
			break;
		default:
				break;
		}

}
void WL13NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL13.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL13.invalidate();

			/* Select the Keypad button */
			BLINKWL13.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL13.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL13.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL13.invalidate();

			/* Select the Keypad button */
			ONOFFWL13.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL13.invalidate();
			break;
		default:
				break;
		}
}



void WL13NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

