#include <gui/wl15blink_screen/WL15BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL15BLINKView::WL15BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_15_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL15ONBuffer, WL15ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL15ONBuffer, WL15ON_SIZE, "OFF");

	WL15ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_15_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS15BLBuffer, WLS15BL_SIZE, "  %d" , blink);
	WLS15BL.invalidate();

#endif
}

void WL15BLINKView::trigger()
{

}

void WL15BLINKView::setupScreen()
{
    WL15BLINKViewBase::setupScreen();
}

void WL15BLINKView::tearDownScreen()
{
    WL15BLINKViewBase::tearDownScreen();
}

void WL15BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_15_STATE, &state);
			 Unicode::snprintf(WL15ONBuffer, WL15ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_15_STATE, &state);
			 Unicode::snprintf(WL15ONBuffer, WL15ON_SIZE, "OFF");
        }

		 WL15ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS15BLBuffer, WLS15BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS15BLBuffer, WLS15BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_15_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_15_STATE, &state);
		WLS15BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS15BLBuffer, WLS15BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS15BLBuffer, WLS15BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_15_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_15_STATE, &state);
		WLS15BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL15BLINKView::moveNextScreen()
{

}

void WL15BLINKView::moveBackScreen()
{
	application().gotoWL15NXTScreenNoTransition();
}
void WL15BLINKView::moveNext()
{
}
void WL15BLINKView::movePrevious()
{
}



void WL15BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
