#include <gui/wl16nxt_screen/WL16NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL16NXTView::WL16NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL16.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL16.invalidate();
}


void WL16NXTView::trigger()
{

}

void WL16NXTView::setupScreen()
{
    WL16NXTViewBase::setupScreen();
}

void WL16NXTView::tearDownScreen()
{
    WL16NXTViewBase::tearDownScreen();
}

void WL16NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL16NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS16ScreenNoTransition();
		break;

	case 2:
		application().gotoWL16BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL16NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL16NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL16.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL16.invalidate();

			/* Select the Keypad button */
			ONOFFWL16.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL16.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL16.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL16.invalidate();

			/* Select the Keypad button */
			BLINKWL16.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL16.invalidate();
			break;
		default:
				break;
		}

}
void WL16NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL16.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL16.invalidate();

			/* Select the Keypad button */
			BLINKWL16.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL16.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL16.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL16.invalidate();

			/* Select the Keypad button */
			ONOFFWL16.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL16.invalidate();
			break;
		default:
				break;
		}
}



void WL16NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

