#include <gui/wl17nxt_screen/WL17NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL17NXTView::WL17NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL17.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL17.invalidate();
}

void WL17NXTView::trigger()
{

}

void WL17NXTView::setupScreen()
{
    WL17NXTViewBase::setupScreen();
}

void WL17NXTView::tearDownScreen()
{
    WL17NXTViewBase::tearDownScreen();
}

void WL17NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL17NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS17ScreenNoTransition();
		break;

	case 2:
		application().gotoWL17BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL17NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL17NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL17.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL17.invalidate();

			/* Select the Keypad button */
			ONOFFWL17.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL17.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL17.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL17.invalidate();

			/* Select the Keypad button */
			BLINKWL17.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL17.invalidate();
			break;
		default:
				break;
		}

}
void WL17NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL17.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL17.invalidate();

			/* Select the Keypad button */
			BLINKWL17.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL17.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL17.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL17.invalidate();

			/* Select the Keypad button */
			ONOFFWL17.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL17.invalidate();
			break;
		default:
				break;
		}
}

void WL17NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}



