#include <gui/wl18nxt_screen/WL18NXTView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL18NXTView::WL18NXTView()
{
	key_position = 1;
	/* Active the first button */
	ONOFFWL18.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	ONOFFWL18.invalidate();
}

void WL18NXTView::trigger()
{

}

void WL18NXTView::setupScreen()
{
    WL18NXTViewBase::setupScreen();
}

void WL18NXTView::tearDownScreen()
{
    WL18NXTViewBase::tearDownScreen();
}

void WL18NXTView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();

}


void WL18NXTView::moveNextScreen()
{
	switch(key_position)
	{
	case 1:
		application().gotoWLS18ScreenNoTransition();
		break;

	case 2:
		application().gotoWL18BLINKScreenNoTransition();
		break;

	default:
		break;

	}
}

void WL18NXTView::moveBackScreen()
{
	application().gotoWarningLightScreenNoTransition();
}
void WL18NXTView::moveNext()
{
	key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			BLINKWL18.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL18.invalidate();

			/* Select the Keypad button */
			ONOFFWL18.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL18.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			ONOFFWL18.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL18.invalidate();

			/* Select the Keypad button */
			BLINKWL18.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL18.invalidate();
			break;
		default:
				break;
		}

}
void WL18NXTView::movePrevious()
{
	key_position--;

		if (0 == key_position)
			key_position = 2;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			ONOFFWL18.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			ONOFFWL18.invalidate();

			/* Select the Keypad button */
			BLINKWL18.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			BLINKWL18.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			BLINKWL18.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			BLINKWL18.invalidate();

			/* Select the Keypad button */
			ONOFFWL18.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			ONOFFWL18.invalidate();
			break;
		default:
				break;
		}
}


void WL18NXTView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}


