#include <gui/wl20blink_screen/WL20BLINKView.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WL20BLINKView::WL20BLINKView()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	blink = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_20_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WL20ONBuffer, WL20ON_SIZE, "ON");
	}
	else
		Unicode::snprintf(WL20ONBuffer, WL20ON_SIZE, "OFF");

	WL20ON.invalidate();
	/* Get the Warning Light blink period from the DB */
	Get_DL(WARNING_LIGHT_20_BLINKING, (uint8_t *)&blink);
	Unicode::snprintf(WLS20BLBuffer, WLS20BL_SIZE, "  %d" , blink);
	WLS20BL.invalidate();

#endif
}

void WL20BLINKView::trigger()
{

}

void WL20BLINKView::setupScreen()
{
    WL20BLINKViewBase::setupScreen();
}

void WL20BLINKView::tearDownScreen()
{
    WL20BLINKViewBase::tearDownScreen();
}

void WL20BLINKView::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		 if (WL_OFF == state)
		 {
			 state = WL_ON;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_20_STATE, &state);
			 Unicode::snprintf(WL20ONBuffer, WL20ON_SIZE, "ON");
		 }
		 else
		 {
			 state = WL_OFF;
			 /* Set the Warning Light Status */
			 Set_DL(WARNING_LIGHT_20_STATE, &state);
			 Unicode::snprintf(WL20ONBuffer, WL20ON_SIZE, "OFF");
        }

		 WL20ON.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((blink < 65535) && (blink >= 0))
		{
			blink ++;
			Unicode::snprintf(WLS20BLBuffer, WLS20BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS20BLBuffer, WLS20BL_SIZE, "Max-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_20_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_20_STATE, &state);
		WLS20BL.invalidate();
	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))

	{
		if ((blink > 0) && (blink <= 65535))
		{
			blink --;
			Unicode::snprintf(WLS20BLBuffer, WLS20BL_SIZE, " %d" , blink);
		}
		else
		{
			Unicode::snprintf(WLS20BLBuffer, WLS20BL_SIZE, "Min-%d" , blink);
		}
		/* Set the Warning Light blink period */
		Set_DL(WARNING_LIGHT_20_BLINKING, (uint8_t *)&blink);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_20_STATE, &state);
		WLS20BL.invalidate();

	}

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))

		moveBackScreen();

#endif
}

void WL20BLINKView::moveNextScreen()
{

}

void WL20BLINKView::moveBackScreen()
{
	application().gotoWL20NXTScreenNoTransition();
}
void WL20BLINKView::moveNext()
{
}
void WL20BLINKView::movePrevious()
{
}


void WL20BLINKView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}


