#include <gui/wls01_screen/WLS01View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS01View::WLS01View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_01_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA1Buffer, WLONTA1_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA1Buffer, WLONTA1_SIZE, "OFF");

    WLONTA1.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_01_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS01TABuffer, WLS01TA_SIZE, "  %d" , pwmdc);
	WLS01TA.invalidate();

#endif
}


void WLS01View::trigger()
{

}

void WLS01View::setupScreen()
{
    WLS01ViewBase::setupScreen();
}

void WLS01View::tearDownScreen()
{
    WLS01ViewBase::tearDownScreen();
}


void WLS01View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
        	/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_01_STATE, &state);
        	Unicode::snprintf(WLONTA1Buffer, WLONTA1_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
        	/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_01_STATE, &state);
            Unicode::snprintf(WLONTA1Buffer, WLONTA1_SIZE, "OFF");
        }
        WLONTA1.invalidate();
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS01TABuffer, WLS01TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS01TABuffer, WLS01TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_01_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_01_STATE, &state);
		WLS01TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS01TABuffer, WLS01TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS01TABuffer, WLS01TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_01_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_01_STATE, &state);

		WLS01TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL01NXTScreenNoTransition();
	}

#endif
}

void WLS01View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
