#include <gui/wls04_screen/WLS04View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS04View::WLS04View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_04_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA4Buffer, WLONTA4_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA4Buffer, WLONTA4_SIZE, "OFF");

	WLONTA4.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_04_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS04TABuffer, WLS04TA_SIZE, "  %d" , pwmdc);
	WLS04TA.invalidate();

#endif
}
void WLS04View::trigger()
{

}

void WLS04View::setupScreen()
{
    WLS04ViewBase::setupScreen();
}

void WLS04View::tearDownScreen()
{
    WLS04ViewBase::tearDownScreen();
}

void WLS04View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_04_STATE, &state);
        	Unicode::snprintf(WLONTA4Buffer, WLONTA4_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_04_STATE, &state);
            Unicode::snprintf(WLONTA4Buffer, WLONTA4_SIZE, "OFF");
        }

        WLONTA4.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS04TABuffer, WLS04TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS04TABuffer, WLS04TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_04_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_04_STATE, &state);
		WLS04TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS04TABuffer, WLS04TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS04TABuffer, WLS04TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_04_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_04_STATE, &state);

		WLS04TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL04NXTScreenNoTransition();
	}

#endif
}


void WLS04View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
