#include <gui/wls07_screen/WLS07View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS07View::WLS07View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_07_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA7Buffer, WLONTA7_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA7Buffer, WLONTA7_SIZE, "OFF");

	WLONTA7.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_07_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS07TABuffer, WLS07TA_SIZE, "  %d" , pwmdc);
	WLS07TA.invalidate();

#endif
}

void WLS07View::trigger()
{

}

void WLS07View::setupScreen()
{
    WLS07ViewBase::setupScreen();
}

void WLS07View::tearDownScreen()
{
    WLS07ViewBase::tearDownScreen();
}

void WLS07View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_07_STATE, &state);
        	Unicode::snprintf(WLONTA7Buffer, WLONTA7_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_07_STATE, &state);
            Unicode::snprintf(WLONTA7Buffer, WLONTA7_SIZE, "OFF");
        }

        WLONTA7.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS07TABuffer, WLS07TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS07TABuffer, WLS07TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_07_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_07_STATE, &state);
		WLS07TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS07TABuffer, WLS07TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS07TABuffer, WLS07TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_07_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_07_STATE, &state);

		WLS07TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL07NXTScreenNoTransition();
	}

#endif
}


void WLS07View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
