#include <gui/wls09_screen/WLS09View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS09View::WLS09View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)
	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_09_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA9Buffer, WLONTA9_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA9Buffer, WLONTA9_SIZE, "OFF");

	WLONTA9.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_09_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS09TABuffer, WLS09TA_SIZE, "  %d" , pwmdc);
	WLS09TA.invalidate();

#endif
}

void WLS09View::trigger()
{

}

void WLS09View::setupScreen()
{
    WLS09ViewBase::setupScreen();
}

void WLS09View::tearDownScreen()
{
    WLS09ViewBase::tearDownScreen();
}

void WLS09View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_09_STATE, &state);
        	Unicode::snprintf(WLONTA9Buffer, WLONTA9_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_09_STATE, &state);
            Unicode::snprintf(WLONTA9Buffer, WLONTA9_SIZE, "OFF");
        }

        WLONTA9.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS09TABuffer, WLS09TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS09TABuffer, WLS09TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_09_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_09_STATE, &state);
		WLS09TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS09TABuffer, WLS09TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS09TABuffer, WLS09TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_09_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_09_STATE, &state);

		WLS09TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL09NXTScreenNoTransition();
	}
#endif
}

void WLS09View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

