#include <gui/wls12_screen/WLS12View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS12View::WLS12View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_12_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA12Buffer, WLONTA12_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA12Buffer, WLONTA12_SIZE, "OFF");

	WLONTA12.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_12_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS12TABuffer, WLS12TA_SIZE, "  %d" , pwmdc);
	WLS12TA.invalidate();

#endif
}

void WLS12View::trigger()
{

}


void WLS12View::setupScreen()
{
    WLS12ViewBase::setupScreen();
}

void WLS12View::tearDownScreen()
{
    WLS12ViewBase::tearDownScreen();
}

void WLS12View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_12_STATE, &state);
        	Unicode::snprintf(WLONTA12Buffer, WLONTA12_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_12_STATE, &state);
            Unicode::snprintf(WLONTA12Buffer, WLONTA12_SIZE, "OFF");
        }

        WLONTA12.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS12TABuffer, WLS12TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS12TABuffer, WLS12TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_12_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_12_STATE, &state);
		WLS12TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS12TABuffer, WLS12TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS12TABuffer, WLS12TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_12_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_12_STATE, &state);

		WLS12TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL12NXTScreenNoTransition();
	}

#endif
}


void WLS12View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

