#include <gui/wls13_screen/WLS13View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS13View::WLS13View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_13_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA13Buffer, WLONTA13_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA13Buffer, WLONTA13_SIZE, "OFF");

	WLONTA13.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_13_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS13TABuffer, WLS13TA_SIZE, "  %d" , pwmdc);
	WLS13TA.invalidate();

#endif
}

void WLS13View::trigger()
{

}


void WLS13View::setupScreen()
{
    WLS13ViewBase::setupScreen();
}

void WLS13View::tearDownScreen()
{
    WLS13ViewBase::tearDownScreen();
}

void WLS13View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_13_STATE, &state);
        	Unicode::snprintf(WLONTA13Buffer, WLONTA13_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_13_STATE, &state);
            Unicode::snprintf(WLONTA13Buffer, WLONTA13_SIZE, "OFF");
        }

        WLONTA13.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS13TABuffer, WLS13TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS13TABuffer, WLS13TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_13_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_13_STATE, &state);
		WLS13TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS13TABuffer, WLS13TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS13TABuffer, WLS13TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_13_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_13_STATE, &state);

		WLS13TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL13NXTScreenNoTransition();
	}

#endif
}


void WLS13View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

