#include <gui/wls14_screen/WLS14View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS14View::WLS14View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_14_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA14Buffer, WLONTA14_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA14Buffer, WLONTA14_SIZE, "OFF");

	WLONTA14.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_14_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS14TABuffer, WLS14TA_SIZE, "  %d" , pwmdc);
	WLS14TA.invalidate();

#endif
}
void WLS14View::trigger()
{

}

void WLS14View::setupScreen()
{
    WLS14ViewBase::setupScreen();
}

void WLS14View::tearDownScreen()
{
    WLS14ViewBase::tearDownScreen();
}

void WLS14View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_14_STATE, &state);
        	Unicode::snprintf(WLONTA14Buffer, WLONTA14_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_14_STATE, &state);
            Unicode::snprintf(WLONTA14Buffer, WLONTA14_SIZE, "OFF");
        }

        WLONTA14.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS14TABuffer, WLS14TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS14TABuffer, WLS14TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_14_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_14_STATE, &state);
		WLS14TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS14TABuffer, WLS14TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS14TABuffer, WLS14TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_14_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_14_STATE, &state);

		WLS14TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL14NXTScreenNoTransition();
	}
#endif
}


void WLS14View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

