#include <gui/wls15_screen/WLS15View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS15View::WLS15View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_15_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA15Buffer, WLONTA15_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA15Buffer, WLONTA15_SIZE, "OFF");

	WLONTA15.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_15_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS15TABuffer, WLS15TA_SIZE, "  %d" , pwmdc);
	WLS15TA.invalidate();

#endif
}

void WLS15View::trigger()
{

}

void WLS15View::setupScreen()
{
    WLS15ViewBase::setupScreen();
}

void WLS15View::tearDownScreen()
{
    WLS15ViewBase::tearDownScreen();
}

void WLS15View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_15_STATE, &state);
        	Unicode::snprintf(WLONTA15Buffer, WLONTA15_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_15_STATE, &state);
            Unicode::snprintf(WLONTA15Buffer, WLONTA15_SIZE, "OFF");
        }

        WLONTA15.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS15TABuffer, WLS15TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS15TABuffer, WLS15TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_15_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_15_STATE, &state);
		WLS15TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS15TABuffer, WLS15TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS15TABuffer, WLS15TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_15_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_15_STATE, &state);

		WLS15TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL15NXTScreenNoTransition();
	}

#endif
}


void WLS15View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}

