#include <gui/wls16_screen/WLS16View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS16View::WLS16View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_16_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA16Buffer, WLONTA16_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA16Buffer, WLONTA16_SIZE, "OFF");

	WLONTA16.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_16_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS16TABuffer, WLS16TA_SIZE, "  %d" , pwmdc);
	WLS16TA.invalidate();
#endif
}

void WLS16View::trigger()
{

}


void WLS16View::setupScreen()
{
    WLS16ViewBase::setupScreen();
}

void WLS16View::tearDownScreen()
{
    WLS16ViewBase::tearDownScreen();
}

void WLS16View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_16_STATE, &state);
        	Unicode::snprintf(WLONTA16Buffer, WLONTA16_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_16_STATE, &state);
            Unicode::snprintf(WLONTA16Buffer, WLONTA16_SIZE, "OFF");
        }

        WLONTA16.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS16TABuffer, WLS16TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS16TABuffer, WLS16TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_16_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_16_STATE, &state);
		WLS16TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS16TABuffer, WLS16TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS16TABuffer, WLS16TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_16_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_16_STATE, &state);

		WLS16TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL16NXTScreenNoTransition();
	}
#endif
}


void WLS16View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
