#include <gui/wls18_screen/WLS18View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS18View::WLS18View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_18_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA18Buffer, WLONTA18_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA18Buffer, WLONTA18_SIZE, "OFF");

	WLONTA18.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_18_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS18TABuffer, WLS18TA_SIZE, "  %d" , pwmdc);
	WLS18TA.invalidate();

#endif
}
void WLS18View::trigger()
{

}

void WLS18View::setupScreen()
{
    WLS18ViewBase::setupScreen();
}

void WLS18View::tearDownScreen()
{
    WLS18ViewBase::tearDownScreen();
}

void WLS18View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_18_STATE, &state);
        	Unicode::snprintf(WLONTA18Buffer, WLONTA18_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_18_STATE, &state);
            Unicode::snprintf(WLONTA18Buffer, WLONTA18_SIZE, "OFF");
        }

        WLONTA18.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS18TABuffer, WLS18TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS18TABuffer, WLS18TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_18_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_18_STATE, &state);
		WLS18TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS18TABuffer, WLS18TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS18TABuffer, WLS18TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_18_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_18_STATE, &state);

		WLS18TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL18NXTScreenNoTransition();
	}
#endif
}



void WLS18View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
