#include <gui/wls19_screen/WLS19View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS19View::WLS19View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)
	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_19_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA19Buffer, WLONTA19_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA19Buffer, WLONTA19_SIZE, "OFF");

	WLONTA19.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_19_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS19TABuffer, WLS19TA_SIZE, "  %d" , pwmdc);
	WLS19TA.invalidate();
#endif
}

void WLS19View::trigger()
{

}


void WLS19View::setupScreen()
{
    WLS19ViewBase::setupScreen();
}

void WLS19View::tearDownScreen()
{
    WLS19ViewBase::tearDownScreen();
}

void WLS19View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_19_STATE, &state);
        	Unicode::snprintf(WLONTA19Buffer, WLONTA19_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_19_STATE, &state);
            Unicode::snprintf(WLONTA19Buffer, WLONTA19_SIZE, "OFF");
        }

        WLONTA19.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS19TABuffer, WLS19TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS19TABuffer, WLS19TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_19_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_19_STATE, &state);
		WLS19TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS19TABuffer, WLS19TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS19TABuffer, WLS19TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_19_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_19_STATE, &state);

		WLS19TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL19NXTScreenNoTransition();
	}
#endif
}



void WLS19View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
