#include <gui/wls20_screen/WLS20View.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WLS20View::WLS20View()
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	pwmdc = 0;

	/* Get the Warning Light Status from the DB */
	Get_DL(WARNING_LIGHT_20_STATE, &state);
	if (WL_ON == state)
	{
		Unicode::snprintf(WLONTA20Buffer, WLONTA20_SIZE, "ON");
	}
	else
		Unicode::snprintf(WLONTA20Buffer, WLONTA20_SIZE, "OFF");

	WLONTA20.invalidate();
	/* Get the Warning Light Intensity from the DB */
	Get_DL(WARNING_LIGHT_20_PWM_DC, &pwmdc);
	Unicode::snprintf(WLS20TABuffer, WLS20TA_SIZE, "  %d" , pwmdc);
	WLS20TA.invalidate();
#endif
}
void WLS20View::trigger()
{

}

void WLS20View::setupScreen()
{
    WLS20ViewBase::setupScreen();
}

void WLS20View::tearDownScreen()
{
    WLS20ViewBase::tearDownScreen();
}

void WLS20View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_WARNING_LIGHT == PS_ENABLE)

	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
        if (WL_OFF == state)
        {
        	state = WL_ON;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_20_STATE, &state);
        	Unicode::snprintf(WLONTA20Buffer, WLONTA20_SIZE, "ON");
        }
        else
        {
        	state = WL_OFF;
    		/* Set the Warning Light Status */
        	Set_DL(WARNING_LIGHT_20_STATE, &state);
            Unicode::snprintf(WLONTA20Buffer, WLONTA20_SIZE, "OFF");
        }

        WLONTA20.invalidate();

	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		if ((pwmdc < 100) && (pwmdc >= 0))
		{
			pwmdc ++;
			Unicode::snprintf(WLS20TABuffer, WLS20TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS20TABuffer, WLS20TA_SIZE, "Max-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_20_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_20_STATE, &state);
		WLS20TA.invalidate();

	}
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{

		if ((pwmdc > 0) && (pwmdc <= 100))
		{
			pwmdc --;
			Unicode::snprintf(WLS20TABuffer, WLS20TA_SIZE, "  %d" , pwmdc);
		}
		else
		{
			Unicode::snprintf(WLS20TABuffer, WLS20TA_SIZE, "Min-%d" , pwmdc);
		}

		/* Set the Warning Light Intensity */
		Set_DL(WARNING_LIGHT_20_PWM_DC, &pwmdc);
		state = WL_ON;
		/* Set the Warning Light Status */
		Set_DL(WARNING_LIGHT_20_STATE, &state);

		WLS20TA.invalidate();
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoWL20NXTScreenNoTransition();
	}
#endif
}


void WLS20View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
