#include <gui/wreeprom1_screen/WREEPROM1View.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

WREEPROM1View::WREEPROM1View()
{
	key_position= 1;
	value = 0;
	place = 1;
	data = 0;
	/* Active the first button */
	PLCTXT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	PLCTXT.invalidate();
}

void WREEPROM1View::setupScreen()
{
    WREEPROM1ViewBase::setupScreen();
}

void WREEPROM1View::tearDownScreen()
{
    WREEPROM1ViewBase::tearDownScreen();
}

void WREEPROM1View::trigger()
{

}

void WREEPROM1View::keyUpdate(uint8_t val)
{
#if (SDK_SERVICE_EEPROM == PS_ENABLE)
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
	{
		key_position++;

		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			DATA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			DATA.invalidate();

			/* Select the Keypad button */
			PLCTXT.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			PLCTXT.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			PLCTXT.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			PLCTXT.invalidate();

			/* Select the Keypad button */
			DATA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			DATA.invalidate();
			break;
		default:
			break;
		}
	}

	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{
		case 1:
		if ((place < 65535) && (place >= 0))
		{
			place ++;
			Unicode::snprintf(PLCTXTBuffer, PLCTXT_SIZE, " %d" , place);
		}
		else
		{
			Unicode::snprintf(PLCTXTBuffer, PLCTXT_SIZE, "Max-%d" , place);
		}

		PLCTXT.invalidate();
		break;
		case 2:
		if ((data < 65535) && (data >= 0))
		{
			data ++;
			Unicode::snprintf(DATABuffer, DATA_SIZE, " %d" , data);
		}
		else
		{
			Unicode::snprintf(DATABuffer, DATA_SIZE, "Max-%d" , data);
		}

		DATA.invalidate();
		break;
	default:
		break;
	    }
	}

	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{
		case 1:
		if ((place > 0) && (place <= 65535))
		{
			place --;
			Unicode::snprintf(PLCTXTBuffer, PLCTXT_SIZE, " %d" , place);
		}
		else
		{
			Unicode::snprintf(PLCTXTBuffer, PLCTXT_SIZE, "Min-%d" , place);
		}

		PLCTXT.invalidate();
		break;
		case 2:
		if ((data > 0) && (data <= 65535))
		{
			data --;
			Unicode::snprintf(DATABuffer, DATA_SIZE, " %d" , data);
		}
		else
		{
			Unicode::snprintf(DATABuffer, DATA_SIZE, "Min-%d" , data);
		}

		DATA.invalidate();
		break;
		default:
			break;

	    }
	 }

	else
	if(KEY4_SHORT_PRESS == val)
	{
		Set_DL((START_EEPROM+place),(uint8_t *)&data);
	}

	else
	if(KEY4_LONG_PRESS == val)
	{
		application().gotoEEPROM1ScreenNoTransition();
	}
#endif
}

void WREEPROM1View::moveNextScreen()
{

}

void WREEPROM1View::moveBackScreen()
{

}
void WREEPROM1View::moveNext()
{
}
void WREEPROM1View::movePrevious()
{
}

void WREEPROM1View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
