#include <gui/wrflash_screen/WRFLASHView.hpp>
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
uint8_t w_idx;

WRFLASHView::WRFLASHView()
{
	key_position= 1;
	value = 0;
	wraddress = 0;
	w_idx = 0;
	/* Active the first button */
	WRADRS.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	WRADRS.invalidate();
}

void WRFLASHView::setupScreen()
{
    WRFLASHViewBase::setupScreen();
}

void WRFLASHView::tearDownScreen()
{
    WRFLASHViewBase::tearDownScreen();
}

void WRFLASHView::trigger()
{

}

void WRFLASHView::keyUpdate(uint8_t val)
{
	if(KEY1_SHORT_PRESS == val)
	{

		uint32_t position = key_position;

		switch (position)
		{
		case 1:
		if ((wraddress < 65535) && (wraddress >= 0))
		{
			wraddress ++;
			Unicode::snprintf(WRADRSBuffer, WRADRS_SIZE, "%.2d" , wraddress);
		}
		else
		{
			Unicode::snprintf(WRADRSBuffer, WRADRS_SIZE, "Max-%d" , wraddress);
		}

		WRADRS.invalidate();
		break;

		case 2:
		if ((w_idx < 20) && (w_idx >= 0))
		{
			w_data[w_idx++];
			Unicode::snprintf(WRDATABuffer, WRDATA_SIZE, "%.2d" , w_data[w_idx]);
		}
		else
		{
			Unicode::snprintf(WRDATABuffer, WRDATA_SIZE, "Max-%d" , w_data[w_idx]);
		}

		WRDATA.invalidate();
		break;
		default:
			break;
		}


	}
	else
	if(KEY1_LONG_PRESS == val)
	{
		{
			key_position++;

			if (3 == key_position)
				key_position = 1;

			switch(key_position)
			{
			case 1:
				/* DESelect the Keypad button */
				WRDATA.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				WRDATA.invalidate();

				/* Select the Keypad button */
				WRADRS.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				WRADRS.invalidate();
				break;
			case 2:
				/* DESelect the Keypad button */
				WRADRS.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
				WRADRS.invalidate();

				/* Select the Keypad button */
				WRDATA.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				WRDATA.invalidate();
				break;
			default:
				break;
			}
		}
	}
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
	{
		uint32_t position = key_position;

		switch (position)
		{
		case 1:
		if ((wraddress > 0) && (wraddress <= 65535))
		{
			wraddress --;
			Unicode::snprintf(WRADRSBuffer, WRADRS_SIZE, "%d" , wraddress);
		}
		else
		{
			Unicode::snprintf(WRADRSBuffer, WRADRS_SIZE, "Min-%d" , wraddress);
		}

		WRADRS.invalidate();
		break;
		case 2:
		if ((w_idx > 0) && (w_idx <= 65535))
		{
			w_data[w_idx--];
			Unicode::snprintf(WRDATABuffer, WRDATA_SIZE, "%d" , w_data[w_idx]);
		}
		else
		{
			Unicode::snprintf(WRDATABuffer, WRDATA_SIZE, "Min-%d" , w_data[w_idx]);
		}

		WRDATA.invalidate();
		break;
		default:
			break;

	    }

	}

	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
	{
#if (SDK_SERVICE_QSPI == PS_ENABLE)
		for (uint32_t index = 0; index <= (wraddress/256); index+=256 )
		{
			QSPI_Erase_Block(index);
		}

		QSPI_Write(&w_data[0], wraddress, sizeof(w_data));
#endif
	 }

	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
	{
		application().gotoFLASHScreenNoTransition();
	}
}

void WRFLASHView::moveNextScreen()
{

}

void WRFLASHView::moveBackScreen()
{

}
void WRFLASHView::moveNext()
{
}
void WRFLASHView::movePrevious()
{
}

void WRFLASHView::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
