#include <gui/wtdog_screen/WTDOGView.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include <texts/TextKeysAndLanguages.hpp>
#include <BitmapDatabase.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
#include "../../../../Core/Maximatecc/Inc/Data_Layer.h"

WTDOGView::WTDOGView()
{
#if (SDK_SERVICE_WATCHDOG == PS_ENABLE)
	key_position = 1;
	state = 1;
	tickCounter = 0;
	wd_triggered = 0;
	user_task_wd0 = USER_TASK_WD0;
	user_task_wd1 = USER_TASK_WD1;
	user_task_wd2 = USER_TASK_WD2;
	user_task_wd3 = USER_TASK_WD3;
	user_task_wd4 = USER_TASK_WD4;
	user_task_wd5 = USER_TASK_WD5;
	user_task_wd6 = USER_TASK_WD6;
	user_task_wd7 = USER_TASK_WD7;
	user_task_wd8 = USER_TASK_WD8;
	user_task_wd9 = USER_TASK_WD9;

	/* Active the first button */
	WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	WD0.invalidate();
#endif
}

void WTDOGView::setupScreen()
{
    WTDOGViewBase::setupScreen();
}

void WTDOGView::tearDownScreen()
{
    WTDOGViewBase::tearDownScreen();
}

void WTDOGView::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		moveEnter();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void WTDOGView::moveNext()
{
	/* WD0 is ENABLED*/
	if((user_task_wd0 == 1)&&(user_task_wd1 == 0)&&(user_task_wd2 == 0)&&(user_task_wd3 == 0)&&(user_task_wd4 == 0)&&
		(user_task_wd5 == 0)&&(user_task_wd6 == 0)&&(user_task_wd7 == 0)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0))
	{
		key_position++;
#if 0
		button2.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button2.invalidate();
		button3.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button3.invalidate();
		button4.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button4.invalidate();
		button5.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button5.invalidate();
		button6.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button6.invalidate();
		button7.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button7.invalidate();
		button8.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button8.invalidate();
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (2 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
		/* DESelect the Keypad button */
		WD9.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
		WD9.invalidate();

		/* Select the Keypad button */
		WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
		WD0.invalidate();

		break;
	default:
		break;
		}
	}

	/* WD1 is ENABLED*/

	if(((user_task_wd1 == 1)&&(user_task_wd0 == 1)&&(user_task_wd2 == 0)&&(user_task_wd3 == 0)&&(user_task_wd4 == 0)&&
			(user_task_wd5 == 0)&&(user_task_wd6 == 0)&&(user_task_wd7 == 0)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0)))
	{

		key_position++;
#if 0
		button3.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button3.invalidate();
		button4.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button4.invalidate();
		button5.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button5.invalidate();
		button6.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button6.invalidate();
		button7.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button7.invalidate();
		button8.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button8.invalidate();
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (3 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		default:
			break;
		}
	}

	/* WD2 is ENABLED*/
	if(((user_task_wd2 == 1)&&(user_task_wd0 == 1)&&(user_task_wd1 == 1)&&(user_task_wd3 == 0)&&(user_task_wd4 == 0)&&
			(user_task_wd5 == 0)&&(user_task_wd6 == 0)&&(user_task_wd7 == 0)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0)))
	{
		key_position++;
#if 0
		button4.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button4.invalidate();
		button5.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button5.invalidate();
		button6.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button6.invalidate();
		button7.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button7.invalidate();
		button8.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button8.invalidate();
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		default:
			break;
		}

	}

	/* WD3 is ENABLED*/
	if(((user_task_wd3 == 1)&&(user_task_wd2 == 1)&&(user_task_wd0 == 1)&&(user_task_wd1 == 1))&&(user_task_wd4 == 0)&&
		(user_task_wd5 == 0)&&(user_task_wd6 == 0)&&(user_task_wd7 == 0)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0))

	{
		key_position++;
#if 0
		button5.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button5.invalidate();
		button6.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button6.invalidate();
		button7.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button7.invalidate();
		button8.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button8.invalidate();
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (5 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD3.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD3.invalidate();
			break;
		default:
			break;
		}
	}

	/* WD4 is ENABLED*/
	if(((user_task_wd4 == 1)&&(user_task_wd3 == 1)&&(user_task_wd2 == 1)&&(user_task_wd0 == 1)&&(user_task_wd1 == 1))&&
		(user_task_wd5 == 0)&&(user_task_wd6 == 0)&&(user_task_wd7 == 0)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0))
	{
		key_position++;
#if 0
		button6.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button6.invalidate();
		button7.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button7.invalidate();
		button8.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button8.invalidate();
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif

		if (6 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD4.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD3.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD3.invalidate();

			/* Select the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD4.invalidate();
			break;
		default:
			break;
		}
	}

	/* WD5 is ENABLED*/
	if(((user_task_wd5 == 1)&&(user_task_wd4 == 1)&&(user_task_wd3 == 1)&&(user_task_wd2 == 1)&&(user_task_wd0 == 1)&&
		(user_task_wd1 == 1))&&(user_task_wd6 == 0)&&(user_task_wd7 == 0)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0))
	{
#if 0
		key_position++;
		button7.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button7.invalidate();
		button8.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button8.invalidate();
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (7 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD5.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD3.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD3.invalidate();

			/* Select the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD4.invalidate();
			break;
		case 6:
			/* DESelect the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD4.invalidate();

			/* Select the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD5.invalidate();
			break;
		default:
			break;
		}
	}

	/* WD6 is ENABLED*/
	if(((user_task_wd6 == 1)&&(user_task_wd5 == 1)&&(user_task_wd4 == 1)&&(user_task_wd3 == 1)&&(user_task_wd2 == 1)&&
		(user_task_wd0 == 1)&&(user_task_wd1 == 1))&&(user_task_wd7 == 0)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0))
	{
		key_position++;
#if 0
		button8.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button8.invalidate();
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (8 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD6.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD3.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD3.invalidate();

			/* Select the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD4.invalidate();
			break;
		case 6:
			/* DESelect the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD4.invalidate();

			/* Select the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD5.invalidate();
			break;
		case 7:
			/* DESelect the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD5.invalidate();

			/* Select the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD6.invalidate();
			break;
		default:
			break;

		}
		return;
	}

	/* WD7 is ENABLED*/
	if(((user_task_wd6 == 1)&&(user_task_wd5 == 1)&&(user_task_wd4 == 1)&&(user_task_wd3 == 1)&&(user_task_wd2 == 1)&&
		(user_task_wd0 == 1)&&(user_task_wd1 == 1))&&(user_task_wd7 == 1)&&(user_task_wd8 == 0)&&(user_task_wd9 == 0))
	{

		key_position++;
#if 0
		button9.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button9.invalidate();
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (9 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD7.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD7.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD3.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD3.invalidate();

			/* Select the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD4.invalidate();
			break;
		case 6:
			/* DESelect the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD4.invalidate();

			/* Select the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD5.invalidate();
			break;
		case 7:
			/* DESelect the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD5.invalidate();

			/* Select the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD6.invalidate();
			break;
		case 8:
			/* DESelect the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD6.invalidate();

			/* Select the Keypad button */
			WD7.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD7.invalidate();
			break;
		default:
			break;
		}
	}

	/* WD8 is ENABLED*/
	if(((user_task_wd6 == 1)&&(user_task_wd5 == 1)&&(user_task_wd4 == 1)&&(user_task_wd3 == 1)&&(user_task_wd2 == 1)&&
		(user_task_wd0 == 1)&&(user_task_wd1 == 1))&&(user_task_wd7 == 1)&&(user_task_wd8 == 1)&&(user_task_wd9 == 0))
	{

		key_position++;
#if 0
		button10.setBitmaps(touchgfx::Bitmap(BITMAP_DARK_BUTTONS_ROUND_EDGE_ICON_BUTTON_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_ICON_BUTTON_PRESSED_ID));
		button10.invalidate();
#endif
		if (10 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD8.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD8.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD3.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD3.invalidate();

			/* Select the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD4.invalidate();
			break;
		case 6:
			/* DESelect the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD4.invalidate();

			/* Select the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD5.invalidate();
			break;
		case 7:
			/* DESelect the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD5.invalidate();

			/* Select the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD6.invalidate();
			break;
		case 8:
			/* DESelect the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD6.invalidate();

			/* Select the Keypad button */
			WD7.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD7.invalidate();
			break;
		case 9:
			/* DESelect the Keypad button */
			WD7.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD7.invalidate();

			/* Select the Keypad button */
			WD8.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD8.invalidate();
			break;
		default:
			break;
		}
	}

	/* WD9 is ENABLED*/
	if(((user_task_wd6 == 1)&&(user_task_wd5 == 1)&&(user_task_wd4 == 1)&&(user_task_wd3 == 1)&&(user_task_wd2 == 1)&&
		(user_task_wd0 == 1)&&(user_task_wd1 == 1))&&(user_task_wd7 == 1)&&(user_task_wd8 == 1)&&(user_task_wd9 == 1))
	{

		key_position++;

		if (11 == key_position)
			key_position = 1;

		switch(key_position)
		{
		case 1:
			/* DESelect the Keypad button */
			WD9.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD9.invalidate();

			/* Select the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD0.invalidate();
			break;
		case 2:
			/* DESelect the Keypad button */
			WD0.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD0.invalidate();

			/* Select the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD1.invalidate();
			break;
		case 3:
			/* DESelect the Keypad button */
			WD1.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD1.invalidate();

			/* Select the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD2.invalidate();
			break;
		case 4:
			/* DESelect the Keypad button */
			WD2.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD2.invalidate();

			/* Select the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD3.invalidate();
			break;
		case 5:
			/* DESelect the Keypad button */
			WD3.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD3.invalidate();

			/* Select the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD4.invalidate();
			break;
		case 6:
			/* DESelect the Keypad button */
			WD4.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD4.invalidate();

			/* Select the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD5.invalidate();
			break;
		case 7:
			/* DESelect the Keypad button */
			WD5.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD5.invalidate();

			/* Select the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD6.invalidate();
			break;
		case 8:
			/* DESelect the Keypad button */
			WD6.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD6.invalidate();

			/* Select the Keypad button */
			WD7.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD7.invalidate();
			break;
		case 9:
			/* DESelect the Keypad button */
			WD7.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD7.invalidate();

			/* Select the Keypad button */
			WD8.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD8.invalidate();
			break;
		case 10:
			/* DESelect the Keypad button */
			WD8.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
			WD8.invalidate();

			/* Select the Keypad button */
			WD9.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
			WD9.invalidate();
			break;
		default:
			break;
		}
	}
return;
}
	void WTDOGView::movePrevious()
	{


	}

	void WTDOGView::moveEnter()
	{
		if (0 != wd_triggered)
			return;

		switch(key_position)
		{
		case 1:
			if(user_task_wd0 == 1)
			{
			user_task_wd0 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD0 Stop ping wait for reboot" );
			wd_triggered = 1;
			}
			WDTXT.invalidate();
			break;

		case 2:
			if(user_task_wd1 == 1)
			{
			user_task_wd1 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD1 Stop ping wait for reboot" );
			wd_triggered = 2;
			}
			WDTXT.invalidate();
			break;

		case 3:
			if(user_task_wd2 == 1)
			{
			user_task_wd2 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD2 Stop ping wait for reboot" );
			wd_triggered = 3;
			}
			WDTXT.invalidate();
			break;

		case 4:
			if(user_task_wd3 == 1)
			{
			user_task_wd3 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD3 Stop ping wait for reboot" );
			wd_triggered = 4;
			}
			WDTXT.invalidate();
			break;

		case 5:
			if(user_task_wd4 == 1)
			{
			user_task_wd4 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD4 Stop ping wait for reboot" );
			wd_triggered = 5;
			}
			WDTXT.invalidate();
			break;

		case 6:
			if(user_task_wd5 == 1)
			{
			user_task_wd5 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD5 Stop ping wait for reboot" );
			wd_triggered = 6;
			}
			WDTXT.invalidate();
			break;

		case 7:
			if(user_task_wd6 == 1)
			{
			user_task_wd6 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD6 Stop ping wait for reboot" );
			wd_triggered = 7;
			}
			WDTXT.invalidate();
			break;

		case 8:
			if(user_task_wd7 == 1)
			{
			user_task_wd7 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD7 Stop ping wait for reboot" );
			wd_triggered = 8;
			}
			WDTXT.invalidate();
			break;

		case 9:
			if(user_task_wd8 == 1)
			{
			user_task_wd8 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD8 Stop ping wait for reboot" );
			wd_triggered = 9;
			}
			WDTXT.invalidate();
			break;

		case 10:
			if(user_task_wd9 == 1)
			{
			user_task_wd9 = 0;
			Unicode::snprintf(WDTXTBuffer, WDTXT_SIZE, "WD9 Stop ping wait for reboot" );
			wd_triggered = 10;
			}
			WDTXT.invalidate();
			break;
		default:
			break;
		}
	}
	void WTDOGView::moveBackScreen()
	{
		application().gotoIngtestScreenNoTransition();

	}

	void WTDOGView::trigger()
	{
#if (SDK_SERVICE_WATCHDOG == PS_ENABLE)
		tickCounter++;
		if(tickCounter >= 100)
		{
			tickCounter = 0;

			if(user_task_wd0 == 1)
			{
#if(USER_TASK_WD0 == PS_ENABLE)
				state = 1;
				Set_DL(WD0_PING , &state);
#endif
			}

			if(user_task_wd1 == 1)
			{
#if(USER_TASK_WD1 == PS_ENABLE)
				state = 2;
				Set_DL(WD1_PING , &state);
#endif
			}

			if(user_task_wd2 == 1)
			{
#if(USER_TASK_WD2 == PS_ENABLE)
				state = 3;
				Set_DL(WD2_PING , &state);
#endif
			}

			if(user_task_wd3 == 1)
			{
#if(USER_TASK_WD3 == PS_ENABLE)
				state = 4;
				Set_DL(WD3_PING , &state);
#endif
			}

			if(user_task_wd4 == 1)
			{
#if(USER_TASK_WD4 == PS_ENABLE)
				state = 5;
				Set_DL(WD4_PING , &state);
#endif
			}

			if(user_task_wd5 == 1)
			{
#if(USER_TASK_WD5 == PS_ENABLE)
				state = 6;
				Set_DL(WD5_PING , &state);
#endif
			}

			if(user_task_wd6 == 1)
			{
#if(USER_TASK_WD6 == PS_ENABLE)
				state = 7;
				Set_DL(WD6_PING , &state);
#endif
			}

			if(user_task_wd7 == 1)
			{
#if(USER_TASK_WD7 == PS_ENABLE)
				state = 8;
				Set_DL(WD7_PING , &state);
#endif
			}

			if(user_task_wd8 == 1)
			{
#if(USER_TASK_WD8 == PS_ENABLE)
				state = 9;
				Set_DL(WD8_PING , &state);
#endif
			}

			if(user_task_wd9 == 1)
			{
#if(USER_TASK_WD9 == PS_ENABLE)
				state = 10;
				Set_DL(WD9_PING , &state);
#endif
			}
		}
#endif
	}




	void WTDOGView::watchdogstatus(uint8_t *val)
	{
		*val = wd_triggered;
	}

